library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity flag is 

    Port ( 
		 FLA : in std_logic_vector(4 downto 1);
		 FLB : in std_logic_vector(4 downto 1);
		 FLC : in std_logic_vector(4 downto 1);
		 FLD : in std_logic_vector(4 downto 1);
		 FLE : in std_logic_vector(4 downto 1);
		 FLF : in std_logic_vector(4 downto 1);
		 FLG : in std_logic_vector(4 downto 1);
		 FLH : in std_logic_vector(4 downto 1);
		 FLI : in std_logic_vector(4 downto 1);
		 FLJ : in std_logic_vector(4 downto 1);
		 FLK : in std_logic_vector(4 downto 1);
		 FLL : in std_logic_vector(4 downto 1);
		 FLM : in std_logic_vector(4 downto 1);
		 FLN : in std_logic_vector(4 downto 1);
		 FLP : in std_logic_vector(4 downto 1);
		 FLQ : in std_logic_vector(4 downto 1);
		 FLR : in std_logic_vector(4 downto 1);
		 FLS : in std_logic_vector(4 downto 1);

		 FLAGA : in std_logic;
		 FLAGB : in std_logic;
		 FLAGC : in std_logic;
		 FLAGD : in std_logic;
		 FLAGE : in std_logic;
		 FLAGF : in std_logic;
		 FLAGG : in std_logic;
		 FLAGH : in std_logic;
	      FLAGI : in std_logic;
		 FLAGJ : in std_logic;
		 FLAGK : in std_logic;
		 FLAGL : in std_logic;
		 FLAGM : in std_logic;
		 FLAGN : in std_logic;
		 FLAGP : in std_logic;
		 FLAGQ : in std_logic;
		 FLAGR : in std_logic;
	      FLAGS : in std_logic;

 		 OUTA : out std_logic_vector(5 downto 1);
		 OUTB : out std_logic_vector(5 downto 1);
		 OUTC : out std_logic_vector(5 downto 1);
		 OUTD : out std_logic_vector(5 downto 1);
		 OUTE : out std_logic_vector(5 downto 1);
		 OUTF : out std_logic_vector(5 downto 1);
		 OUTG : out std_logic_vector(5 downto 1);
		 OUTH : out std_logic_vector(5 downto 1);
		 OUTI : out std_logic_vector(5 downto 1);
		 OUTJ : out std_logic_vector(5 downto 1);
		 OUTK : out std_logic_vector(5 downto 1);
		 OUTL : out std_logic_vector(5 downto 1);
		 OUTM : out std_logic_vector(5 downto 1);
		 OUTN : out std_logic_vector(5 downto 1);
		 OUTP : out std_logic_vector(5 downto 1);
		 OUTQ : out std_logic_vector(5 downto 1);
		 OUTR : out std_logic_vector(5 downto 1);
		 OUTS : out std_logic_vector(5 downto 1));

end flag;

architecture ARC  of flag is

BEGIN

OUTA(1) <= FLA(1) AND FLAGA;
OUTA(2) <= FLA(2) AND FLAGA;
OUTA(3) <= FLA(3) AND FLAGA;
OUTA(4) <= FLA(4) AND FLAGA;
OUTA(5) <= FLAGA;

OUTB(1) <= FLB(1) AND FLAGB;
OUTB(2) <= FLB(2) AND FLAGB;
OUTB(3) <= FLB(3) AND FLAGB;
OUTB(4) <= FLB(4) AND FLAGB;
OUTB(5) <= FLAGB;

OUTC(1) <= FLC(1) AND FLAGC;
OUTC(2) <= FLC(2) AND FLAGC;
OUTC(3) <= FLC(3) AND FLAGC;
OUTC(4) <= FLC(4) AND FLAGC;
OUTC(5) <= FLAGC;

OUTD(1) <= FLD(1) AND FLAGD;
OUTD(2) <= FLD(2) AND FLAGD;
OUTD(3) <= FLD(3) AND FLAGD;
OUTD(4) <= FLD(4) AND FLAGD;
OUTD(5) <= FLAGD;

OUTE(1) <= FLE(1) AND FLAGE;
OUTE(2) <= FLE(2) AND FLAGE;
OUTE(3) <= FLE(3) AND FLAGE;
OUTE(4) <= FLE(4) AND FLAGE;
OUTE(5) <= FLAGE;

OUTF(1) <= FLF(1) AND FLAGF;
OUTF(2) <= FLF(2) AND FLAGF;
OUTF(3) <= FLF(3) AND FLAGF;
OUTF(4) <= FLF(4) AND FLAGF;
OUTF(5) <= FLAGF;

OUTG(1) <= FLG(1) AND FLAGG;
OUTG(2) <= FLG(2) AND FLAGG;
OUTG(3) <= FLG(3) AND FLAGG;
OUTG(4) <= FLG(4) AND FLAGG;
OUTG(5) <= FLAGG;

OUTH(1) <= FLH(1) AND FLAGH;
OUTH(2) <= FLH(2) AND FLAGH;
OUTH(3) <= FLH(3) AND FLAGH;
OUTH(4) <= FLH(4) AND FLAGH;
OUTH(5) <= FLAGH;

OUTI(1) <= FLI(1) AND FLAGI;
OUTI(2) <= FLI(2) AND FLAGI;
OUTI(3) <= FLI(3) AND FLAGI;
OUTI(4) <= FLI(4) AND FLAGI;
OUTI(5) <= FLAGI;

OUTJ(1) <= FLJ(1) AND FLAGJ;
OUTJ(2) <= FLJ(2) AND FLAGJ;
OUTJ(3) <= FLJ(3) AND FLAGJ;
OUTJ(4) <= FLJ(4) AND FLAGJ;
OUTJ(5) <= FLAGJ;

OUTK(1) <= FLK(1) AND FLAGK;
OUTK(2) <= FLK(2) AND FLAGK;
OUTK(3) <= FLK(3) AND FLAGK;
OUTK(4) <= FLK(4) AND FLAGK;
OUTK(5) <= FLAGK;

OUTL(1) <= FLL(1) AND FLAGL;
OUTL(2) <= FLL(2) AND FLAGL;
OUTL(3) <= FLL(3) AND FLAGL;
OUTL(4) <= FLL(4) AND FLAGL;
OUTL(5) <= FLAGL;

OUTM(1) <= FLM(1) AND FLAGM;
OUTM(2) <= FLM(2) AND FLAGM;
OUTM(3) <= FLM(3) AND FLAGM;
OUTM(4) <= FLM(4) AND FLAGM;
OUTM(5) <= FLAGM;

OUTN(1) <= FLN(1) AND FLAGN;
OUTN(2) <= FLN(2) AND FLAGN;
OUTN(3) <= FLN(3) AND FLAGN;
OUTN(4) <= FLN(4) AND FLAGN;
OUTN(5) <= FLAGN;

OUTP(1) <= FLP(1) AND FLAGP;
OUTP(2) <= FLP(2) AND FLAGP;
OUTP(3) <= FLP(3) AND FLAGP;
OUTP(4) <= FLP(4) AND FLAGP;
OUTP(5) <= FLAGP;

OUTQ(1) <= FLQ(1) AND FLAGQ;
OUTQ(2) <= FLQ(2) AND FLAGQ;
OUTQ(3) <= FLQ(3) AND FLAGQ;
OUTQ(4) <= FLQ(4) AND FLAGQ;
OUTQ(5) <= FLAGQ;

OUTR(1) <= FLR(1) AND FLAGR;
OUTR(2) <= FLR(2) AND FLAGR;
OUTR(3) <= FLR(3) AND FLAGR;
OUTR(4) <= FLR(4) AND FLAGR;
OUTR(5) <= FLAGR;

OUTS(1) <= FLS(1) AND FLAGS;
OUTS(2) <= FLS(2) AND FLAGS;
OUTS(3) <= FLS(3) AND FLAGS;
OUTS(4) <= FLS(4) AND FLAGS;
OUTS(5) <= FLAGS;

end ARC;
