library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity merger is

    Port ( 
		 FA : in std_logic_vector(31 downto 0);
		 FB : in std_logic_vector(31 downto 0);
		 FC : in std_logic_vector(31 downto 0);
		 FD : in std_logic_vector(31 downto 0);
		 FE : in std_logic_vector(31 downto 0);
		 FF : in std_logic_vector(31 downto 0);
		 FG : in std_logic_vector(31 downto 0);
		 FH : in std_logic_vector(31 downto 0);
		 FI : in std_logic_vector(31 downto 0);

		 SA : in std_logic_vector(31 downto 0);
		 SB : in std_logic_vector(31 downto 0);
		 SC : in std_logic_vector(31 downto 0);
		 SD : in std_logic_vector(31 downto 0);
		 SE : in std_logic_vector(31 downto 0);
		 SF : in std_logic_vector(31 downto 0);
		 SG : in std_logic_vector(31 downto 0);
		 SH : in std_logic_vector(31 downto 0);
		 SI : in std_logic_vector(31 downto 0);

       A : in std_logic_vector(18 downto 1);
		 B : in std_logic_vector(18 downto 1);
       C : in std_logic_vector(18 downto 1);

       SWITCH : in std_logic;

		 CONA : in std_logic_vector(18 downto 1);
		 CONB : in std_logic_vector(18 downto 1);
		 CONC : in std_logic_vector(18 downto 1);

       OUTA : out std_logic_vector(31 downto 0);
       OUTB : out std_logic_vector(31 downto 0);
       OUTC : out std_logic_vector(31 downto 0));

end merger;

architecture ARC  of merger is

BEGIN

OUTA(0) <= (((FA(0)  AND A(1))  OR 
           (FA(16) AND A(2))  OR 
		 (FB(0)  AND A(3))  OR 
		 (FB(16) AND A(4))  OR
		 (FC(0)  AND A(5))  OR 
		 (FC(16) AND A(6))  OR 
		 (FD(0)  AND A(7))  OR 
		 (FD(16) AND A(8))  OR
           (FE(0)  AND A(9))  OR 
		 (FE(16) AND A(10)) OR 
		 (FF(0)  AND A(11)) OR 
		 (FF(16) AND A(12)) OR 
           (FG(0)  AND A(13)) OR 
		 (FG(16) AND A(14)) OR
		 (FH(0)  AND A(15)) OR 
		 (FH(16) AND A(16)) OR
		 (FI(0)  AND A(17)) OR
		 (FI(16) AND A(18))) AND NOT SWITCH) OR
		 (((FA(0) AND CONA(1)) OR
		 (FA(16) AND CONA(2)) OR
		 (FB(0) AND CONA(3)) OR
		 (FB(16) AND CONA(4)) OR
		 (FC(0) AND CONA(5)) OR
		 (FC(16) AND CONA(6)) OR
		 (FD(0) AND CONA(7)) OR
		 (FD(16) AND CONA(8)) OR
		 (FE(0) AND CONA(9)) OR
		 (FE(16) AND CONA(10)) OR
		 (FF(0) AND CONA(11)) OR
		 (FF(16) AND CONA(12)) OR
		 (FG(0) AND CONA(13)) OR
		 (FG(16) AND CONA(14)) OR
		 (FH(0) AND CONA(15)) OR
		 (FH(16) AND CONA(16)) OR
		 (FI(0) AND CONA(17)) OR
		 (FI(16) AND CONA(18))) AND SWITCH); 

OUTA(1) <= (((FA(1)  AND A(1))  OR 
           (FA(17) AND A(2))  OR 
		 (FB(1)  AND A(3))  OR 
		 (FB(17) AND A(4))  OR
		 (FC(1)  AND A(5))  OR 
		 (FC(17) AND A(6))  OR 
		 (FD(1)  AND A(7))  OR 
		 (FD(17) AND A(8))  OR
           (FE(1)  AND A(9))  OR 
		 (FE(17) AND A(10)) OR 
		 (FF(1)  AND A(11)) OR 
		 (FF(17) AND A(12)) OR 
           (FG(1)  AND A(13)) OR 
		 (FG(17) AND A(14)) OR
		 (FH(1)  AND A(15)) OR 
		 (FH(17) AND A(16)) OR
		 (FI(1)  AND A(17)) OR
		 (FI(17) AND A(18))) AND NOT SWITCH) OR
		 (((FA(1) AND CONA(1)) OR
		 (FA(17) AND CONA(2)) OR
		 (FB(1) AND CONA(3)) OR
		 (FB(17) AND CONA(4)) OR
		 (FC(1) AND CONA(5)) OR
		 (FC(17) AND CONA(6)) OR
		 (FD(1) AND CONA(7)) OR
		 (FD(17) AND CONA(8)) OR
		 (FE(1) AND CONA(9)) OR
		 (FE(17) AND CONA(10)) OR
		 (FF(1) AND CONA(11)) OR
		 (FF(17) AND CONA(12)) OR
		 (FG(1) AND CONA(13)) OR
		 (FG(17) AND CONA(14)) OR
		 (FH(1) AND CONA(15)) OR
		 (FH(17) AND CONA(16)) OR
		 (FI(1) AND CONA(17)) OR
		 (FI(17) AND CONA(18))) AND SWITCH); 

OUTA(2) <= (((FA(2)  AND A(1))  OR 
           (FA(18) AND A(2))  OR 
		 (FB(2)  AND A(3))  OR 
		 (FB(18) AND A(4))  OR
		 (FC(2)  AND A(5))  OR 
		 (FC(18) AND A(6))  OR 
		 (FD(2)  AND A(7))  OR 
		 (FD(18) AND A(8))  OR
           (FE(2)  AND A(9))  OR 
		 (FE(18) AND A(10)) OR 
		 (FF(2)  AND A(11)) OR 
		 (FF(18) AND A(12)) OR 
           (FG(2)  AND A(13)) OR 
		 (FG(18) AND A(14)) OR
		 (FH(2)  AND A(15)) OR 
		 (FH(18) AND A(16)) OR
		 (FI(2)  AND A(17)) OR
		 (FI(18) AND A(18))) AND NOT SWITCH) OR
		 (((FA(2) AND CONA(1)) OR
		 (FA(18) AND CONA(2)) OR
		 (FB(2) AND CONA(3)) OR
		 (FB(18) AND CONA(4)) OR
		 (FC(2) AND CONA(5)) OR
		 (FC(18) AND CONA(6)) OR
		 (FD(2) AND CONA(7)) OR
		 (FD(18) AND CONA(8)) OR
		 (FE(2) AND CONA(9)) OR
		 (FE(18) AND CONA(10)) OR
		 (FF(2) AND CONA(11)) OR
		 (FF(18) AND CONA(12)) OR
		 (FG(2) AND CONA(13)) OR
		 (FG(18) AND CONA(14)) OR
		 (FH(2) AND CONA(15)) OR
		 (FH(18) AND CONA(16)) OR
		 (FI(2) AND CONA(17)) OR
		 (FI(18) AND CONA(18))) AND SWITCH); 

OUTA(3) <= (((FA(3)  AND A(1))  OR 
           (FA(19) AND A(2))  OR 
		 (FB(3)  AND A(3))  OR 
		 (FB(19) AND A(4))  OR
		 (FC(3)  AND A(5))  OR 
		 (FC(19) AND A(6))  OR 
		 (FD(3)  AND A(7))  OR 
		 (FD(19) AND A(8))  OR
           (FE(3)  AND A(9))  OR 
		 (FE(19) AND A(10)) OR 
		 (FF(3)  AND A(11)) OR 
		 (FF(19) AND A(12)) OR 
           (FG(3)  AND A(13)) OR 
		 (FG(19) AND A(14)) OR
		 (FH(3)  AND A(15)) OR 
		 (FH(19) AND A(16)) OR
		 (FI(3)  AND A(17)) OR
		 (FI(19) AND A(18))) AND NOT SWITCH) OR
		 (((FA(3) AND CONA(1)) OR
		 (FA(19) AND CONA(2)) OR
		 (FB(3) AND CONA(3)) OR
		 (FB(19) AND CONA(4)) OR
		 (FC(3) AND CONA(5)) OR
		 (FC(19) AND CONA(6)) OR
		 (FD(3) AND CONA(7)) OR
		 (FD(19) AND CONA(8)) OR
		 (FE(3) AND CONA(9)) OR
		 (FE(19) AND CONA(10)) OR
		 (FF(3) AND CONA(11)) OR
		 (FF(19) AND CONA(12)) OR
		 (FG(3) AND CONA(13)) OR
		 (FG(19) AND CONA(14)) OR
		 (FH(3) AND CONA(15)) OR
		 (FH(19) AND CONA(16)) OR
		 (FI(3) AND CONA(17)) OR
		 (FI(19) AND CONA(18))) AND SWITCH); 

OUTA(4) <= (((FA(4)  AND A(1))  OR 
           (FA(20) AND A(2))  OR 
		 (FB(4)  AND A(3))  OR 
		 (FB(20) AND A(4))  OR
		 (FC(4)  AND A(5))  OR 
		 (FC(20) AND A(6))  OR 
		 (FD(4)  AND A(7))  OR 
		 (FD(20) AND A(8))  OR
           (FE(4)  AND A(9))  OR 
		 (FE(20) AND A(10)) OR 
		 (FF(4)  AND A(11)) OR 
		 (FF(20) AND A(12)) OR 
           (FG(4)  AND A(13)) OR 
		 (FG(20) AND A(14)) OR
		 (FH(4)  AND A(15)) OR 
		 (FH(20) AND A(16)) OR
		 (FI(4)  AND A(17)) OR
		 (FI(20) AND A(18))) AND NOT SWITCH) OR
		 (((FA(4) AND CONA(1)) OR
		 (FA(20) AND CONA(2)) OR
		 (FB(4) AND CONA(3)) OR
		 (FB(20) AND CONA(4)) OR
		 (FC(4) AND CONA(5)) OR
		 (FC(20) AND CONA(6)) OR
		 (FD(4) AND CONA(7)) OR
		 (FD(20) AND CONA(8)) OR
		 (FE(4) AND CONA(9)) OR
		 (FE(20) AND CONA(10)) OR
		 (FF(4) AND CONA(11)) OR
		 (FF(20) AND CONA(12)) OR
		 (FG(4) AND CONA(13)) OR
		 (FG(20) AND CONA(14)) OR
		 (FH(4) AND CONA(15)) OR
		 (FH(20) AND CONA(16)) OR
		 (FI(4) AND CONA(17)) OR
		 (FI(20) AND CONA(18))) AND SWITCH); 

OUTA(5) <= (((FA(5)  AND A(1))  OR 
           (FA(21) AND A(2))  OR 
		 (FB(5)  AND A(3))  OR 
		 (FB(21) AND A(4))  OR
		 (FC(5)  AND A(5))  OR 
		 (FC(21) AND A(6))  OR 
		 (FD(5)  AND A(7))  OR 
		 (FD(21) AND A(8))  OR
           (FE(5)  AND A(9))  OR 
		 (FE(21) AND A(10)) OR 
		 (FF(5)  AND A(11)) OR 
		 (FF(21) AND A(12)) OR 
           (FG(5)  AND A(13)) OR 
		 (FG(21) AND A(14)) OR
		 (FH(5)  AND A(15)) OR 
		 (FH(21) AND A(16)) OR
		 (FI(5)  AND A(17)) OR
		 (FI(21) AND A(18))) AND NOT SWITCH) OR
		 (((FA(5) AND CONA(1)) OR
		 (FA(21) AND CONA(2)) OR
		 (FB(5) AND CONA(3)) OR
		 (FB(21) AND CONA(4)) OR
		 (FC(5) AND CONA(5)) OR
		 (FC(21) AND CONA(6)) OR
		 (FD(5) AND CONA(7)) OR
		 (FD(21) AND CONA(8)) OR
		 (FE(5) AND CONA(9)) OR
		 (FE(21) AND CONA(10)) OR
		 (FF(5) AND CONA(11)) OR
		 (FF(21) AND CONA(12)) OR
		 (FG(5) AND CONA(13)) OR
		 (FG(21) AND CONA(14)) OR
		 (FH(5) AND CONA(15)) OR
		 (FH(21) AND CONA(16)) OR
		 (FI(5) AND CONA(17)) OR
		 (FI(21) AND CONA(18))) AND SWITCH); 

OUTA(6) <= (((FA(6)  AND A(1))  OR 
           (FA(22) AND A(2))  OR 
		 (FB(6)  AND A(3))  OR 
		 (FB(22) AND A(4))  OR
		 (FC(6)  AND A(5))  OR 
		 (FC(22) AND A(6))  OR 
		 (FD(6)  AND A(7))  OR 
		 (FD(22) AND A(8))  OR
           (FE(6)  AND A(9))  OR 
		 (FE(22) AND A(10)) OR 
		 (FF(6)  AND A(11)) OR 
		 (FF(22) AND A(12)) OR 
           (FG(6)  AND A(13)) OR 
		 (FG(22) AND A(14)) OR
		 (FH(6)  AND A(15)) OR 
		 (FH(22) AND A(16)) OR
		 (FI(6)  AND A(17)) OR
		 (FI(22) AND A(18))) AND NOT SWITCH) OR
		 (((FA(6) AND CONA(1)) OR
		 (FA(22) AND CONA(2)) OR
		 (FB(6) AND CONA(3)) OR
		 (FB(22) AND CONA(4)) OR
		 (FC(6) AND CONA(5)) OR
		 (FC(22) AND CONA(6)) OR
		 (FD(6) AND CONA(7)) OR
		 (FD(22) AND CONA(8)) OR
		 (FE(6) AND CONA(9)) OR
		 (FE(22) AND CONA(10)) OR
		 (FF(6) AND CONA(11)) OR
		 (FF(22) AND CONA(12)) OR
		 (FG(6) AND CONA(13)) OR
		 (FG(22) AND CONA(14)) OR
		 (FH(6) AND CONA(15)) OR
		 (FH(22) AND CONA(16)) OR
		 (FI(6) AND CONA(17)) OR
		 (FI(22) AND CONA(18))) AND SWITCH); 

OUTA(7) <= (((FA(7)  AND A(1))  OR 
           (FA(23) AND A(2))  OR 
		 (FB(7)  AND A(3))  OR 
		 (FB(23) AND A(4))  OR
		 (FC(7)  AND A(5))  OR 
		 (FC(23) AND A(6))  OR 
		 (FD(7)  AND A(7))  OR 
		 (FD(23) AND A(8))  OR
           (FE(7)  AND A(9))  OR 
		 (FE(23) AND A(10)) OR 
		 (FF(7)  AND A(11)) OR 
		 (FF(23) AND A(12)) OR 
           (FG(7)  AND A(13)) OR 
		 (FG(23) AND A(14)) OR
		 (FH(7)  AND A(15)) OR 
		 (FH(23) AND A(16)) OR
		 (FI(7)  AND A(17)) OR
		 (FI(23) AND A(18))) AND NOT SWITCH) OR
		 (((FA(7) AND CONA(1)) OR
		 (FA(23) AND CONA(2)) OR
		 (FB(7) AND CONA(3)) OR
		 (FB(23) AND CONA(4)) OR
		 (FC(7) AND CONA(5)) OR
		 (FC(23) AND CONA(6)) OR
		 (FD(7) AND CONA(7)) OR
		 (FD(23) AND CONA(8)) OR
		 (FE(7) AND CONA(9)) OR
		 (FE(23) AND CONA(10)) OR
		 (FF(7) AND CONA(11)) OR
		 (FF(23) AND CONA(12)) OR
		 (FG(7) AND CONA(13)) OR
		 (FG(23) AND CONA(14)) OR
		 (FH(7) AND CONA(15)) OR
		 (FH(23) AND CONA(16)) OR
		 (FI(7) AND CONA(17)) OR
		 (FI(23) AND CONA(18))) AND SWITCH); 

OUTA(8) <= (((FA(8)  AND A(1))  OR 
           (FA(24) AND A(2))  OR 
		 (FB(8)  AND A(3))  OR 
		 (FB(24) AND A(4))  OR
		 (FC(8)  AND A(5))  OR 
		 (FC(24) AND A(6))  OR 
		 (FD(8)  AND A(7))  OR 
		 (FD(24) AND A(8))  OR
           (FE(8)  AND A(9))  OR 
		 (FE(24) AND A(10)) OR 
		 (FF(8)  AND A(11)) OR 
		 (FF(24) AND A(12)) OR 
           (FG(8)  AND A(13)) OR 
		 (FG(24) AND A(14)) OR
		 (FH(8)  AND A(15)) OR 
		 (FH(24) AND A(16)) OR
		 (FI(8)  AND A(17)) OR
		 (FI(24) AND A(18))) AND NOT SWITCH) OR
		 (((FA(8) AND CONA(1)) OR
		 (FA(24) AND CONA(2)) OR
		 (FB(8) AND CONA(3)) OR
		 (FB(24) AND CONA(4)) OR
		 (FC(8) AND CONA(5)) OR
		 (FC(24) AND CONA(6)) OR
		 (FD(8) AND CONA(7)) OR
		 (FD(24) AND CONA(8)) OR
		 (FE(8) AND CONA(9)) OR
		 (FE(24) AND CONA(10)) OR
		 (FF(8) AND CONA(11)) OR
		 (FF(24) AND CONA(12)) OR
		 (FG(8) AND CONA(13)) OR
		 (FG(24) AND CONA(14)) OR
		 (FH(8) AND CONA(15)) OR
		 (FH(24) AND CONA(16)) OR
		 (FI(8) AND CONA(17)) OR
		 (FI(24) AND CONA(18))) AND SWITCH); 

OUTA(9) <= (((FA(9)  AND A(1))  OR 
           (FA(25) AND A(2))  OR 
		 (FB(9)  AND A(3))  OR 
		 (FB(25) AND A(4))  OR
		 (FC(9)  AND A(5))  OR 
		 (FC(25) AND A(6))  OR 
		 (FD(9)  AND A(7))  OR 
		 (FD(25) AND A(8))  OR
           (FE(9)  AND A(9))  OR 
		 (FE(25) AND A(10)) OR 
		 (FF(9)  AND A(11)) OR 
		 (FF(25) AND A(12)) OR 
           (FG(9)  AND A(13)) OR 
		 (FG(25) AND A(14)) OR
		 (FH(9)  AND A(15)) OR 
		 (FH(25) AND A(16)) OR
		 (FI(9)  AND A(17)) OR
		 (FI(25) AND A(18))) AND NOT SWITCH) OR
		 (((FA(9) AND CONA(1)) OR
		 (FA(25) AND CONA(2)) OR
		 (FB(9) AND CONA(3)) OR
		 (FB(25) AND CONA(4)) OR
		 (FC(9) AND CONA(5)) OR
		 (FC(25) AND CONA(6)) OR
		 (FD(9) AND CONA(7)) OR
		 (FD(25) AND CONA(8)) OR
		 (FE(9) AND CONA(9)) OR
		 (FE(25) AND CONA(10)) OR
		 (FF(9) AND CONA(11)) OR
		 (FF(25) AND CONA(12)) OR
		 (FG(9) AND CONA(13)) OR
		 (FG(25) AND CONA(14)) OR
		 (FH(9) AND CONA(15)) OR
		 (FH(25) AND CONA(16)) OR
		 (FI(9) AND CONA(17)) OR
		 (FI(25) AND CONA(18))) AND SWITCH); 

OUTA(10) <= (((FA(10)  AND A(1))  OR 
           (FA(26) AND A(2))  OR 
		 (FB(10)  AND A(3))  OR 
		 (FB(26) AND A(4))  OR
		 (FC(10)  AND A(5))  OR 
		 (FC(26) AND A(6))  OR 
		 (FD(10)  AND A(7))  OR 
		 (FD(26) AND A(8))  OR
           (FE(10)  AND A(9))  OR 
		 (FE(26) AND A(10)) OR 
		 (FF(10)  AND A(11)) OR 
		 (FF(26) AND A(12)) OR 
           (FG(10)  AND A(13)) OR 
		 (FG(26) AND A(14)) OR
		 (FH(10)  AND A(15)) OR 
		 (FH(26) AND A(16)) OR
		 (FI(10)  AND A(17)) OR
		 (FI(26) AND A(18))) AND NOT SWITCH) OR
		 (((FA(10) AND CONA(1)) OR
		 (FA(26) AND CONA(2)) OR
		 (FB(10) AND CONA(3)) OR
		 (FB(26) AND CONA(4)) OR
		 (FC(10) AND CONA(5)) OR
		 (FC(26) AND CONA(6)) OR
		 (FD(10) AND CONA(7)) OR
		 (FD(26) AND CONA(8)) OR
		 (FE(10) AND CONA(9)) OR
		 (FE(26) AND CONA(10)) OR
		 (FF(10) AND CONA(11)) OR
		 (FF(26) AND CONA(12)) OR
		 (FG(10) AND CONA(13)) OR
		 (FG(26) AND CONA(14)) OR
		 (FH(10) AND CONA(15)) OR
		 (FH(26) AND CONA(16)) OR
		 (FI(10) AND CONA(17)) OR
		 (FI(26) AND CONA(18))) AND SWITCH); 

OUTA(11) <= (((FA(11)  AND A(1))  OR 
           (FA(27) AND A(2))  OR 
		 (FB(11)  AND A(3))  OR 
		 (FB(27) AND A(4))  OR
		 (FC(11)  AND A(5))  OR 
		 (FC(27) AND A(6))  OR 
		 (FD(11)  AND A(7))  OR 
		 (FD(27) AND A(8))  OR
           (FE(11)  AND A(9))  OR 
		 (FE(27) AND A(10)) OR 
		 (FF(11)  AND A(11)) OR 
		 (FF(27) AND A(12)) OR 
           (FG(11)  AND A(13)) OR 
		 (FG(27) AND A(14)) OR
		 (FH(11)  AND A(15)) OR 
		 (FH(27) AND A(16)) OR
		 (FI(11)  AND A(17)) OR
		 (FI(27) AND A(18))) AND NOT SWITCH) OR
		 (((FA(11) AND CONA(1)) OR
		 (FA(27) AND CONA(2)) OR
		 (FB(11) AND CONA(3)) OR
		 (FB(27) AND CONA(4)) OR
		 (FC(11) AND CONA(5)) OR
		 (FC(27) AND CONA(6)) OR
		 (FD(11) AND CONA(7)) OR
		 (FD(27) AND CONA(8)) OR
		 (FE(11) AND CONA(9)) OR
		 (FE(27) AND CONA(10)) OR
		 (FF(11) AND CONA(11)) OR
		 (FF(27) AND CONA(12)) OR
		 (FG(11) AND CONA(13)) OR
		 (FG(27) AND CONA(14)) OR
		 (FH(11) AND CONA(15)) OR
		 (FH(27) AND CONA(16)) OR
		 (FI(11) AND CONA(17)) OR
		 (FI(27) AND CONA(18))) AND SWITCH); 

OUTA(12) <= (((FA(12)  AND A(1))  OR 
           (FA(28) AND A(2))  OR 
		 (FB(12)  AND A(3))  OR 
		 (FB(28) AND A(4))  OR
		 (FC(12)  AND A(5))  OR 
		 (FC(28) AND A(6))  OR 
		 (FD(12)  AND A(7))  OR 
		 (FD(28) AND A(8))  OR
           (FE(12)  AND A(9))  OR 
		 (FE(28) AND A(10)) OR 
		 (FF(12)  AND A(11)) OR 
		 (FF(28) AND A(12)) OR 
           (FG(12)  AND A(13)) OR 
		 (FG(28) AND A(14)) OR
		 (FH(12)  AND A(15)) OR 
		 (FH(28) AND A(16)) OR
		 (FI(12)  AND A(17)) OR
		 (FI(28) AND A(18))) AND NOT SWITCH) OR
		 (((FA(12) AND CONA(1)) OR
		 (FA(28) AND CONA(2)) OR
		 (FB(12) AND CONA(3)) OR
		 (FB(28) AND CONA(4)) OR
		 (FC(12) AND CONA(5)) OR
		 (FC(28) AND CONA(6)) OR
		 (FD(12) AND CONA(7)) OR
		 (FD(28) AND CONA(8)) OR
		 (FE(12) AND CONA(9)) OR
		 (FE(28) AND CONA(10)) OR
		 (FF(12) AND CONA(11)) OR
		 (FF(28) AND CONA(12)) OR
		 (FG(12) AND CONA(13)) OR
		 (FG(28) AND CONA(14)) OR
		 (FH(12) AND CONA(15)) OR
		 (FH(28) AND CONA(16)) OR
		 (FI(12) AND CONA(17)) OR
		 (FI(28) AND CONA(18))) AND SWITCH); 

OUTA(13) <= (((FA(13)  AND A(1))  OR 
           (FA(29) AND A(2))  OR 
		 (FB(13)  AND A(3))  OR 
		 (FB(29) AND A(4))  OR
		 (FC(13)  AND A(5))  OR 
		 (FC(29) AND A(6))  OR 
		 (FD(13)  AND A(7))  OR 
		 (FD(29) AND A(8))  OR
           (FE(13)  AND A(9))  OR 
		 (FE(29) AND A(10)) OR 
		 (FF(13)  AND A(11)) OR 
		 (FF(29) AND A(12)) OR 
           (FG(13)  AND A(13)) OR 
		 (FG(29) AND A(14)) OR
		 (FH(13)  AND A(15)) OR 
		 (FH(29) AND A(16)) OR
		 (FI(13)  AND A(17)) OR
		 (FI(29) AND A(18))) AND NOT SWITCH) OR
		 (((FA(13) AND CONA(1)) OR
		 (FA(29) AND CONA(2)) OR
		 (FB(13) AND CONA(3)) OR
		 (FB(29) AND CONA(4)) OR
		 (FC(13) AND CONA(5)) OR
		 (FC(29) AND CONA(6)) OR
		 (FD(13) AND CONA(7)) OR
		 (FD(29) AND CONA(8)) OR
		 (FE(13) AND CONA(9)) OR
		 (FE(29) AND CONA(10)) OR
		 (FF(13) AND CONA(11)) OR
		 (FF(29) AND CONA(12)) OR
		 (FG(13) AND CONA(13)) OR
		 (FG(29) AND CONA(14)) OR
		 (FH(13) AND CONA(15)) OR
		 (FH(29) AND CONA(16)) OR
		 (FI(13) AND CONA(17)) OR
		 (FI(29) AND CONA(18))) AND SWITCH); 

OUTA(14) <= (((FA(14)  AND A(1))  OR 
           (FA(30) AND A(2))  OR 
		 (FB(14)  AND A(3))  OR 
		 (FB(30) AND A(4))  OR
		 (FC(14)  AND A(5))  OR 
		 (FC(30) AND A(6))  OR 
		 (FD(14)  AND A(7))  OR 
		 (FD(30) AND A(8))  OR
           (FE(14)  AND A(9))  OR 
		 (FE(30) AND A(10)) OR 
		 (FF(14)  AND A(11)) OR 
		 (FF(30) AND A(12)) OR 
           (FG(14)  AND A(13)) OR 
		 (FG(30) AND A(14)) OR
		 (FH(14)  AND A(15)) OR 
		 (FH(30) AND A(16)) OR
		 (FI(14)  AND A(17)) OR
		 (FI(30) AND A(18))) AND NOT SWITCH) OR
		 (((FA(14) AND CONA(1)) OR
		 (FA(30) AND CONA(2)) OR
		 (FB(14) AND CONA(3)) OR
		 (FB(30) AND CONA(4)) OR
		 (FC(14) AND CONA(5)) OR
		 (FC(30) AND CONA(6)) OR
		 (FD(14) AND CONA(7)) OR
		 (FD(30) AND CONA(8)) OR
		 (FE(14) AND CONA(9)) OR
		 (FE(30) AND CONA(10)) OR
		 (FF(14) AND CONA(11)) OR
		 (FF(30) AND CONA(12)) OR
		 (FG(14) AND CONA(13)) OR
		 (FG(30) AND CONA(14)) OR
		 (FH(14) AND CONA(15)) OR
		 (FH(30) AND CONA(16)) OR
		 (FI(14) AND CONA(17)) OR
		 (FI(30) AND CONA(18))) AND SWITCH); 

OUTA(15) <= (((FA(15)  AND A(1))  OR 
           (FA(31) AND A(2))  OR 
		 (FB(15)  AND A(3))  OR 
		 (FB(31) AND A(4))  OR
		 (FC(15)  AND A(5))  OR 
		 (FC(31) AND A(6))  OR 
		 (FD(15)  AND A(7))  OR 
		 (FD(31) AND A(8))  OR
           (FE(15)  AND A(9))  OR 
		 (FE(31) AND A(10)) OR 
		 (FF(15)  AND A(11)) OR 
		 (FF(31) AND A(12)) OR 
           (FG(15)  AND A(13)) OR 
		 (FG(31) AND A(14)) OR
		 (FH(15)  AND A(15)) OR 
		 (FH(31) AND A(16)) OR
		 (FI(15)  AND A(17)) OR
		 (FI(31) AND A(18))) AND NOT SWITCH) OR
		 (((FA(15) AND CONA(1)) OR
		 (FA(31) AND CONA(2)) OR
		 (FB(15) AND CONA(3)) OR
		 (FB(31) AND CONA(4)) OR
		 (FC(15) AND CONA(5)) OR
		 (FC(31) AND CONA(6)) OR
		 (FD(15) AND CONA(7)) OR
		 (FD(31) AND CONA(8)) OR
		 (FE(15) AND CONA(9)) OR
		 (FE(31) AND CONA(10)) OR
		 (FF(15) AND CONA(11)) OR
		 (FF(31) AND CONA(12)) OR
		 (FG(15) AND CONA(13)) OR
		 (FG(31) AND CONA(14)) OR
		 (FH(15) AND CONA(15)) OR
		 (FH(31) AND CONA(16)) OR
		 (FI(15) AND CONA(17)) OR
		 (FI(31) AND CONA(18))) AND SWITCH); 

OUTA(16) <= (((SA(0)  AND A(1))  OR 
           (SA(16) AND A(2))  OR 
		 (SB(0)  AND A(3))  OR 
		 (SB(16) AND A(4))  OR
		 (SC(0)  AND A(5))  OR 
		 (SC(16) AND A(6))  OR 
		 (SD(0)  AND A(7))  OR 
		 (SD(16) AND A(8))  OR
           (SE(0)  AND A(9))  OR 
		 (SE(16) AND A(10)) OR 
		 (SF(0)  AND A(11)) OR 
		 (SF(16) AND A(12)) OR 
           (SG(0)  AND A(13)) OR 
		 (SG(16) AND A(14)) OR
		 (SH(0)  AND A(15)) OR 
		 (SH(16) AND A(16)) OR
		 (SI(0)  AND A(17)) OR
		 (SI(16) AND A(18))) AND NOT SWITCH) OR
		 (((SA(0) AND CONA(1)) OR
		 (SA(16) AND CONA(2)) OR
		 (SB(0) AND CONA(3)) OR
		 (SB(16) AND CONA(4)) OR
		 (SC(0) AND CONA(5)) OR
		 (SC(16) AND CONA(6)) OR
		 (SD(0) AND CONA(7)) OR
		 (SD(16) AND CONA(8)) OR
		 (SE(0) AND CONA(9)) OR
		 (SE(16) AND CONA(10)) OR
		 (SF(0) AND CONA(11)) OR
		 (SF(16) AND CONA(12)) OR
		 (SG(0) AND CONA(13)) OR
		 (SG(16) AND CONA(14)) OR
		 (SH(0) AND CONA(15)) OR
		 (SH(16) AND CONA(16)) OR
		 (SI(0) AND CONA(17)) OR
		 (SI(16) AND CONA(18))) AND SWITCH); 

OUTA(17) <= (((SA(1)  AND A(1))  OR 
           (SA(17) AND A(2))  OR 
		 (SB(1)  AND A(3))  OR 
		 (SB(17) AND A(4))  OR
		 (SC(1)  AND A(5))  OR 
		 (SC(17) AND A(6))  OR 
		 (SD(1)  AND A(7))  OR 
		 (SD(17) AND A(8))  OR
           (SE(1)  AND A(9))  OR 
		 (SE(17) AND A(10)) OR 
		 (SF(1)  AND A(11)) OR 
		 (SF(17) AND A(12)) OR 
           (SG(1)  AND A(13)) OR 
		 (SG(17) AND A(14)) OR
		 (SH(1)  AND A(15)) OR 
		 (SH(17) AND A(16)) OR
		 (SI(1)  AND A(17)) OR
		 (SI(17) AND A(18))) AND NOT SWITCH) OR
		 (((SA(1) AND CONA(1)) OR
		 (SA(17) AND CONA(2)) OR
		 (SB(1) AND CONA(3)) OR
		 (SB(17) AND CONA(4)) OR
		 (SC(1) AND CONA(5)) OR
		 (SC(17) AND CONA(6)) OR
		 (SD(1) AND CONA(7)) OR
		 (SD(17) AND CONA(8)) OR
		 (SE(1) AND CONA(9)) OR
		 (SE(17) AND CONA(10)) OR
		 (SF(1) AND CONA(11)) OR
		 (SF(17) AND CONA(12)) OR
		 (SG(1) AND CONA(13)) OR
		 (SG(17) AND CONA(14)) OR
		 (SH(1) AND CONA(15)) OR
		 (SH(17) AND CONA(16)) OR
		 (SI(1) AND CONA(17)) OR
		 (SI(17) AND CONA(18))) AND SWITCH); 

OUTA(18) <= (((SA(2)  AND A(1))  OR 
           (SA(18) AND A(2))  OR 
		 (SB(2)  AND A(3))  OR 
		 (SB(18) AND A(4))  OR
		 (SC(2)  AND A(5))  OR 
		 (SC(18) AND A(6))  OR 
		 (SD(2)  AND A(7))  OR 
		 (SD(18) AND A(8))  OR
           (SE(2)  AND A(9))  OR 
		 (SE(18) AND A(10)) OR 
		 (SF(2)  AND A(11)) OR 
		 (SF(18) AND A(12)) OR 
           (SG(2)  AND A(13)) OR 
		 (SG(18) AND A(14)) OR
		 (SH(2)  AND A(15)) OR 
		 (SH(18) AND A(16)) OR
		 (SI(2)  AND A(17)) OR
		 (SI(18) AND A(18))) AND NOT SWITCH) OR
		 (((SA(2) AND CONA(1)) OR
		 (SA(18) AND CONA(2)) OR
		 (SB(2) AND CONA(3)) OR
		 (SB(18) AND CONA(4)) OR
		 (SC(2) AND CONA(5)) OR
		 (SC(18) AND CONA(6)) OR
		 (SD(2) AND CONA(7)) OR
		 (SD(18) AND CONA(8)) OR
		 (SE(2) AND CONA(9)) OR
		 (SE(18) AND CONA(10)) OR
		 (SF(2) AND CONA(11)) OR
		 (SF(18) AND CONA(12)) OR
		 (SG(2) AND CONA(13)) OR
		 (SG(18) AND CONA(14)) OR
		 (SH(2) AND CONA(15)) OR
		 (SH(18) AND CONA(16)) OR
		 (SI(2) AND CONA(17)) OR
		 (SI(18) AND CONA(18))) AND SWITCH); 

OUTA(19) <= (((SA(3)  AND A(1))  OR 
           (SA(19) AND A(2))  OR 
		 (SB(3)  AND A(3))  OR 
		 (SB(19) AND A(4))  OR
		 (SC(3)  AND A(5))  OR 
		 (SC(19) AND A(6))  OR 
		 (SD(3)  AND A(7))  OR 
		 (SD(19) AND A(8))  OR
           (SE(3)  AND A(9))  OR 
		 (SE(19) AND A(10)) OR 
		 (SF(3)  AND A(11)) OR 
		 (SF(19) AND A(12)) OR 
           (SG(3)  AND A(13)) OR 
		 (SG(19) AND A(14)) OR
		 (SH(3)  AND A(15)) OR 
		 (SH(19) AND A(16)) OR
		 (SI(3)  AND A(17)) OR
		 (SI(19) AND A(18))) AND NOT SWITCH) OR
		 (((SA(3) AND CONA(1)) OR
		 (SA(19) AND CONA(2)) OR
		 (SB(3) AND CONA(3)) OR
		 (SB(19) AND CONA(4)) OR
		 (SC(3) AND CONA(5)) OR
		 (SC(19) AND CONA(6)) OR
		 (SD(3) AND CONA(7)) OR
		 (SD(19) AND CONA(8)) OR
		 (SE(3) AND CONA(9)) OR
		 (SE(19) AND CONA(10)) OR
		 (SF(3) AND CONA(11)) OR
		 (SF(19) AND CONA(12)) OR
		 (SG(3) AND CONA(13)) OR
		 (SG(19) AND CONA(14)) OR
		 (SH(3) AND CONA(15)) OR
		 (SH(19) AND CONA(16)) OR
		 (SI(3) AND CONA(17)) OR
		 (SI(19) AND CONA(18))) AND SWITCH); 


OUTA(20) <= (((SA(4)  AND A(1))  OR 
           (SA(20) AND A(2))  OR 
		 (SB(4)  AND A(3))  OR 
		 (SB(20) AND A(4))  OR
		 (SC(4)  AND A(5))  OR 
		 (SC(20) AND A(6))  OR 
		 (SD(4)  AND A(7))  OR 
		 (SD(20) AND A(8))  OR
           (SE(4)  AND A(9))  OR 
		 (SE(20) AND A(10)) OR 
		 (SF(4)  AND A(11)) OR 
		 (SF(20) AND A(12)) OR 
           (SG(4)  AND A(13)) OR 
		 (SG(20) AND A(14)) OR
		 (SH(4)  AND A(15)) OR 
		 (SH(20) AND A(16)) OR
		 (SI(4)  AND A(17)) OR
		 (SI(20) AND A(18))) AND NOT SWITCH) OR
		 (((SA(4) AND CONA(1)) OR
		 (SA(20) AND CONA(2)) OR
		 (SB(4) AND CONA(3)) OR
		 (SB(20) AND CONA(4)) OR
		 (SC(4) AND CONA(5)) OR
		 (SC(20) AND CONA(6)) OR
		 (SD(4) AND CONA(7)) OR
		 (SD(20) AND CONA(8)) OR
		 (SE(4) AND CONA(9)) OR
		 (SE(20) AND CONA(10)) OR
		 (SF(4) AND CONA(11)) OR
		 (SF(20) AND CONA(12)) OR
		 (SG(4) AND CONA(13)) OR
		 (SG(20) AND CONA(14)) OR
		 (SH(4) AND CONA(15)) OR
		 (SH(20) AND CONA(16)) OR
		 (SI(4) AND CONA(17)) OR
		 (SI(20) AND CONA(18))) AND SWITCH); 

OUTA(21) <= (((SA(5)  AND A(1))  OR 
           (SA(21) AND A(2))  OR 
		 (SB(5)  AND A(3))  OR 
		 (SB(21) AND A(4))  OR
		 (SC(5)  AND A(5))  OR 
		 (SC(21) AND A(6))  OR 
		 (SD(5)  AND A(7))  OR 
		 (SD(21) AND A(8))  OR
           (SE(5)  AND A(9))  OR 
		 (SE(21) AND A(10)) OR 
		 (SF(5)  AND A(11)) OR 
		 (SF(21) AND A(12)) OR 
           (SG(5)  AND A(13)) OR 
		 (SG(21) AND A(14)) OR
		 (SH(5)  AND A(15)) OR 
		 (SH(21) AND A(16)) OR
		 (SI(5)  AND A(17)) OR
		 (SI(21) AND A(18))) AND NOT SWITCH) OR
		 (((SA(5) AND CONA(1)) OR
		 (SA(21) AND CONA(2)) OR
		 (SB(5) AND CONA(3)) OR
		 (SB(21) AND CONA(4)) OR
		 (SC(5) AND CONA(5)) OR
		 (SC(21) AND CONA(6)) OR
		 (SD(5) AND CONA(7)) OR
		 (SD(21) AND CONA(8)) OR
		 (SE(5) AND CONA(9)) OR
		 (SE(21) AND CONA(10)) OR
		 (SF(5) AND CONA(11)) OR
		 (SF(21) AND CONA(12)) OR
		 (SG(5) AND CONA(13)) OR
		 (SG(21) AND CONA(14)) OR
		 (SH(5) AND CONA(15)) OR
		 (SH(21) AND CONA(16)) OR
		 (SI(5) AND CONA(17)) OR
		 (SI(21) AND CONA(18))) AND SWITCH); 

OUTA(22) <= (((SA(6)  AND A(1))  OR 
           (SA(22) AND A(2))  OR 
		 (SB(6)  AND A(3))  OR 
		 (SB(22) AND A(4))  OR
		 (SC(6)  AND A(5))  OR 
		 (SC(22) AND A(6))  OR 
		 (SD(6)  AND A(7))  OR 
		 (SD(22) AND A(8))  OR
           (SE(6)  AND A(9))  OR 
		 (SE(22) AND A(10)) OR 
		 (SF(6)  AND A(11)) OR 
		 (SF(22) AND A(12)) OR 
           (SG(6)  AND A(13)) OR 
		 (SG(22) AND A(14)) OR
		 (SH(6)  AND A(15)) OR 
		 (SH(22) AND A(16)) OR
		 (SI(6)  AND A(17)) OR
		 (SI(22) AND A(18))) AND NOT SWITCH) OR
		 (((SA(6) AND CONA(1)) OR
		 (SA(22) AND CONA(2)) OR
		 (SB(6) AND CONA(3)) OR
		 (SB(22) AND CONA(4)) OR
		 (SC(6) AND CONA(5)) OR
		 (SC(22) AND CONA(6)) OR
		 (SD(6) AND CONA(7)) OR
		 (SD(22) AND CONA(8)) OR
		 (SE(6) AND CONA(9)) OR
		 (SE(22) AND CONA(10)) OR
		 (SF(6) AND CONA(11)) OR
		 (SF(22) AND CONA(12)) OR
		 (SG(6) AND CONA(13)) OR
		 (SG(22) AND CONA(14)) OR
		 (SH(6) AND CONA(15)) OR
		 (SH(22) AND CONA(16)) OR
		 (SI(6) AND CONA(17)) OR
		 (SI(22) AND CONA(18))) AND SWITCH); 

OUTA(23) <= (((SA(7)  AND A(1))  OR 
           (SA(23) AND A(2))  OR 
		 (SB(7)  AND A(3))  OR 
		 (SB(23) AND A(4))  OR
		 (SC(7)  AND A(5))  OR 
		 (SC(23) AND A(6))  OR 
		 (SD(7)  AND A(7))  OR 
		 (SD(23) AND A(8))  OR
           (SE(7)  AND A(9))  OR 
		 (SE(23) AND A(10)) OR 
		 (SF(7)  AND A(11)) OR 
		 (SF(23) AND A(12)) OR 
           (SG(7)  AND A(13)) OR 
		 (SG(23) AND A(14)) OR
		 (SH(7)  AND A(15)) OR 
		 (SH(23) AND A(16)) OR
		 (SI(7)  AND A(17)) OR
		 (SI(23) AND A(18))) AND NOT SWITCH) OR
		 (((SA(7) AND CONA(1)) OR
		 (SA(23) AND CONA(2)) OR
		 (SB(7) AND CONA(3)) OR
		 (SB(23) AND CONA(4)) OR
		 (SC(7) AND CONA(5)) OR
		 (SC(23) AND CONA(6)) OR
		 (SD(7) AND CONA(7)) OR
		 (SD(23) AND CONA(8)) OR
		 (SE(7) AND CONA(9)) OR
		 (SE(23) AND CONA(10)) OR
		 (SF(7) AND CONA(11)) OR
		 (SF(23) AND CONA(12)) OR
		 (SG(7) AND CONA(13)) OR
		 (SG(23) AND CONA(14)) OR
		 (SH(7) AND CONA(15)) OR
		 (SH(23) AND CONA(16)) OR
		 (SI(7) AND CONA(17)) OR
		 (SI(23) AND CONA(18))) AND SWITCH); 

OUTA(24) <= (((SA(8)  AND A(1))  OR 
           (SA(24) AND A(2))  OR 
		 (SB(8)  AND A(3))  OR 
		 (SB(24) AND A(4))  OR
		 (SC(8)  AND A(5))  OR 
		 (SC(24) AND A(6))  OR 
		 (SD(8)  AND A(7))  OR 
		 (SD(24) AND A(8))  OR
           (SE(8)  AND A(9))  OR 
		 (SE(24) AND A(10)) OR 
		 (SF(8)  AND A(11)) OR 
		 (SF(24) AND A(12)) OR 
           (SG(8)  AND A(13)) OR 
		 (SG(24) AND A(14)) OR
		 (SH(8)  AND A(15)) OR 
		 (SH(24) AND A(16)) OR
		 (SI(8)  AND A(17)) OR
		 (SI(24) AND A(18))) AND NOT SWITCH) OR
		 (((SA(8) AND CONA(1)) OR
		 (SA(24) AND CONA(2)) OR
		 (SB(8) AND CONA(3)) OR
		 (SB(24) AND CONA(4)) OR
		 (SC(8) AND CONA(5)) OR
		 (SC(24) AND CONA(6)) OR
		 (SD(8) AND CONA(7)) OR
		 (SD(24) AND CONA(8)) OR
		 (SE(8) AND CONA(9)) OR
		 (SE(24) AND CONA(10)) OR
		 (SF(8) AND CONA(11)) OR
		 (SF(24) AND CONA(12)) OR
		 (SG(8) AND CONA(13)) OR
		 (SG(24) AND CONA(14)) OR
		 (SH(8) AND CONA(15)) OR
		 (SH(24) AND CONA(16)) OR
		 (SI(8) AND CONA(17)) OR
		 (SI(24) AND CONA(18))) AND SWITCH); 

OUTA(25) <= (((SA(9)  AND A(1))  OR 
           (SA(25) AND A(2))  OR 
		 (SB(9)  AND A(3))  OR 
		 (SB(25) AND A(4))  OR
		 (SC(9)  AND A(5))  OR 
		 (SC(25) AND A(6))  OR 
		 (SD(9)  AND A(7))  OR 
		 (SD(25) AND A(8))  OR
           (SE(9)  AND A(9))  OR 
		 (SE(25) AND A(10)) OR 
		 (SF(9)  AND A(11)) OR 
		 (SF(25) AND A(12)) OR 
           (SG(9)  AND A(13)) OR 
		 (SG(25) AND A(14)) OR
		 (SH(9)  AND A(15)) OR 
		 (SH(25) AND A(16)) OR
		 (SI(9)  AND A(17)) OR
		 (SI(25) AND A(18))) AND NOT SWITCH) OR
		 (((SA(9) AND CONA(1)) OR
		 (SA(25) AND CONA(2)) OR
		 (SB(9) AND CONA(3)) OR
		 (SB(25) AND CONA(4)) OR
		 (SC(9) AND CONA(5)) OR
		 (SC(25) AND CONA(6)) OR
		 (SD(9) AND CONA(7)) OR
		 (SD(25) AND CONA(8)) OR
		 (SE(9) AND CONA(9)) OR
		 (SE(25) AND CONA(10)) OR
		 (SF(9) AND CONA(11)) OR
		 (SF(25) AND CONA(12)) OR
		 (SG(9) AND CONA(13)) OR
		 (SG(25) AND CONA(14)) OR
		 (SH(9) AND CONA(15)) OR
		 (SH(25) AND CONA(16)) OR
		 (SI(9) AND CONA(17)) OR
		 (SI(25) AND CONA(18))) AND SWITCH); 

OUTA(26) <= (((SA(10)  AND A(1))  OR 
           (SA(26) AND A(2))  OR 
		 (SB(10)  AND A(3))  OR 
		 (SB(26) AND A(4))  OR
		 (SC(10)  AND A(5))  OR 
		 (SC(26) AND A(6))  OR 
		 (SD(10)  AND A(7))  OR 
		 (SD(26) AND A(8))  OR
           (SE(10)  AND A(9))  OR 
		 (SE(26) AND A(10)) OR 
		 (SF(10)  AND A(11)) OR 
		 (SF(26) AND A(12)) OR 
           (SG(10)  AND A(13)) OR 
		 (SG(26) AND A(14)) OR
		 (SH(10)  AND A(15)) OR 
		 (SH(26) AND A(16)) OR
		 (SI(10)  AND A(17)) OR
		 (SI(26) AND A(18))) AND NOT SWITCH) OR
		 (((SA(10) AND CONA(1)) OR
		 (SA(26) AND CONA(2)) OR
		 (SB(10) AND CONA(3)) OR
		 (SB(26) AND CONA(4)) OR
		 (SC(10) AND CONA(5)) OR
		 (SC(26) AND CONA(6)) OR
		 (SD(10) AND CONA(7)) OR
		 (SD(26) AND CONA(8)) OR
		 (SE(10) AND CONA(9)) OR
		 (SE(26) AND CONA(10)) OR
		 (SF(10) AND CONA(11)) OR
		 (SF(26) AND CONA(12)) OR
		 (SG(10) AND CONA(13)) OR
		 (SG(26) AND CONA(14)) OR
		 (SH(10) AND CONA(15)) OR
		 (SH(26) AND CONA(16)) OR
		 (SI(10) AND CONA(17)) OR
		 (SI(26) AND CONA(18))) AND SWITCH); 

OUTA(27) <= ((SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27))  AND NOT SWITCH) OR
		 (((SA(11) AND CONA(1)) OR
		 (SA(27) AND CONA(2)) OR
		 (SB(11) AND CONA(3)) OR
		 (SB(27) AND CONA(4)) OR
		 (SC(11) AND CONA(5)) OR
		 (SC(27) AND CONA(6)) OR
		 (SD(11) AND CONA(7)) OR
		 (SD(27) AND CONA(8)) OR
		 (SE(11) AND CONA(9)) OR
		 (SE(27) AND CONA(10)) OR
		 (SF(11) AND CONA(11)) OR
		 (SF(27) AND CONA(12)) OR
		 (SG(11) AND CONA(13)) OR
		 (SG(27) AND CONA(14)) OR
		 (SH(11) AND CONA(15)) OR
		 (SH(27) AND CONA(16)) OR
		 (SI(11) AND CONA(17)) OR
		 (SI(27) AND CONA(18))) AND SWITCH); 

--OUTA(27) <= (((SA(11) AND A(1)) OR 
--       (SA(27) AND A(2))   OR 
--		 (SB(11) AND A(3))   OR 
--		 (SB(27) AND A(4))   OR
--		 (SC(11) AND A(5))   OR 
--		 (SC(27) AND A(6))   OR 
--		 (SD(11) AND A(7))  OR 
--		 (SD(27) AND A(8))  OR
--       (SE(11) AND A(9))  OR 
--		 (SE(27) AND A(10))  OR 
--		 (SF(11) AND A(11))  OR 
--		 (SF(27) AND A(12))  OR 
--       (SG(11) AND A(13))  OR 
--		 (SG(27) AND A(14))  OR
--		 (SH(11) AND A(15))  OR 
--		 (SH(27) AND A(16))  OR
--		 (SI(11) AND A(17))  OR
--		 (SI(27) AND A(18))) AND NOT SWITCH) OR
--		 (((SA(11) AND CONA(1)) OR
--		 (SA(27) AND CONA(2)) OR
--		 (SB(11) AND CONA(3)) OR
--		 (SB(27) AND CONA(4)) OR
--		 (SC(11) AND CONA(5)) OR
--		 (SC(27) AND CONA(6)) OR
--		 (SD(11) AND CONA(7)) OR
--		 (SD(27) AND CONA(8)) OR
--		 (SE(11) AND CONA(9)) OR
--		 (SE(27) AND CONA(10)) OR
--		 (SF(11) AND CONA(11)) OR
--		 (SF(27) AND CONA(12)) OR
--		 (SG(11) AND CONA(13)) OR
--		 (SG(27) AND CONA(14)) OR
--		 (SH(11) AND CONA(15)) OR
--		 (SH(27) AND CONA(16)) OR
--		 (SI(11) AND CONA(17)) OR
--		 (SI(27) AND CONA(18))) AND SWITCH); 

OUTA(28) <= (((SA(12)  AND A(1))  OR 
           (SA(28) AND A(2))  OR 
		 (SB(12)  AND A(3))  OR 
		 (SB(28) AND A(4))  OR
		 (SC(12)  AND A(5))  OR 
		 (SC(28) AND A(6))  OR 
		 (SD(12)  AND A(7))  OR 
		 (SD(28) AND A(8))  OR
           (SE(12)  AND A(9))  OR 
		 (SE(28) AND A(10)) OR 
		 (SF(12)  AND A(11)) OR 
		 (SF(28) AND A(12)) OR 
           (SG(12)  AND A(13)) OR 
		 (SG(28) AND A(14)) OR
		 (SH(12)  AND A(15)) OR 
		 (SH(28) AND A(16)) OR
		 (SI(12)  AND A(17)) OR
		 (SI(28) AND A(18))) AND NOT SWITCH) OR
		 (((SA(12) AND CONA(1)) OR
		 (SA(28) AND CONA(2)) OR
		 (SB(12) AND CONA(3)) OR
		 (SB(28) AND CONA(4)) OR
		 (SC(12) AND CONA(5)) OR
		 (SC(28) AND CONA(6)) OR
		 (SD(12) AND CONA(7)) OR
		 (SD(28) AND CONA(8)) OR
		 (SE(12) AND CONA(9)) OR
		 (SE(28) AND CONA(10)) OR
		 (SF(12) AND CONA(11)) OR
		 (SF(28) AND CONA(12)) OR
		 (SG(12) AND CONA(13)) OR
		 (SG(28) AND CONA(14)) OR
		 (SH(12) AND CONA(15)) OR
		 (SH(28) AND CONA(16)) OR
		 (SI(12) AND CONA(17)) OR
		 (SI(28) AND CONA(18))) AND SWITCH); 

OUTA(29) <= (((SA(13)  AND A(1))  OR 
           (SA(29) AND A(2))  OR 
		 (SB(13)  AND A(3))  OR 
		 (SB(29) AND A(4))  OR
		 (SC(13)  AND A(5))  OR 
		 (SC(29) AND A(6))  OR 
		 (SD(13)  AND A(7))  OR 
		 (SD(29) AND A(8))  OR
           (SE(13)  AND A(9))  OR 
		 (SE(29) AND A(10)) OR 
		 (SF(13)  AND A(11)) OR 
		 (SF(29) AND A(12)) OR 
           (SG(13)  AND A(13)) OR 
		 (SG(29) AND A(14)) OR
		 (SH(13)  AND A(15)) OR 
		 (SH(29) AND A(16)) OR
		 (SI(13)  AND A(17)) OR
		 (SI(29) AND A(18))) AND NOT SWITCH) OR
		 (((SA(13) AND CONA(1)) OR
		 (SA(29) AND CONA(2)) OR
		 (SB(13) AND CONA(3)) OR
		 (SB(29) AND CONA(4)) OR
		 (SC(13) AND CONA(5)) OR
		 (SC(29) AND CONA(6)) OR
		 (SD(13) AND CONA(7)) OR
		 (SD(29) AND CONA(8)) OR
		 (SE(13) AND CONA(9)) OR
		 (SE(29) AND CONA(10)) OR
		 (SF(13) AND CONA(11)) OR
		 (SF(29) AND CONA(12)) OR
		 (SG(13) AND CONA(13)) OR
		 (SG(29) AND CONA(14)) OR
		 (SH(13) AND CONA(15)) OR
		 (SH(29) AND CONA(16)) OR
		 (SI(13) AND CONA(17)) OR
		 (SI(29) AND CONA(18))) AND SWITCH); 

OUTA(30) <= (((SA(14)  AND A(1))  OR 
           (SA(30) AND A(2))  OR 
		 (SB(14)  AND A(3))  OR 
		 (SB(30) AND A(4))  OR
		 (SC(14)  AND A(5))  OR 
		 (SC(30) AND A(6))  OR 
		 (SD(14)  AND A(7))  OR 
		 (SD(30) AND A(8))  OR
           (SE(14)  AND A(9))  OR 
		 (SE(30) AND A(10)) OR 
		 (SF(14)  AND A(11)) OR 
		 (SF(30) AND A(12)) OR 
           (SG(14)  AND A(13)) OR 
		 (SG(30) AND A(14)) OR
		 (SH(14)  AND A(15)) OR 
		 (SH(30) AND A(16)) OR
		 (SI(14)  AND A(17)) OR
		 (SI(30) AND A(18))) AND NOT SWITCH) OR
		 (((SA(14) AND CONA(1)) OR
		 (SA(30) AND CONA(2)) OR
		 (SB(14) AND CONA(3)) OR
		 (SB(30) AND CONA(4)) OR
		 (SC(14) AND CONA(5)) OR
		 (SC(30) AND CONA(6)) OR
		 (SD(14) AND CONA(7)) OR
		 (SD(30) AND CONA(8)) OR
		 (SE(14) AND CONA(9)) OR
		 (SE(30) AND CONA(10)) OR
		 (SF(14) AND CONA(11)) OR
		 (SF(30) AND CONA(12)) OR
		 (SG(14) AND CONA(13)) OR
		 (SG(30) AND CONA(14)) OR
		 (SH(14) AND CONA(15)) OR
		 (SH(30) AND CONA(16)) OR
		 (SI(14) AND CONA(17)) OR
		 (SI(30) AND CONA(18))) AND SWITCH); 

OUTA(31) <= (((SA(15)  AND A(1))  OR 
           (SA(31) AND A(2))  OR 
		 (SB(15)  AND A(3))  OR 
		 (SB(31) AND A(4))  OR
		 (SC(15)  AND A(5))  OR 
		 (SC(31) AND A(6))  OR 
		 (SD(15)  AND A(7))  OR 
		 (SD(31) AND A(8))  OR
           (SE(15)  AND A(9))  OR 
		 (SE(31) AND A(10)) OR 
		 (SF(15)  AND A(11)) OR 
		 (SF(31) AND A(12)) OR 
           (SG(15)  AND A(13)) OR 
		 (SG(31) AND A(14)) OR
		 (SH(15)  AND A(15)) OR 
		 (SH(31) AND A(16)) OR
		 (SI(15)  AND A(17)) OR
		 (SI(31) AND A(18))) AND NOT SWITCH) OR
		 (((SA(15) AND CONA(1)) OR
		 (SA(31) AND CONA(2)) OR
		 (SB(15) AND CONA(3)) OR
		 (SB(31) AND CONA(4)) OR
		 (SC(15) AND CONA(5)) OR
		 (SC(31) AND CONA(6)) OR
		 (SD(15) AND CONA(7)) OR
		 (SD(31) AND CONA(8)) OR
		 (SE(15) AND CONA(9)) OR
		 (SE(31) AND CONA(10)) OR
		 (SF(15) AND CONA(11)) OR
		 (SF(31) AND CONA(12)) OR
		 (SG(15) AND CONA(13)) OR
		 (SG(31) AND CONA(14)) OR
		 (SH(15) AND CONA(15)) OR
		 (SH(31) AND CONA(16)) OR
		 (SI(15) AND CONA(17)) OR
		 (SI(31) AND CONA(18))) AND SWITCH); 

-- SECOND BEST

OUTB(0) <= (((FA(0)  AND B(1))  OR 
           (FA(16) AND B(2))  OR 
		 (FB(0)  AND B(3))  OR 
		 (FB(16) AND B(4))  OR
		 (FC(0)  AND B(5))  OR 
		 (FC(16) AND B(6))  OR 
		 (FD(0)  AND B(7))  OR 
		 (FD(16) AND B(8))  OR
           (FE(0)  AND B(9))  OR 
		 (FE(16) AND B(10)) OR 
		 (FF(0)  AND B(11)) OR 
		 (FF(16) AND B(12)) OR 
           (FG(0)  AND B(13)) OR 
		 (FG(16) AND B(14)) OR
		 (FH(0)  AND B(15)) OR 
		 (FH(16) AND B(16)) OR
		 (FI(0)  AND B(17)) OR
		 (FI(16) AND B(18))) AND NOT SWITCH) OR
		 (((FA(0) AND CONB(1)) OR
		 (FA(16) AND CONB(2)) OR
		 (FB(0) AND CONB(3)) OR
		 (FB(16) AND CONB(4)) OR
		 (FC(0) AND CONB(5)) OR
		 (FC(16) AND CONB(6)) OR
		 (FD(0) AND CONB(7)) OR
		 (FD(16) AND CONB(8)) OR
		 (FE(0) AND CONB(9)) OR
		 (FE(16) AND CONB(10)) OR
		 (FF(0) AND CONB(11)) OR
		 (FF(16) AND CONB(12)) OR
		 (FG(0) AND CONB(13)) OR
		 (FG(16) AND CONB(14)) OR
		 (FH(0) AND CONB(15)) OR
		 (FH(16) AND CONB(16)) OR
		 (FI(0) AND CONB(17)) OR
		 (FI(16) AND CONB(18))) AND SWITCH); 

OUTB(1) <= (((FA(1)  AND B(1))  OR 
           (FA(17) AND B(2))  OR 
		 (FB(1)  AND B(3))  OR 
		 (FB(17) AND B(4))  OR
		 (FC(1)  AND B(5))  OR 
		 (FC(17) AND B(6))  OR 
		 (FD(1)  AND B(7))  OR 
		 (FD(17) AND B(8))  OR
           (FE(1)  AND B(9))  OR 
		 (FE(17) AND B(10)) OR 
		 (FF(1)  AND B(11)) OR 
		 (FF(17) AND B(12)) OR 
           (FG(1)  AND B(13)) OR 
		 (FG(17) AND B(14)) OR
		 (FH(1)  AND B(15)) OR 
		 (FH(17) AND B(16)) OR
		 (FI(1)  AND B(17)) OR
		 (FI(17) AND B(18))) AND NOT SWITCH) OR
		 (((FA(1) AND CONB(1)) OR
		 (FA(17) AND CONB(2)) OR
		 (FB(1) AND CONB(3)) OR
		 (FB(17) AND CONB(4)) OR
		 (FC(1) AND CONB(5)) OR
		 (FC(17) AND CONB(6)) OR
		 (FD(1) AND CONB(7)) OR
		 (FD(17) AND CONB(8)) OR
		 (FE(1) AND CONB(9)) OR
		 (FE(17) AND CONB(10)) OR
		 (FF(1) AND CONB(11)) OR
		 (FF(17) AND CONB(12)) OR
		 (FG(1) AND CONB(13)) OR
		 (FG(17) AND CONB(14)) OR
		 (FH(1) AND CONB(15)) OR
		 (FH(17) AND CONB(16)) OR
		 (FI(1) AND CONB(17)) OR
		 (FI(17) AND CONB(18))) AND SWITCH); 

OUTB(2) <= (((FA(2)  AND B(1))  OR 
           (FA(18) AND B(2))  OR 
		 (FB(2)  AND B(3))  OR 
		 (FB(18) AND B(4))  OR
		 (FC(2)  AND B(5))  OR 
		 (FC(18) AND B(6))  OR 
		 (FD(2)  AND B(7))  OR 
		 (FD(18) AND B(8))  OR
           (FE(2)  AND B(9))  OR 
		 (FE(18) AND B(10)) OR 
		 (FF(2)  AND B(11)) OR 
		 (FF(18) AND B(12)) OR 
           (FG(2)  AND B(13)) OR 
		 (FG(18) AND B(14)) OR
		 (FH(2)  AND B(15)) OR 
		 (FH(18) AND B(16)) OR
		 (FI(2)  AND B(17)) OR
		 (FI(18) AND B(18))) AND NOT SWITCH) OR
		 (((FA(2) AND CONB(1)) OR
		 (FA(18) AND CONB(2)) OR
		 (FB(2) AND CONB(3)) OR
		 (FB(18) AND CONB(4)) OR
		 (FC(2) AND CONB(5)) OR
		 (FC(18) AND CONB(6)) OR
		 (FD(2) AND CONB(7)) OR
		 (FD(18) AND CONB(8)) OR
		 (FE(2) AND CONB(9)) OR
		 (FE(18) AND CONB(10)) OR
		 (FF(2) AND CONB(11)) OR
		 (FF(18) AND CONB(12)) OR
		 (FG(2) AND CONB(13)) OR
		 (FG(18) AND CONB(14)) OR
		 (FH(2) AND CONB(15)) OR
		 (FH(18) AND CONB(16)) OR
		 (FI(2) AND CONB(17)) OR
		 (FI(18) AND CONB(18))) AND SWITCH); 

OUTB(3) <= (((FA(3)  AND B(1))  OR 
           (FA(19) AND B(2))  OR 
		 (FB(3)  AND B(3))  OR 
		 (FB(19) AND B(4))  OR
		 (FC(3)  AND B(5))  OR 
		 (FC(19) AND B(6))  OR 
		 (FD(3)  AND B(7))  OR 
		 (FD(19) AND B(8))  OR
           (FE(3)  AND B(9))  OR 
		 (FE(19) AND B(10)) OR 
		 (FF(3)  AND B(11)) OR 
		 (FF(19) AND B(12)) OR 
           (FG(3)  AND B(13)) OR 
		 (FG(19) AND B(14)) OR
		 (FH(3)  AND B(15)) OR 
		 (FH(19) AND B(16)) OR
		 (FI(3)  AND B(17)) OR
		 (FI(19) AND B(18))) AND NOT SWITCH) OR
		 (((FA(3) AND CONB(1)) OR
		 (FA(19) AND CONB(2)) OR
		 (FB(3) AND CONB(3)) OR
		 (FB(19) AND CONB(4)) OR
		 (FC(3) AND CONB(5)) OR
		 (FC(19) AND CONB(6)) OR
		 (FD(3) AND CONB(7)) OR
		 (FD(19) AND CONB(8)) OR
		 (FE(3) AND CONB(9)) OR
		 (FE(19) AND CONB(10)) OR
		 (FF(3) AND CONB(11)) OR
		 (FF(19) AND CONB(12)) OR
		 (FG(3) AND CONB(13)) OR
		 (FG(19) AND CONB(14)) OR
		 (FH(3) AND CONB(15)) OR
		 (FH(19) AND CONB(16)) OR
		 (FI(3) AND CONB(17)) OR
		 (FI(19) AND CONB(18))) AND SWITCH); 

OUTB(4) <= (((FA(4)  AND B(1))  OR 
           (FA(20) AND B(2))  OR 
		 (FB(4)  AND B(3))  OR 
		 (FB(20) AND B(4))  OR
		 (FC(4)  AND B(5))  OR 
		 (FC(20) AND B(6))  OR 
		 (FD(4)  AND B(7))  OR 
		 (FD(20) AND B(8))  OR
           (FE(4)  AND B(9))  OR 
		 (FE(20) AND B(10)) OR 
		 (FF(4)  AND B(11)) OR 
		 (FF(20) AND B(12)) OR 
           (FG(4)  AND B(13)) OR 
		 (FG(20) AND B(14)) OR
		 (FH(4)  AND B(15)) OR 
		 (FH(20) AND B(16)) OR
		 (FI(4)  AND B(17)) OR
		 (FI(20) AND B(18))) AND NOT SWITCH) OR
		 (((FA(4) AND CONB(1)) OR
		 (FA(20) AND CONB(2)) OR
		 (FB(4) AND CONB(3)) OR
		 (FB(20) AND CONB(4)) OR
		 (FC(4) AND CONB(5)) OR
		 (FC(20) AND CONB(6)) OR
		 (FD(4) AND CONB(7)) OR
		 (FD(20) AND CONB(8)) OR
		 (FE(4) AND CONB(9)) OR
		 (FE(20) AND CONB(10)) OR
		 (FF(4) AND CONB(11)) OR
		 (FF(20) AND CONB(12)) OR
		 (FG(4) AND CONB(13)) OR
		 (FG(20) AND CONB(14)) OR
		 (FH(4) AND CONB(15)) OR
		 (FH(20) AND CONB(16)) OR
		 (FI(4) AND CONB(17)) OR
		 (FI(20) AND CONB(18))) AND SWITCH); 

OUTB(5) <= (((FA(5)  AND B(1))  OR 
           (FA(21) AND B(2))  OR 
		 (FB(5)  AND B(3))  OR 
		 (FB(21) AND B(4))  OR
		 (FC(5)  AND B(5))  OR 
		 (FC(21) AND B(6))  OR 
		 (FD(5)  AND B(7))  OR 
		 (FD(21) AND B(8))  OR
           (FE(5)  AND B(9))  OR 
		 (FE(21) AND B(10)) OR 
		 (FF(5)  AND B(11)) OR 
		 (FF(21) AND B(12)) OR 
           (FG(5)  AND B(13)) OR 
		 (FG(21) AND B(14)) OR
		 (FH(5)  AND B(15)) OR 
		 (FH(21) AND B(16)) OR
		 (FI(5)  AND B(17)) OR
		 (FI(21) AND B(18))) AND NOT SWITCH) OR
		 (((FA(5) AND CONB(1)) OR
		 (FA(21) AND CONB(2)) OR
		 (FB(5) AND CONB(3)) OR
		 (FB(21) AND CONB(4)) OR
		 (FC(5) AND CONB(5)) OR
		 (FC(21) AND CONB(6)) OR
		 (FD(5) AND CONB(7)) OR
		 (FD(21) AND CONB(8)) OR
		 (FE(5) AND CONB(9)) OR
		 (FE(21) AND CONB(10)) OR
		 (FF(5) AND CONB(11)) OR
		 (FF(21) AND CONB(12)) OR
		 (FG(5) AND CONB(13)) OR
		 (FG(21) AND CONB(14)) OR
		 (FH(5) AND CONB(15)) OR
		 (FH(21) AND CONB(16)) OR
		 (FI(5) AND CONB(17)) OR
		 (FI(21) AND CONB(18))) AND SWITCH); 

OUTB(6) <= (((FA(6)  AND B(1))  OR 
           (FA(22) AND B(2))  OR 
		 (FB(6)  AND B(3))  OR 
		 (FB(22) AND B(4))  OR
		 (FC(6)  AND B(5))  OR 
		 (FC(22) AND B(6))  OR 
		 (FD(6)  AND B(7))  OR 
		 (FD(22) AND B(8))  OR
           (FE(6)  AND B(9))  OR 
		 (FE(22) AND B(10)) OR 
		 (FF(6)  AND B(11)) OR 
		 (FF(22) AND B(12)) OR 
           (FG(6)  AND B(13)) OR 
		 (FG(22) AND B(14)) OR
		 (FH(6)  AND B(15)) OR 
		 (FH(22) AND B(16)) OR
		 (FI(6)  AND B(17)) OR
		 (FI(22) AND B(18))) AND NOT SWITCH) OR
		 (((FA(6) AND CONB(1)) OR
		 (FA(22) AND CONB(2)) OR
		 (FB(6) AND CONB(3)) OR
		 (FB(22) AND CONB(4)) OR
		 (FC(6) AND CONB(5)) OR
		 (FC(22) AND CONB(6)) OR
		 (FD(6) AND CONB(7)) OR
		 (FD(22) AND CONB(8)) OR
		 (FE(6) AND CONB(9)) OR
		 (FE(22) AND CONB(10)) OR
		 (FF(6) AND CONB(11)) OR
		 (FF(22) AND CONB(12)) OR
		 (FG(6) AND CONB(13)) OR
		 (FG(22) AND CONB(14)) OR
		 (FH(6) AND CONB(15)) OR
		 (FH(22) AND CONB(16)) OR
		 (FI(6) AND CONB(17)) OR
		 (FI(22) AND CONB(18))) AND SWITCH); 

OUTB(7) <= (((FA(7)  AND B(1))  OR 
           (FA(23) AND B(2))  OR 
		 (FB(7)  AND B(3))  OR 
		 (FB(23) AND B(4))  OR
		 (FC(7)  AND B(5))  OR 
		 (FC(23) AND B(6))  OR 
		 (FD(7)  AND B(7))  OR 
		 (FD(23) AND B(8))  OR
           (FE(7)  AND B(9))  OR 
		 (FE(23) AND B(10)) OR 
		 (FF(7)  AND B(11)) OR 
		 (FF(23) AND B(12)) OR 
           (FG(7)  AND B(13)) OR 
		 (FG(23) AND B(14)) OR
		 (FH(7)  AND B(15)) OR 
		 (FH(23) AND B(16)) OR
		 (FI(7)  AND B(17)) OR
		 (FI(23) AND B(18))) AND NOT SWITCH) OR
		 (((FA(7) AND CONB(1)) OR
		 (FA(23) AND CONB(2)) OR
		 (FB(7) AND CONB(3)) OR
		 (FB(23) AND CONB(4)) OR
		 (FC(7) AND CONB(5)) OR
		 (FC(23) AND CONB(6)) OR
		 (FD(7) AND CONB(7)) OR
		 (FD(23) AND CONB(8)) OR
		 (FE(7) AND CONB(9)) OR
		 (FE(23) AND CONB(10)) OR
		 (FF(7) AND CONB(11)) OR
		 (FF(23) AND CONB(12)) OR
		 (FG(7) AND CONB(13)) OR
		 (FG(23) AND CONB(14)) OR
		 (FH(7) AND CONB(15)) OR
		 (FH(23) AND CONB(16)) OR
		 (FI(7) AND CONB(17)) OR
		 (FI(23) AND CONB(18))) AND SWITCH); 

OUTB(8) <= (((FA(8)  AND B(1))  OR 
           (FA(24) AND B(2))  OR 
		 (FB(8)  AND B(3))  OR 
		 (FB(24) AND B(4))  OR
		 (FC(8)  AND B(5))  OR 
		 (FC(24) AND B(6))  OR 
		 (FD(8)  AND B(7))  OR 
		 (FD(24) AND B(8))  OR
           (FE(8)  AND B(9))  OR 
		 (FE(24) AND B(10)) OR 
		 (FF(8)  AND B(11)) OR 
		 (FF(24) AND B(12)) OR 
           (FG(8)  AND B(13)) OR 
		 (FG(24) AND B(14)) OR
		 (FH(8)  AND B(15)) OR 
		 (FH(24) AND B(16)) OR
		 (FI(8)  AND B(17)) OR
		 (FI(24) AND B(18))) AND NOT SWITCH) OR
		 (((FA(8) AND CONB(1)) OR
		 (FA(24) AND CONB(2)) OR
		 (FB(8) AND CONB(3)) OR
		 (FB(24) AND CONB(4)) OR
		 (FC(8) AND CONB(5)) OR
		 (FC(24) AND CONB(6)) OR
		 (FD(8) AND CONB(7)) OR
		 (FD(24) AND CONB(8)) OR
		 (FE(8) AND CONB(9)) OR
		 (FE(24) AND CONB(10)) OR
		 (FF(8) AND CONB(11)) OR
		 (FF(24) AND CONB(12)) OR
		 (FG(8) AND CONB(13)) OR
		 (FG(24) AND CONB(14)) OR
		 (FH(8) AND CONB(15)) OR
		 (FH(24) AND CONB(16)) OR
		 (FI(8) AND CONB(17)) OR
		 (FI(24) AND CONB(18))) AND SWITCH); 

OUTB(9) <= (((FA(9)  AND B(1))  OR 
           (FA(25) AND B(2))  OR 
		 (FB(9)  AND B(3))  OR 
		 (FB(25) AND B(4))  OR
		 (FC(9)  AND B(5))  OR 
		 (FC(25) AND B(6))  OR 
		 (FD(9)  AND B(7))  OR 
		 (FD(25) AND B(8))  OR
           (FE(9)  AND B(9))  OR 
		 (FE(25) AND B(10)) OR 
		 (FF(9)  AND B(11)) OR 
		 (FF(25) AND B(12)) OR 
           (FG(9)  AND B(13)) OR 
		 (FG(25) AND B(14)) OR
		 (FH(9)  AND B(15)) OR 
		 (FH(25) AND B(16)) OR
		 (FI(9)  AND B(17)) OR
		 (FI(25) AND B(18))) AND NOT SWITCH) OR
		 (((FA(9) AND CONB(1)) OR
		 (FA(25) AND CONB(2)) OR
		 (FB(9) AND CONB(3)) OR
		 (FB(25) AND CONB(4)) OR
		 (FC(9) AND CONB(5)) OR
		 (FC(25) AND CONB(6)) OR
		 (FD(9) AND CONB(7)) OR
		 (FD(25) AND CONB(8)) OR
		 (FE(9) AND CONB(9)) OR
		 (FE(25) AND CONB(10)) OR
		 (FF(9) AND CONB(11)) OR
		 (FF(25) AND CONB(12)) OR
		 (FG(9) AND CONB(13)) OR
		 (FG(25) AND CONB(14)) OR
		 (FH(9) AND CONB(15)) OR
		 (FH(25) AND CONB(16)) OR
		 (FI(9) AND CONB(17)) OR
		 (FI(25) AND CONB(18))) AND SWITCH); 

OUTB(10) <= (((FA(10)  AND B(1))  OR 
           (FA(26) AND B(2))  OR 
		 (FB(10) AND B(3))  OR 
		 (FB(26) AND B(4))  OR
		 (FC(10) AND B(5))  OR 
		 (FC(26) AND B(6))  OR 
		 (FD(10) AND B(7))  OR 
		 (FD(26) AND B(8))  OR
           (FE(10) AND B(9))  OR 
		 (FE(26) AND B(10)) OR 
		 (FF(10) AND B(11)) OR 
		 (FF(26) AND B(12)) OR 
           (FG(10) AND B(13)) OR 
		 (FG(26) AND B(14)) OR
		 (FH(10) AND B(15)) OR 
		 (FH(26) AND B(16)) OR
		 (FI(10) AND B(17)) OR
		 (FI(26) AND B(18))) AND NOT SWITCH) OR
		 (((FA(10) AND CONB(1)) OR
		 (FA(26) AND CONB(2)) OR
		 (FB(10) AND CONB(3)) OR
		 (FB(26) AND CONB(4)) OR
		 (FC(10) AND CONB(5)) OR
		 (FC(26) AND CONB(6)) OR
		 (FD(10) AND CONB(7)) OR
		 (FD(26) AND CONB(8)) OR
		 (FE(10) AND CONB(9)) OR
		 (FE(26) AND CONB(10)) OR
		 (FF(10) AND CONB(11)) OR
		 (FF(26) AND CONB(12)) OR
		 (FG(10) AND CONB(13)) OR
		 (FG(26) AND CONB(14)) OR
		 (FH(10) AND CONB(15)) OR
		 (FH(26) AND CONB(16)) OR
		 (FI(10) AND CONB(17)) OR
		 (FI(26) AND CONB(18))) AND SWITCH); 

OUTB(11) <= (((FA(11)  AND B(1))  OR 
           (FA(27) AND B(2))  OR 
		 (FB(11) AND B(3))  OR 
		 (FB(27) AND B(4))  OR
		 (FC(11) AND B(5))  OR 
		 (FC(27) AND B(6))  OR 
		 (FD(11) AND B(7))  OR 
		 (FD(27) AND B(8))  OR
           (FE(11) AND B(9))  OR 
		 (FE(27) AND B(10)) OR 
		 (FF(11) AND B(11)) OR 
		 (FF(27) AND B(12)) OR 
           (FG(11) AND B(13)) OR 
		 (FG(27) AND B(14)) OR
		 (FH(11) AND B(15)) OR 
		 (FH(27) AND B(16)) OR
		 (FI(11) AND B(17)) OR
		 (FI(27) AND B(18))) AND NOT SWITCH) OR
		 (((FA(11) AND CONB(1)) OR
		 (FA(27) AND CONB(2)) OR
		 (FB(11) AND CONB(3)) OR
		 (FB(27) AND CONB(4)) OR
		 (FC(11) AND CONB(5)) OR
		 (FC(27) AND CONB(6)) OR
		 (FD(11) AND CONB(7)) OR
		 (FD(27) AND CONB(8)) OR
		 (FE(11) AND CONB(9)) OR
		 (FE(27) AND CONB(10)) OR
		 (FF(11) AND CONB(11)) OR
		 (FF(27) AND CONB(12)) OR
		 (FG(11) AND CONB(13)) OR
		 (FG(27) AND CONB(14)) OR
		 (FH(11) AND CONB(15)) OR
		 (FH(27) AND CONB(16)) OR
		 (FI(11) AND CONB(17)) OR
		 (FI(27) AND CONB(18))) AND SWITCH); 

OUTB(12) <= (((FA(12) AND B(1))  OR 
           (FA(28) AND B(2))  OR 
		 (FB(12) AND B(3))  OR 
		 (FB(28) AND B(4))  OR
		 (FC(12) AND B(5))  OR 
		 (FC(28) AND B(6))  OR 
		 (FD(12) AND B(7))  OR 
		 (FD(28) AND B(8))  OR
           (FE(12) AND B(9))  OR 
		 (FE(28) AND B(10)) OR 
		 (FF(12) AND B(11)) OR 
		 (FF(28) AND B(12)) OR 
           (FG(12) AND B(13)) OR 
		 (FG(28) AND B(14)) OR
		 (FH(12) AND B(15)) OR 
		 (FH(28) AND B(16)) OR
		 (FI(12) AND B(17)) OR
		 (FI(28) AND B(18))) AND NOT SWITCH) OR
		 (((FA(12) AND CONB(1)) OR
		 (FA(28) AND CONB(2)) OR
		 (FB(12) AND CONB(3)) OR
		 (FB(28) AND CONB(4)) OR
		 (FC(12) AND CONB(5)) OR
		 (FC(28) AND CONB(6)) OR
		 (FD(12) AND CONB(7)) OR
		 (FD(28) AND CONB(8)) OR
		 (FE(12) AND CONB(9)) OR
		 (FE(28) AND CONB(10)) OR
		 (FF(12) AND CONB(11)) OR
		 (FF(28) AND CONB(12)) OR
		 (FG(12) AND CONB(13)) OR
		 (FG(28) AND CONB(14)) OR
		 (FH(12) AND CONB(15)) OR
		 (FH(28) AND CONB(16)) OR
		 (FI(12) AND CONB(17)) OR
		 (FI(28) AND CONB(18))) AND SWITCH); 

OUTB(13) <= (((FA(13) AND B(1))  OR 
           (FA(29) AND B(2))  OR 
		 (FB(13) AND B(3))  OR 
		 (FB(29) AND B(4))  OR
		 (FC(13) AND B(5))  OR 
		 (FC(29) AND B(6))  OR 
		 (FD(13) AND B(7))  OR 
		 (FD(29) AND B(8))  OR
           (FE(13) AND B(9))  OR 
		 (FE(29) AND B(10)) OR 
		 (FF(13) AND B(11)) OR 
		 (FF(29) AND B(12)) OR 
           (FG(13) AND B(13)) OR 
		 (FG(29) AND B(14)) OR
		 (FH(13) AND B(15)) OR 
		 (FH(29) AND B(16)) OR
		 (FI(13) AND B(17)) OR
		 (FI(29) AND B(18))) AND NOT SWITCH) OR
		 (((FA(13) AND CONB(1)) OR
		 (FA(29) AND CONB(2)) OR
		 (FB(13) AND CONB(3)) OR
		 (FB(29) AND CONB(4)) OR
		 (FC(13) AND CONB(5)) OR
		 (FC(29) AND CONB(6)) OR
		 (FD(13) AND CONB(7)) OR
		 (FD(29) AND CONB(8)) OR
		 (FE(13) AND CONB(9)) OR
		 (FE(29) AND CONB(10)) OR
		 (FF(13) AND CONB(11)) OR
		 (FF(29) AND CONB(12)) OR
		 (FG(13) AND CONB(13)) OR
		 (FG(29) AND CONB(14)) OR
		 (FH(13) AND CONB(15)) OR
		 (FH(29) AND CONB(16)) OR
		 (FI(13) AND CONB(17)) OR
		 (FI(29) AND CONB(18))) AND SWITCH); 

OUTB(14) <= (((FA(14) AND B(1))  OR 
           (FA(30) AND B(2))  OR 
		 (FB(14) AND B(3))  OR 
		 (FB(30) AND B(4))  OR
		 (FC(14) AND B(5))  OR 
		 (FC(30) AND B(6))  OR 
		 (FD(14) AND B(7))  OR 
		 (FD(30) AND B(8))  OR
           (FE(14) AND B(9))  OR 
		 (FE(30) AND B(10)) OR 
		 (FF(14) AND B(11)) OR 
		 (FF(30) AND B(12)) OR 
           (FG(14) AND B(13)) OR 
		 (FG(30) AND B(14)) OR
		 (FH(14) AND B(15)) OR 
		 (FH(30) AND B(16)) OR
		 (FI(14) AND B(17)) OR
		 (FI(30) AND B(18))) AND NOT SWITCH) OR
		 (((FA(14) AND CONB(1)) OR
		 (FA(30) AND CONB(2)) OR
		 (FB(14) AND CONB(3)) OR
		 (FB(30) AND CONB(4)) OR
		 (FC(14) AND CONB(5)) OR
		 (FC(30) AND CONB(6)) OR
		 (FD(14) AND CONB(7)) OR
		 (FD(30) AND CONB(8)) OR
		 (FE(14) AND CONB(9)) OR
		 (FE(30) AND CONB(10)) OR
		 (FF(14) AND CONB(11)) OR
		 (FF(30) AND CONB(12)) OR
		 (FG(14) AND CONB(13)) OR
		 (FG(30) AND CONB(14)) OR
		 (FH(14) AND CONB(15)) OR
		 (FH(30) AND CONB(16)) OR
		 (FI(14) AND CONB(17)) OR
		 (FI(30) AND CONB(18))) AND SWITCH); 

OUTB(15) <= (((FA(15) AND B(1))  OR 
           (FA(31) AND B(2))  OR 
		 (FB(15) AND B(3))  OR 
		 (FB(31) AND B(4))  OR
		 (FC(15) AND B(5))  OR 
		 (FC(31) AND B(6))  OR 
		 (FD(15) AND B(7))  OR 
		 (FD(31) AND B(8))  OR
           (FE(15) AND B(9))  OR 
		 (FE(31) AND B(10)) OR 
		 (FF(15) AND B(11)) OR 
		 (FF(31) AND B(12)) OR 
           (FG(15) AND B(13)) OR 
		 (FG(31) AND B(14)) OR
		 (FH(15) AND B(15)) OR 
		 (FH(31) AND B(16)) OR
		 (FI(15) AND B(17)) OR
		 (FI(31) AND B(18))) AND NOT SWITCH) OR
		 (((FA(15) AND CONB(1)) OR
		 (FA(31) AND CONB(2)) OR
		 (FB(15) AND CONB(3)) OR
		 (FB(31) AND CONB(4)) OR
		 (FC(15) AND CONB(5)) OR
		 (FC(31) AND CONB(6)) OR
		 (FD(15) AND CONB(7)) OR
		 (FD(31) AND CONB(8)) OR
		 (FE(15) AND CONB(9)) OR
		 (FE(31) AND CONB(10)) OR
		 (FF(15) AND CONB(11)) OR
		 (FF(31) AND CONB(12)) OR
		 (FG(15) AND CONB(13)) OR
		 (FG(31) AND CONB(14)) OR
		 (FH(15) AND CONB(15)) OR
		 (FH(31) AND CONB(16)) OR
		 (FI(15) AND CONB(17)) OR
		 (FI(31) AND CONB(18))) AND SWITCH); 

OUTB(16) <= (((SA(0) AND B(1))  OR 
           (SA(16) AND B(2))  OR 
		 (SB(0)  AND B(3))  OR 
		 (SB(16) AND B(4))  OR
		 (SC(0)  AND B(5))  OR 
		 (SC(16) AND B(6))  OR 
		 (SD(0)  AND B(7))  OR 
		 (SD(16) AND B(8))  OR
           (SE(0)  AND B(9))  OR 
		 (SE(16) AND B(10)) OR 
		 (SF(0)  AND B(11)) OR 
		 (SF(16) AND B(12)) OR 
           (SG(0)  AND B(13)) OR 
		 (SG(16) AND B(14)) OR
		 (SH(0)  AND B(15)) OR 
		 (SH(16) AND B(16)) OR
		 (SI(0)  AND B(17)) OR
		 (SI(16) AND B(18))) AND NOT SWITCH) OR
		 (((SA(0) AND CONB(1)) OR
		 (SA(16) AND CONB(2)) OR
		 (SB(0) AND CONB(3)) OR
		 (SB(16) AND CONB(4)) OR
		 (SC(0) AND CONB(5)) OR
		 (SC(16) AND CONB(6)) OR
		 (SD(0) AND CONB(7)) OR
		 (SD(16) AND CONB(8)) OR
		 (SE(0) AND CONB(9)) OR
		 (SE(16) AND CONB(10)) OR
		 (SF(0) AND CONB(11)) OR
		 (SF(16) AND CONB(12)) OR
		 (SG(0) AND CONB(13)) OR
		 (SG(16) AND CONB(14)) OR
		 (SH(0) AND CONB(15)) OR
		 (SH(16) AND CONB(16)) OR
		 (SI(0) AND CONB(17)) OR
		 (SI(16) AND CONB(18))) AND SWITCH); 

OUTB(17) <= (((SA(1)  AND B(1))  OR 
           (SA(17) AND B(2))  OR 
		 (SB(1)  AND B(3))  OR 
		 (SB(17) AND B(4))  OR
		 (SC(1)  AND B(5))  OR 
		 (SC(17) AND B(6))  OR 
		 (SD(1)  AND B(7))  OR 
		 (SD(17) AND B(8))  OR
           (SE(1)  AND B(9))  OR 
		 (SE(17) AND B(10)) OR 
		 (SF(1)  AND B(11)) OR 
		 (SF(17) AND B(12)) OR 
           (SG(1)  AND B(13)) OR 
		 (SG(17) AND B(14)) OR
		 (SH(1)  AND B(15)) OR 
		 (SH(17) AND B(16)) OR
		 (SI(1)  AND B(17)) OR
		 (SI(17) AND B(18))) AND NOT SWITCH) OR
		 (((SA(1) AND CONB(1)) OR
		 (SA(17) AND CONB(2)) OR
		 (SB(1) AND CONB(3)) OR
		 (SB(17) AND CONB(4)) OR
		 (SC(1) AND CONB(5)) OR
		 (SC(17) AND CONB(6)) OR
		 (SD(1) AND CONB(7)) OR
		 (SD(17) AND CONB(8)) OR
		 (SE(1) AND CONB(9)) OR
		 (SE(17) AND CONB(10)) OR
		 (SF(1) AND CONB(11)) OR
		 (SF(17) AND CONB(12)) OR
		 (SG(1) AND CONB(13)) OR
		 (SG(17) AND CONB(14)) OR
		 (SH(1) AND CONB(15)) OR
		 (SH(17) AND CONB(16)) OR
		 (SI(1) AND CONB(17)) OR
		 (SI(17) AND CONB(18))) AND SWITCH); 

OUTB(18) <= (((SA(2)  AND B(1))  OR 
           (SA(18) AND B(2))  OR 
		 (SB(2)  AND B(3))  OR 
		 (SB(18) AND B(4))  OR
		 (SC(2)  AND B(5))  OR 
		 (SC(18) AND B(6))  OR 
		 (SD(2)  AND B(7))  OR 
		 (SD(18) AND B(8))  OR
           (SE(2)  AND B(9))  OR 
		 (SE(18) AND B(10)) OR 
		 (SF(2)  AND B(11)) OR 
		 (SF(18) AND B(12)) OR 
           (SG(2)  AND B(13)) OR 
		 (SG(18) AND B(14)) OR
		 (SH(2)  AND B(15)) OR 
		 (SH(18) AND B(16)) OR
		 (SI(2)  AND B(17)) OR
		 (SI(18) AND B(18))) AND NOT SWITCH) OR
		 (((SA(2) AND CONB(1)) OR
		 (SA(18) AND CONB(2)) OR
		 (SB(2) AND CONB(3)) OR
		 (SB(18) AND CONB(4)) OR
		 (SC(2) AND CONB(5)) OR
		 (SC(18) AND CONB(6)) OR
		 (SD(2) AND CONB(7)) OR
		 (SD(18) AND CONB(8)) OR
		 (SE(2) AND CONB(9)) OR
		 (SE(18) AND CONB(10)) OR
		 (SF(2) AND CONB(11)) OR
		 (SF(18) AND CONB(12)) OR
		 (SG(2) AND CONB(13)) OR
		 (SG(18) AND CONB(14)) OR
		 (SH(2) AND CONB(15)) OR
		 (SH(18) AND CONB(16)) OR
		 (SI(2) AND CONB(17)) OR
		 (SI(18) AND CONB(18))) AND SWITCH); 

OUTB(19) <= (((SA(3)  AND B(1))  OR 
           (SA(19) AND B(2))  OR 
		 (SB(3)  AND B(3))  OR 
		 (SB(19) AND B(4))  OR
		 (SC(3)  AND B(5))  OR 
		 (SC(19) AND B(6))  OR 
		 (SD(3)  AND B(7))  OR 
		 (SD(19) AND B(8))  OR
           (SE(3)  AND B(9))  OR 
		 (SE(19) AND B(10)) OR 
		 (SF(3)  AND B(11)) OR 
		 (SF(19) AND B(12)) OR 
           (SG(3)  AND B(13)) OR 
		 (SG(19) AND B(14)) OR
		 (SH(3)  AND B(15)) OR 
		 (SH(19) AND B(16)) OR
		 (SI(3)  AND B(17)) OR
		 (SI(19) AND B(18))) AND NOT SWITCH) OR
		 (((SA(3) AND CONB(1)) OR
		 (SA(19) AND CONB(2)) OR
		 (SB(3) AND CONB(3)) OR
		 (SB(19) AND CONB(4)) OR
		 (SC(3) AND CONB(5)) OR
		 (SC(19) AND CONB(6)) OR
		 (SD(3) AND CONB(7)) OR
		 (SD(19) AND CONB(8)) OR
		 (SE(3) AND CONB(9)) OR
		 (SE(19) AND CONB(10)) OR
		 (SF(3) AND CONB(11)) OR
		 (SF(19) AND CONB(12)) OR
		 (SG(3) AND CONB(13)) OR
		 (SG(19) AND CONB(14)) OR
		 (SH(3) AND CONB(15)) OR
		 (SH(19) AND CONB(16)) OR
		 (SI(3) AND CONB(17)) OR
		 (SI(19) AND CONB(18))) AND SWITCH); 


OUTB(20) <= (((SA(4)  AND B(1))  OR 
           (SA(20) AND B(2))  OR 
		 (SB(4)  AND B(3))  OR 
		 (SB(20) AND B(4))  OR
		 (SC(4)  AND B(5))  OR 
		 (SC(20) AND B(6))  OR 
		 (SD(4)  AND B(7))  OR 
		 (SD(20) AND B(8))  OR
           (SE(4)  AND B(9))  OR 
		 (SE(20) AND B(10)) OR 
		 (SF(4)  AND B(11)) OR 
		 (SF(20) AND B(12)) OR 
           (SG(4)  AND B(13)) OR 
		 (SG(20) AND B(14)) OR
		 (SH(4)  AND B(15)) OR 
		 (SH(20) AND B(16)) OR
		 (SI(4)  AND B(17)) OR
		 (SI(20) AND B(18))) AND NOT SWITCH) OR
		 (((SA(4) AND CONB(1)) OR
		 (SA(20) AND CONB(2)) OR
		 (SB(4) AND CONB(3)) OR
		 (SB(20) AND CONB(4)) OR
		 (SC(4) AND CONB(5)) OR
		 (SC(20) AND CONB(6)) OR
		 (SD(4) AND CONB(7)) OR
		 (SD(20) AND CONB(8)) OR
		 (SE(4) AND CONB(9)) OR
		 (SE(20) AND CONB(10)) OR
		 (SF(4) AND CONB(11)) OR
		 (SF(20) AND CONB(12)) OR
		 (SG(4) AND CONB(13)) OR
		 (SG(20) AND CONB(14)) OR
		 (SH(4) AND CONB(15)) OR
		 (SH(20) AND CONB(16)) OR
		 (SI(4) AND CONB(17)) OR
		 (SI(20) AND CONB(18))) AND SWITCH); 

OUTB(21) <= (((SA(5)  AND B(1))  OR 
           (SA(21) AND B(2))  OR 
		 (SB(5)  AND B(3))  OR 
		 (SB(21) AND B(4))  OR
		 (SC(5)  AND B(5))  OR 
		 (SC(21) AND B(6))  OR 
		 (SD(5)  AND B(7))  OR 
		 (SD(21) AND B(8))  OR
           (SE(5)  AND B(9))  OR 
		 (SE(21) AND B(10)) OR 
		 (SF(5)  AND B(11)) OR 
		 (SF(21) AND B(12)) OR 
           (SG(5)  AND B(13)) OR 
		 (SG(21) AND B(14)) OR
		 (SH(5)  AND B(15)) OR 
		 (SH(21) AND B(16)) OR
		 (SI(5)  AND B(17)) OR
		 (SI(21) AND B(18))) AND NOT SWITCH) OR
		 (((SA(5) AND CONB(1)) OR
		 (SA(21) AND CONB(2)) OR
		 (SB(5) AND CONB(3)) OR
		 (SB(21) AND CONB(4)) OR
		 (SC(5) AND CONB(5)) OR
		 (SC(21) AND CONB(6)) OR
		 (SD(5) AND CONB(7)) OR
		 (SD(21) AND CONB(8)) OR
		 (SE(5) AND CONB(9)) OR
		 (SE(21) AND CONB(10)) OR
		 (SF(5) AND CONB(11)) OR
		 (SF(21) AND CONB(12)) OR
		 (SG(5) AND CONB(13)) OR
		 (SG(21) AND CONB(14)) OR
		 (SH(5) AND CONB(15)) OR
		 (SH(21) AND CONB(16)) OR
		 (SI(5) AND CONB(17)) OR
		 (SI(21) AND CONB(18))) AND SWITCH); 

OUTB(22) <= (((SA(6)  AND B(1))  OR 
           (SA(22) AND B(2))  OR 
		 (SB(6)  AND B(3))  OR 
		 (SB(22) AND B(4))  OR
		 (SC(6)  AND B(5))  OR 
		 (SC(22) AND B(6))  OR 
		 (SD(6)  AND B(7))  OR 
		 (SD(22) AND B(8))  OR
           (SE(6)  AND B(9))  OR 
		 (SE(22) AND B(10)) OR 
		 (SF(6)  AND B(11)) OR 
		 (SF(22) AND B(12)) OR 
           (SG(6)  AND B(13)) OR 
		 (SG(22) AND B(14)) OR
		 (SH(6)  AND B(15)) OR 
		 (SH(22) AND B(16)) OR
		 (SI(6)  AND B(17)) OR
		 (SI(22) AND B(18))) AND NOT SWITCH) OR
		 (((SA(6) AND CONB(1)) OR
		 (SA(22) AND CONB(2)) OR
		 (SB(6) AND CONB(3)) OR
		 (SB(22) AND CONB(4)) OR
		 (SC(6) AND CONB(5)) OR
		 (SC(22) AND CONB(6)) OR
		 (SD(6) AND CONB(7)) OR
		 (SD(22) AND CONB(8)) OR
		 (SE(6) AND CONB(9)) OR
		 (SE(22) AND CONB(10)) OR
		 (SF(6) AND CONB(11)) OR
		 (SF(22) AND CONB(12)) OR
		 (SG(6) AND CONB(13)) OR
		 (SG(22) AND CONB(14)) OR
		 (SH(6) AND CONB(15)) OR
		 (SH(22) AND CONB(16)) OR
		 (SI(6) AND CONB(17)) OR
		 (SI(22) AND CONB(18))) AND SWITCH); 

OUTB(23) <= (((SA(7)  AND B(1))  OR 
           (SA(23) AND B(2))  OR 
		 (SB(7)  AND B(3))  OR 
		 (SB(23) AND B(4))  OR
		 (SC(7)  AND B(5))  OR 
		 (SC(23) AND B(6))  OR 
		 (SD(7)  AND B(7))  OR 
		 (SD(23) AND B(8))  OR
           (SE(7)  AND B(9))  OR 
		 (SE(23) AND B(10)) OR 
		 (SF(7)  AND B(11)) OR 
		 (SF(23) AND B(12)) OR 
           (SG(7)  AND B(13)) OR 
		 (SG(23) AND B(14)) OR
		 (SH(7)  AND B(15)) OR 
		 (SH(23) AND B(16)) OR
		 (SI(7)  AND B(17)) OR
		 (SI(23) AND B(18))) AND NOT SWITCH) OR
		 (((SA(7) AND CONB(1)) OR
		 (SA(23) AND CONB(2)) OR
		 (SB(7) AND CONB(3)) OR
		 (SB(23) AND CONB(4)) OR
		 (SC(7) AND CONB(5)) OR
		 (SC(23) AND CONB(6)) OR
		 (SD(7) AND CONB(7)) OR
		 (SD(23) AND CONB(8)) OR
		 (SE(7) AND CONB(9)) OR
		 (SE(23) AND CONB(10)) OR
		 (SF(7) AND CONB(11)) OR
		 (SF(23) AND CONB(12)) OR
		 (SG(7) AND CONB(13)) OR
		 (SG(23) AND CONB(14)) OR
		 (SH(7) AND CONB(15)) OR
		 (SH(23) AND CONB(16)) OR
		 (SI(7) AND CONB(17)) OR
		 (SI(23) AND CONB(18))) AND SWITCH); 

OUTB(24) <= (((SA(8)  AND B(1))  OR 
           (SA(24) AND B(2))  OR 
		 (SB(8)  AND B(3))  OR 
		 (SB(24) AND B(4))  OR
		 (SC(8)  AND B(5))  OR 
		 (SC(24) AND B(6))  OR 
		 (SD(8)  AND B(7))  OR 
		 (SD(24) AND B(8))  OR
           (SE(8)  AND B(9))  OR 
		 (SE(24) AND B(10)) OR 
		 (SF(8)  AND B(11)) OR 
		 (SF(24) AND B(12)) OR 
           (SG(8)  AND B(13)) OR 
		 (SG(24) AND B(14)) OR
		 (SH(8)  AND B(15)) OR 
		 (SH(24) AND B(16)) OR
		 (SI(8)  AND B(17)) OR
		 (SI(24) AND B(18))) AND NOT SWITCH) OR
		 (((SA(8) AND CONB(1)) OR
		 (SA(24) AND CONB(2)) OR
		 (SB(8) AND CONB(3)) OR
		 (SB(24) AND CONB(4)) OR
		 (SC(8) AND CONB(5)) OR
		 (SC(24) AND CONB(6)) OR
		 (SD(8) AND CONB(7)) OR
		 (SD(24) AND CONB(8)) OR
		 (SE(8) AND CONB(9)) OR
		 (SE(24) AND CONB(10)) OR
		 (SF(8) AND CONB(11)) OR
		 (SF(24) AND CONB(12)) OR
		 (SG(8) AND CONB(13)) OR
		 (SG(24) AND CONB(14)) OR
		 (SH(8) AND CONB(15)) OR
		 (SH(24) AND CONB(16)) OR
		 (SI(8) AND CONB(17)) OR
		 (SI(24) AND CONB(18))) AND SWITCH); 

OUTB(25) <= (((SA(9)  AND B(1))  OR 
           (SA(25) AND B(2))  OR 
		 (SB(9)  AND B(3))  OR 
		 (SB(25) AND B(4))  OR
		 (SC(9)  AND B(5))  OR 
		 (SC(25) AND B(6))  OR 
		 (SD(9)  AND B(7))  OR 
		 (SD(25) AND B(8))  OR
           (SE(9)  AND B(9))  OR 
		 (SE(25) AND B(10)) OR 
		 (SF(9)  AND B(11)) OR 
		 (SF(25) AND B(12)) OR 
           (SG(9)  AND B(13)) OR 
		 (SG(25) AND B(14)) OR
		 (SH(9)  AND B(15)) OR 
		 (SH(25) AND B(16)) OR
		 (SI(9)  AND B(17)) OR
		 (SI(25) AND B(18))) AND NOT SWITCH) OR
		 (((SA(9) AND CONB(1)) OR
		 (SA(25) AND CONB(2)) OR
		 (SB(9) AND CONB(3)) OR
		 (SB(25) AND CONB(4)) OR
		 (SC(9) AND CONB(5)) OR
		 (SC(25) AND CONB(6)) OR
		 (SD(9) AND CONB(7)) OR
		 (SD(25) AND CONB(8)) OR
		 (SE(9) AND CONB(9)) OR
		 (SE(25) AND CONB(10)) OR
		 (SF(9) AND CONB(11)) OR
		 (SF(25) AND CONB(12)) OR
		 (SG(9) AND CONB(13)) OR
		 (SG(25) AND CONB(14)) OR
		 (SH(9) AND CONB(15)) OR
		 (SH(25) AND CONB(16)) OR
		 (SI(9) AND CONB(17)) OR
		 (SI(25) AND CONB(18))) AND SWITCH); 

OUTB(26) <= (((SA(10)  AND B(1))  OR 
           (SA(26) AND B(2))  OR 
		 (SB(10) AND B(3))  OR 
		 (SB(26) AND B(4))  OR
		 (SC(10) AND B(5))  OR 
		 (SC(26) AND B(6))  OR 
		 (SD(10) AND B(7))  OR 
		 (SD(26) AND B(8))  OR
           (SE(10) AND B(9))  OR 
		 (SE(26) AND B(10)) OR 
		 (SF(10) AND B(11)) OR 
		 (SF(26) AND B(12)) OR 
           (SG(10) AND B(13)) OR 
		 (SG(26) AND B(14)) OR
		 (SH(10) AND B(15)) OR 
		 (SH(26) AND B(16)) OR
		 (SI(10) AND B(17)) OR
		 (SI(26) AND B(18))) AND NOT SWITCH) OR
		 (((SA(10) AND CONB(1)) OR
		 (SA(26) AND CONB(2)) OR
		 (SB(10) AND CONB(3)) OR
		 (SB(26) AND CONB(4)) OR
		 (SC(10) AND CONB(5)) OR
		 (SC(26) AND CONB(6)) OR
		 (SD(10) AND CONB(7)) OR
		 (SD(26) AND CONB(8)) OR
		 (SE(10) AND CONB(9)) OR
		 (SE(26) AND CONB(10)) OR
		 (SF(10) AND CONB(11)) OR
		 (SF(26) AND CONB(12)) OR
		 (SG(10) AND CONB(13)) OR
		 (SG(26) AND CONB(14)) OR
		 (SH(10) AND CONB(15)) OR
		 (SH(26) AND CONB(16)) OR
		 (SI(10) AND CONB(17)) OR
		 (SI(26) AND CONB(18))) AND SWITCH); 

OUTB(27) <= ((SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27))  AND NOT SWITCH) OR
		 (((SA(11) AND CONB(1)) OR
		 (SA(27) AND CONB(2)) OR
		 (SB(11) AND CONB(3)) OR
		 (SB(27) AND CONB(4)) OR
		 (SC(11) AND CONB(5)) OR
		 (SC(27) AND CONB(6)) OR
		 (SD(11) AND CONB(7)) OR
		 (SD(27) AND CONB(8)) OR
		 (SE(11) AND CONB(9)) OR
		 (SE(27) AND CONB(10)) OR
   	 (SF(11) AND CONB(11)) OR
		 (SF(27) AND CONB(12)) OR
		 (SG(11) AND CONB(13)) OR
		 (SG(27) AND CONB(14)) OR
		 (SH(11) AND CONB(15)) OR
		 (SH(27) AND CONB(16)) OR
		 (SI(11) AND CONB(17)) OR
		 (SI(27) AND CONB(18))) AND SWITCH); 

--OUTB(27) <= (((SA(11) AND B(1)) OR 
--       (SA(27) AND B(2))   OR 
--		 (SB(11) AND B(3))   OR 
--		 (SB(27) AND B(4))   OR
--		 (SC(11) AND B(5))   OR 
--		 (SC(27) AND B(6))   OR 
--		 (SD(11) AND B(7))  OR 
--		 (SD(27) AND B(8))  OR
--       (SE(11) AND B(9))  OR 
--		 (SE(27) AND B(10))  OR 
--		 (SF(11) AND B(11))  OR 
--		 (SF(27) AND B(12))  OR 
--       (SG(11) AND B(13))  OR 
--		 (SG(27) AND B(14))  OR
--		 (SH(11) AND B(15))  OR 
--		 (SH(27) AND B(16))  OR
--		 (SI(11) AND B(17))  OR
--		 (SI(27) AND B(18))) AND NOT SWITCH) OR
--		 (((SA(11) AND CONB(1)) OR
--		 (SA(27) AND CONB(2)) OR
--		 (SB(11) AND CONB(3)) OR
--		 (SB(27) AND CONB(4)) OR
--		 (SC(11) AND CONB(5)) OR
--		 (SC(27) AND CONB(6)) OR
-- 	 (SD(11) AND CONB(7)) OR
--		 (SD(27) AND CONB(8)) OR
--		 (SE(11) AND CONB(9)) OR
--		 (SE(27) AND CONB(10)) OR
--		 (SF(11) AND CONB(11)) OR
--		 (SF(27) AND CONB(12)) OR
--		 (SG(11) AND CONB(13)) OR
--		 (SG(27) AND CONB(14)) OR
--		 (SH(11) AND CONB(15)) OR
--		 (SH(27) AND CONB(16)) OR
--		 (SI(11) AND CONB(17)) OR
--		 (SI(27) AND CONB(18))) AND SWITCH); 

OUTB(28) <= (((SA(12)  AND B(1))  OR 
           (SA(28) AND B(2))  OR 
		 (SB(12) AND B(3))  OR 
		 (SB(28) AND B(4))  OR
		 (SC(12) AND B(5))  OR 
		 (SC(28) AND B(6))  OR 
		 (SD(12) AND B(7))  OR 
		 (SD(28) AND B(8))  OR
           (SE(12) AND B(9))  OR 
		 (SE(28) AND B(10)) OR 
		 (SF(12) AND B(11)) OR 
		 (SF(28) AND B(12)) OR 
           (SG(12) AND B(13)) OR 
		 (SG(28) AND B(14)) OR
		 (SH(12) AND B(15)) OR 
		 (SH(28) AND B(16)) OR
		 (SI(12) AND B(17)) OR
		 (SI(28) AND B(18))) AND NOT SWITCH) OR
		 (((SA(12) AND CONB(1)) OR
		 (SA(28) AND CONB(2)) OR
		 (SB(12) AND CONB(3)) OR
		 (SB(28) AND CONB(4)) OR
		 (SC(12) AND CONB(5)) OR
		 (SC(28) AND CONB(6)) OR
		 (SD(12) AND CONB(7)) OR
		 (SD(28) AND CONB(8)) OR
		 (SE(12) AND CONB(9)) OR
		 (SE(28) AND CONB(10)) OR
		 (SF(12) AND CONB(11)) OR
		 (SF(28) AND CONB(12)) OR
		 (SG(12) AND CONB(13)) OR
		 (SG(28) AND CONB(14)) OR
		 (SH(12) AND CONB(15)) OR
		 (SH(28) AND CONB(16)) OR
		 (SI(12) AND CONB(17)) OR
		 (SI(28) AND CONB(18))) AND SWITCH); 

OUTB(29) <= (((SA(13)  AND B(1))  OR 
           (SA(29) AND B(2))  OR 
		 (SB(13) AND B(3))  OR 
		 (SB(29) AND B(4))  OR
		 (SC(13) AND B(5))  OR 
		 (SC(29) AND B(6))  OR 
		 (SD(13) AND B(7))  OR 
		 (SD(29) AND B(8))  OR
           (SE(13) AND B(9))  OR 
		 (SE(29) AND B(10)) OR 
		 (SF(13) AND B(11)) OR 
		 (SF(29) AND B(12)) OR 
           (SG(13) AND B(13)) OR 
		 (SG(29) AND B(14)) OR
		 (SH(13) AND B(15)) OR 
		 (SH(29) AND B(16)) OR
		 (SI(13) AND B(17)) OR
		 (SI(29) AND B(18))) AND NOT SWITCH) OR
		 (((SA(13) AND CONB(1)) OR
		 (SA(29) AND CONB(2)) OR
		 (SB(13) AND CONB(3)) OR
		 (SB(29) AND CONB(4)) OR
		 (SC(13) AND CONB(5)) OR
		 (SC(29) AND CONB(6)) OR
		 (SD(13) AND CONB(7)) OR
		 (SD(29) AND CONB(8)) OR
		 (SE(13) AND CONB(9)) OR
		 (SE(29) AND CONB(10)) OR
		 (SF(13) AND CONB(11)) OR
		 (SF(29) AND CONB(12)) OR
		 (SG(13) AND CONB(13)) OR
		 (SG(29) AND CONB(14)) OR
		 (SH(13) AND CONB(15)) OR
		 (SH(29) AND CONB(16)) OR
		 (SI(13) AND CONB(17)) OR
		 (SI(29) AND CONB(18))) AND SWITCH); 

OUTB(30) <= (((SA(14)  AND B(1))  OR 
           (SA(30) AND B(2))  OR 
		 (SB(14) AND B(3))  OR 
		 (SB(30) AND B(4))  OR
		 (SC(14) AND B(5))  OR 
		 (SC(30) AND B(6))  OR 
		 (SD(14) AND B(7))  OR 
		 (SD(30) AND B(8))  OR
           (SE(14) AND B(9))  OR 
		 (SE(30) AND B(10)) OR 
		 (SF(14) AND B(11)) OR 
		 (SF(30) AND B(12)) OR 
           (SG(14) AND B(13)) OR 
		 (SG(30) AND B(14)) OR
		 (SH(14) AND B(15)) OR 
		 (SH(30) AND B(16)) OR
		 (SI(14) AND B(17)) OR
		 (SI(30) AND B(18))) AND NOT SWITCH) OR
		 (((SA(14) AND CONB(1)) OR
		 (SA(30) AND CONB(2)) OR
		 (SB(14) AND CONB(3)) OR
		 (SB(30) AND CONB(4)) OR
		 (SC(14) AND CONB(5)) OR
		 (SC(30) AND CONB(6)) OR
		 (SD(14) AND CONB(7)) OR
		 (SD(30) AND CONB(8)) OR
		 (SE(14) AND CONB(9)) OR
		 (SE(30) AND CONB(10)) OR
		 (SF(14) AND CONB(11)) OR
		 (SF(30) AND CONB(12)) OR
		 (SG(14) AND CONB(13)) OR
		 (SG(30) AND CONB(14)) OR
		 (SH(14) AND CONB(15)) OR
		 (SH(30) AND CONB(16)) OR
		 (SI(14) AND CONB(17)) OR
		 (SI(30) AND CONB(18))) AND SWITCH); 

OUTB(31) <= (((SA(15)  AND B(1))  OR 
           (SA(31) AND B(2))  OR 
		 (SB(15) AND B(3))  OR 
		 (SB(31) AND B(4))  OR
		 (SC(15) AND B(5))  OR 
		 (SC(31) AND B(6))  OR 
		 (SD(15) AND B(7))  OR 
		 (SD(31) AND B(8))  OR
           (SE(15) AND B(9))  OR 
		 (SE(31) AND B(10)) OR 
		 (SF(15) AND B(11)) OR 
		 (SF(31) AND B(12)) OR 
           (SG(15) AND B(13)) OR 
		 (SG(31) AND B(14)) OR
		 (SH(15) AND B(15)) OR 
		 (SH(31) AND B(16)) OR
		 (SI(15) AND B(17)) OR
		 (SI(31) AND B(18))) AND NOT SWITCH) OR
		 (((SA(15) AND CONB(1)) OR
		 (SA(31) AND CONB(2)) OR
		 (SB(15) AND CONB(3)) OR
		 (SB(31) AND CONB(4)) OR
		 (SC(15) AND CONB(5)) OR
		 (SC(31) AND CONB(6)) OR
		 (SD(15) AND CONB(7)) OR
		 (SD(31) AND CONB(8)) OR
		 (SE(15) AND CONB(9)) OR
		 (SE(31) AND CONB(10)) OR
		 (SF(15) AND CONB(11)) OR
		 (SF(31) AND CONB(12)) OR
		 (SG(15) AND CONB(13)) OR
		 (SG(31) AND CONB(14)) OR
		 (SH(15) AND CONB(15)) OR
		 (SH(31) AND CONB(16)) OR
		 (SI(15) AND CONB(17)) OR
		 (SI(31) AND CONB(18))) AND SWITCH); 

-- THIRD BEST 

OUTC(0) <= (((FA(0)  AND C(1))  OR 
           (FA(16) AND C(2))  OR 
		 (FB(0)  AND C(3))  OR 
		 (FB(16) AND C(4))  OR
		 (FC(0)  AND C(5))  OR 
		 (FC(16) AND C(6))  OR 
		 (FD(0)  AND C(7))  OR 
		 (FD(16) AND C(8))  OR
           (FE(0)  AND C(9))  OR 
		 (FE(16) AND C(10)) OR 
		 (FF(0)  AND C(11)) OR 
		 (FF(16) AND C(12)) OR 
           (FG(0)  AND C(13)) OR 
		 (FG(16) AND C(14)) OR
		 (FH(0)  AND C(15)) OR 
		 (FH(16) AND C(16)) OR
		 (FI(0)  AND C(17)) OR
		 (FI(16) AND C(18))) AND NOT SWITCH) OR
		 (((FA(0) AND CONC(1)) OR
		 (FA(16) AND CONC(2)) OR
		 (FB(0) AND CONC(3)) OR
		 (FB(16) AND CONC(4)) OR
		 (FC(0) AND CONC(5)) OR
		 (FC(16) AND CONC(6)) OR
		 (FD(0) AND CONC(7)) OR
		 (FD(16) AND CONC(8)) OR
		 (FE(0) AND CONC(9)) OR
		 (FE(16) AND CONC(10)) OR
		 (FF(0) AND CONC(11)) OR
		 (FF(16) AND CONC(12)) OR
		 (FG(0) AND CONC(13)) OR
		 (FG(16) AND CONC(14)) OR
		 (FH(0) AND CONC(15)) OR
		 (FH(16) AND CONC(16)) OR
		 (FI(0) AND CONC(17)) OR
		 (FI(16) AND CONC(18))) AND SWITCH); 

OUTC(1) <= (((FA(1)  AND C(1))  OR 
           (FA(17) AND C(2))  OR 
		 (FB(1)  AND C(3))  OR 
		 (FB(17) AND C(4))  OR
		 (FC(1)  AND C(5))  OR 
		 (FC(17) AND C(6))  OR 
		 (FD(1)  AND C(7))  OR 
		 (FD(17) AND C(8))  OR
           (FE(1)  AND C(9))  OR 
		 (FE(17) AND C(10)) OR 
		 (FF(1)  AND C(11)) OR 
		 (FF(17) AND C(12)) OR 
           (FG(1)  AND C(13)) OR 
		 (FG(17) AND C(14)) OR
		 (FH(1)  AND C(15)) OR 
		 (FH(17) AND C(16)) OR
		 (FI(1)  AND C(17)) OR
		 (FI(17) AND C(18))) AND NOT SWITCH) OR
		 (((FA(1) AND CONC(1)) OR
		 (FA(17) AND CONC(2)) OR
		 (FB(1) AND CONC(3)) OR
		 (FB(17) AND CONC(4)) OR
		 (FC(1) AND CONC(5)) OR
		 (FC(17) AND CONC(6)) OR
		 (FD(1) AND CONC(7)) OR
		 (FD(17) AND CONC(8)) OR
		 (FE(1) AND CONC(9)) OR
		 (FE(17) AND CONC(10)) OR
		 (FF(1) AND CONC(11)) OR
		 (FF(17) AND CONC(12)) OR
		 (FG(1) AND CONC(13)) OR
		 (FG(17) AND CONC(14)) OR
		 (FH(1) AND CONC(15)) OR
		 (FH(17) AND CONC(16)) OR
		 (FI(1) AND CONC(17)) OR
		 (FI(17) AND CONC(18))) AND SWITCH); 

OUTC(2) <= (((FA(2)  AND C(1))  OR 
           (FA(18) AND C(2))  OR 
		 (FB(2)  AND C(3))  OR 
		 (FB(18) AND C(4))  OR
		 (FC(2)  AND C(5))  OR 
		 (FC(18) AND C(6))  OR 
		 (FD(2)  AND C(7))  OR 
		 (FD(18) AND C(8))  OR
           (FE(2)  AND C(9))  OR 
		 (FE(18) AND C(10)) OR 
		 (FF(2)  AND C(11)) OR 
		 (FF(18) AND C(12)) OR 
           (FG(2)  AND C(13)) OR 
		 (FG(18) AND C(14)) OR
		 (FH(2)  AND C(15)) OR 
		 (FH(18) AND C(16)) OR
		 (FI(2)  AND C(17)) OR
		 (FI(18) AND C(18))) AND NOT SWITCH) OR
		 (((FA(2) AND CONC(1)) OR
		 (FA(18) AND CONC(2)) OR
		 (FB(2) AND CONC(3)) OR
		 (FB(18) AND CONC(4)) OR
		 (FC(2) AND CONC(5)) OR
		 (FC(18) AND CONC(6)) OR
		 (FD(2) AND CONC(7)) OR
		 (FD(18) AND CONC(8)) OR
		 (FE(2) AND CONC(9)) OR
		 (FE(18) AND CONC(10)) OR
		 (FF(2) AND CONC(11)) OR
		 (FF(18) AND CONC(12)) OR
		 (FG(2) AND CONC(13)) OR
		 (FG(18) AND CONC(14)) OR
		 (FH(2) AND CONC(15)) OR
		 (FH(18) AND CONC(16)) OR
		 (FI(2) AND CONC(17)) OR
		 (FI(18) AND CONC(18))) AND SWITCH); 

OUTC(3) <= (((FA(3)  AND C(1))  OR 
           (FA(19) AND C(2))  OR 
		 (FB(3)  AND C(3))  OR 
		 (FB(19) AND C(4))  OR
		 (FC(3)  AND C(5))  OR 
		 (FC(19) AND C(6))  OR 
		 (FD(3)  AND C(7))  OR 
		 (FD(19) AND C(8))  OR
           (FE(3)  AND C(9))  OR 
		 (FE(19) AND C(10)) OR 
		 (FF(3)  AND C(11)) OR 
		 (FF(19) AND C(12)) OR 
           (FG(3)  AND C(13)) OR 
		 (FG(19) AND C(14)) OR
		 (FH(3)  AND C(15)) OR 
		 (FH(19) AND C(16)) OR
		 (FI(3)  AND C(17)) OR
		 (FI(19) AND C(18))) AND NOT SWITCH) OR
		 (((FA(3) AND CONC(1)) OR
		 (FA(19) AND CONC(2)) OR
		 (FB(3) AND CONC(3)) OR
		 (FB(19) AND CONC(4)) OR
		 (FC(3) AND CONC(5)) OR
		 (FC(19) AND CONC(6)) OR
		 (FD(3) AND CONC(7)) OR
		 (FD(19) AND CONC(8)) OR
		 (FE(3) AND CONC(9)) OR
		 (FE(19) AND CONC(10)) OR
		 (FF(3) AND CONC(11)) OR
		 (FF(19) AND CONC(12)) OR
		 (FG(3) AND CONC(13)) OR
		 (FG(19) AND CONC(14)) OR
		 (FH(3) AND CONC(15)) OR
		 (FH(19) AND CONC(16)) OR
		 (FI(3) AND CONC(17)) OR
		 (FI(19) AND CONC(18))) AND SWITCH); 

OUTC(4) <= (((FA(4)  AND C(1))  OR 
           (FA(20) AND C(2))  OR 
		 (FB(4)  AND C(3))  OR 
		 (FB(20) AND C(4))  OR
		 (FC(4)  AND C(5))  OR 
		 (FC(20) AND C(6))  OR 
		 (FD(4)  AND C(7))  OR 
		 (FD(20) AND C(8))  OR
           (FE(4)  AND C(9))  OR 
		 (FE(20) AND C(10)) OR 
		 (FF(4)  AND C(11)) OR 
		 (FF(20) AND C(12)) OR 
           (FG(4)  AND C(13)) OR 
		 (FG(20) AND C(14)) OR
		 (FH(4)  AND C(15)) OR 
		 (FH(20) AND C(16)) OR
		 (FI(4)  AND C(17)) OR
		 (FI(20) AND C(18))) AND NOT SWITCH) OR
		 (((FA(4) AND CONC(1)) OR
		 (FA(20) AND CONC(2)) OR
		 (FB(4) AND CONC(3)) OR
		 (FB(20) AND CONC(4)) OR
		 (FC(4) AND CONC(5)) OR
		 (FC(20) AND CONC(6)) OR
		 (FD(4) AND CONC(7)) OR
		 (FD(20) AND CONC(8)) OR
		 (FE(4) AND CONC(9)) OR
		 (FE(20) AND CONC(10)) OR
		 (FF(4) AND CONC(11)) OR
		 (FF(20) AND CONC(12)) OR
		 (FG(4) AND CONC(13)) OR
		 (FG(20) AND CONC(14)) OR
		 (FH(4) AND CONC(15)) OR
		 (FH(20) AND CONC(16)) OR
		 (FI(4) AND CONC(17)) OR
		 (FI(20) AND CONC(18))) AND SWITCH); 

OUTC(5) <= (((FA(5)  AND C(1))  OR 
           (FA(21) AND C(2))  OR 
		 (FB(5)  AND C(3))  OR 
		 (FB(21) AND C(4))  OR
		 (FC(5)  AND C(5))  OR 
		 (FC(21) AND C(6))  OR 
		 (FD(5)  AND C(7))  OR 
		 (FD(21) AND C(8))  OR
           (FE(5)  AND C(9))  OR 
		 (FE(21) AND C(10)) OR 
		 (FF(5)  AND C(11)) OR 
		 (FF(21) AND C(12)) OR 
           (FG(5)  AND C(13)) OR 
		 (FG(21) AND C(14)) OR
		 (FH(5)  AND C(15)) OR 
		 (FH(21) AND C(16)) OR
		 (FI(5)  AND C(17)) OR
		 (FI(21) AND C(18))) AND NOT SWITCH) OR
		 (((FA(5) AND CONC(1)) OR
		 (FA(21) AND CONC(2)) OR
		 (FB(5) AND CONC(3)) OR
		 (FB(21) AND CONC(4)) OR
		 (FC(5) AND CONC(5)) OR
		 (FC(21) AND CONC(6)) OR
		 (FD(5) AND CONC(7)) OR
		 (FD(21) AND CONC(8)) OR
		 (FE(5) AND CONC(9)) OR
		 (FE(21) AND CONC(10)) OR
		 (FF(5) AND CONC(11)) OR
		 (FF(21) AND CONC(12)) OR
		 (FG(5) AND CONC(13)) OR
		 (FG(21) AND CONC(14)) OR
		 (FH(5) AND CONC(15)) OR
		 (FH(21) AND CONC(16)) OR
		 (FI(5) AND CONC(17)) OR
		 (FI(21) AND CONC(18))) AND SWITCH); 

OUTC(6) <= (((FA(6)  AND C(1))  OR 
           (FA(22) AND C(2))  OR 
		 (FB(6)  AND C(3))  OR 
		 (FB(22) AND C(4))  OR
		 (FC(6)  AND C(5))  OR 
		 (FC(22) AND C(6))  OR 
		 (FD(6)  AND C(7))  OR 
		 (FD(22) AND C(8))  OR
           (FE(6)  AND C(9))  OR 
		 (FE(22) AND C(10)) OR 
		 (FF(6)  AND C(11)) OR 
		 (FF(22) AND C(12)) OR 
           (FG(6)  AND C(13)) OR 
		 (FG(22) AND C(14)) OR
		 (FH(6)  AND C(15)) OR 
		 (FH(22) AND C(16)) OR
		 (FI(6)  AND C(17)) OR
		 (FI(22) AND C(18))) AND NOT SWITCH) OR
		 (((FA(6) AND CONC(1)) OR
		 (FA(22) AND CONC(2)) OR
		 (FB(6) AND CONC(3)) OR
		 (FB(22) AND CONC(4)) OR
		 (FC(6) AND CONC(5)) OR
		 (FC(22) AND CONC(6)) OR
		 (FD(6) AND CONC(7)) OR
		 (FD(22) AND CONC(8)) OR
		 (FE(6) AND CONC(9)) OR
		 (FE(22) AND CONC(10)) OR
		 (FF(6) AND CONC(11)) OR
		 (FF(22) AND CONC(12)) OR
		 (FG(6) AND CONC(13)) OR
		 (FG(22) AND CONC(14)) OR
		 (FH(6) AND CONC(15)) OR
		 (FH(22) AND CONC(16)) OR
		 (FI(6) AND CONC(17)) OR
		 (FI(22) AND CONC(18))) AND SWITCH); 

OUTC(7) <= (((FA(7)  AND C(1))  OR 
           (FA(23) AND C(2))  OR 
		 (FB(7)  AND C(3))  OR 
		 (FB(23) AND C(4))  OR
		 (FC(7)  AND C(5))  OR 
		 (FC(23) AND C(6))  OR 
		 (FD(7)  AND C(7))  OR 
		 (FD(23) AND C(8))  OR
           (FE(7)  AND C(9))  OR 
		 (FE(23) AND C(10)) OR 
		 (FF(7)  AND C(11)) OR 
		 (FF(23) AND C(12)) OR 
           (FG(7)  AND C(13)) OR 
		 (FG(23) AND C(14)) OR
		 (FH(7)  AND C(15)) OR 
		 (FH(23) AND C(16)) OR
		 (FI(7)  AND C(17)) OR
		 (FI(23) AND C(18))) AND NOT SWITCH) OR
		 (((FA(7) AND CONC(1)) OR
		 (FA(23) AND CONC(2)) OR
		 (FB(7) AND CONC(3)) OR
		 (FB(23) AND CONC(4)) OR
		 (FC(7) AND CONC(5)) OR
		 (FC(23) AND CONC(6)) OR
		 (FD(7) AND CONC(7)) OR
		 (FD(23) AND CONC(8)) OR
		 (FE(7) AND CONC(9)) OR
		 (FE(23) AND CONC(10)) OR
		 (FF(7) AND CONC(11)) OR
		 (FF(23) AND CONC(12)) OR
		 (FG(7) AND CONC(13)) OR
		 (FG(23) AND CONC(14)) OR
		 (FH(7) AND CONC(15)) OR
		 (FH(23) AND CONC(16)) OR
		 (FI(7) AND CONC(17)) OR
		 (FI(23) AND CONC(18))) AND SWITCH); 

OUTC(8) <= (((FA(8)  AND C(1))  OR 
           (FA(24) AND C(2))  OR 
		 (FB(8)  AND C(3))  OR 
		 (FB(24) AND C(4))  OR
		 (FC(8)  AND C(5))  OR 
		 (FC(24) AND C(6))  OR 
		 (FD(8)  AND C(7))  OR 
		 (FD(24) AND C(8))  OR
           (FE(8)  AND C(9))  OR 
		 (FE(24) AND C(10)) OR 
		 (FF(8)  AND C(11)) OR 
		 (FF(24) AND C(12)) OR 
           (FG(8)  AND C(13)) OR 
		 (FG(24) AND C(14)) OR
		 (FH(8)  AND C(15)) OR 
		 (FH(24) AND C(16)) OR
		 (FI(8)  AND C(17)) OR
		 (FI(24) AND C(18))) AND NOT SWITCH) OR
		 (((FA(8) AND CONC(1)) OR
		 (FA(24) AND CONC(2)) OR
		 (FB(8) AND CONC(3)) OR
		 (FB(24) AND CONC(4)) OR
		 (FC(8) AND CONC(5)) OR
		 (FC(24) AND CONC(6)) OR
		 (FD(8) AND CONC(7)) OR
		 (FD(24) AND CONC(8)) OR
		 (FE(8) AND CONC(9)) OR
		 (FE(24) AND CONC(10)) OR
		 (FF(8) AND CONC(11)) OR
		 (FF(24) AND CONC(12)) OR
		 (FG(8) AND CONC(13)) OR
		 (FG(24) AND CONC(14)) OR
		 (FH(8) AND CONC(15)) OR
		 (FH(24) AND CONC(16)) OR
		 (FI(8) AND CONC(17)) OR
		 (FI(24) AND CONC(18))) AND SWITCH); 

OUTC(9) <= (((FA(9)  AND C(1))  OR 
           (FA(25) AND C(2))  OR 
		 (FB(9)  AND C(3))  OR 
		 (FB(25) AND C(4))  OR
		 (FC(9)  AND C(5))  OR 
		 (FC(25) AND C(6))  OR 
		 (FD(9)  AND C(7))  OR 
		 (FD(25) AND C(8))  OR
           (FE(9)  AND C(9))  OR 
		 (FE(25) AND C(10)) OR 
		 (FF(9)  AND C(11)) OR 
		 (FF(25) AND C(12)) OR 
           (FG(9)  AND C(13)) OR 
		 (FG(25) AND C(14)) OR
		 (FH(9)  AND C(15)) OR 
		 (FH(25) AND C(16)) OR
		 (FI(9)  AND C(17)) OR
		 (FI(25) AND C(18))) AND NOT SWITCH) OR
		 (((FA(9) AND CONC(1)) OR
		 (FA(25) AND CONC(2)) OR
		 (FB(9) AND CONC(3)) OR
		 (FB(25) AND CONC(4)) OR
		 (FC(9) AND CONC(5)) OR
		 (FC(25) AND CONC(6)) OR
		 (FD(9) AND CONC(7)) OR
		 (FD(25) AND CONC(8)) OR
		 (FE(9) AND CONC(9)) OR
		 (FE(25) AND CONC(10)) OR
		 (FF(9) AND CONC(11)) OR
		 (FF(25) AND CONC(12)) OR
		 (FG(9) AND CONC(13)) OR
		 (FG(25) AND CONC(14)) OR
		 (FH(9) AND CONC(15)) OR
		 (FH(25) AND CONC(16)) OR
		 (FI(9) AND CONC(17)) OR
		 (FI(25) AND CONC(18))) AND SWITCH); 

OUTC(10) <= (((FA(10)  AND C(1))  OR 
           (FA(26) AND C(2))  OR 
		 (FB(10) AND C(3))  OR 
		 (FB(26) AND C(4))  OR
		 (FC(10) AND C(5))  OR 
		 (FC(26) AND C(6))  OR 
		 (FD(10) AND C(7))  OR 
		 (FD(26) AND C(8))  OR
           (FE(10) AND C(9))  OR 
		 (FE(26) AND C(10)) OR 
		 (FF(10) AND C(11)) OR 
		 (FF(26) AND C(12)) OR 
           (FG(10) AND C(13)) OR 
		 (FG(26) AND C(14)) OR
		 (FH(10) AND C(15)) OR 
		 (FH(26) AND C(16)) OR
		 (FI(10) AND C(17)) OR
		 (FI(26) AND C(18))) AND NOT SWITCH) OR
		 (((FA(10) AND CONC(1)) OR
		 (FA(26) AND CONC(2)) OR
		 (FB(10) AND CONC(3)) OR
		 (FB(26) AND CONC(4)) OR
		 (FC(10) AND CONC(5)) OR
		 (FC(26) AND CONC(6)) OR
		 (FD(10) AND CONC(7)) OR
		 (FD(26) AND CONC(8)) OR
		 (FE(10) AND CONC(9)) OR
		 (FE(26) AND CONC(10)) OR
		 (FF(10) AND CONC(11)) OR
		 (FF(26) AND CONC(12)) OR
		 (FG(10) AND CONC(13)) OR
		 (FG(26) AND CONC(14)) OR
		 (FH(10) AND CONC(15)) OR
		 (FH(26) AND CONC(16)) OR
		 (FI(10) AND CONC(17)) OR
		 (FI(26) AND CONC(18))) AND SWITCH); 

OUTC(11) <= (((FA(11)  AND C(1))  OR 
           (FA(27) AND C(2))  OR 
		 (FB(11) AND C(3))  OR 
		 (FB(27) AND C(4))  OR
		 (FC(11) AND C(5))  OR 
		 (FC(27) AND C(6))  OR 
		 (FD(11) AND C(7))  OR 
		 (FD(27) AND C(8))  OR
           (FE(11) AND C(9))  OR 
		 (FE(27) AND C(10)) OR 
		 (FF(11) AND C(11)) OR 
		 (FF(27) AND C(12)) OR 
           (FG(11) AND C(13)) OR 
		 (FG(27) AND C(14)) OR
		 (FH(11) AND C(15)) OR 
		 (FH(27) AND C(16)) OR
		 (FI(11) AND C(17)) OR
		 (FI(27) AND C(18))) AND NOT SWITCH) OR
		 (((FA(11) AND CONC(1)) OR
		 (FA(27) AND CONC(2)) OR
		 (FB(11) AND CONC(3)) OR
		 (FB(27) AND CONC(4)) OR
		 (FC(11) AND CONC(5)) OR
		 (FC(27) AND CONC(6)) OR
		 (FD(11) AND CONC(7)) OR
		 (FD(27) AND CONC(8)) OR
		 (FE(11) AND CONC(9)) OR
		 (FE(27) AND CONC(10)) OR
		 (FF(11) AND CONC(11)) OR
		 (FF(27) AND CONC(12)) OR
		 (FG(11) AND CONC(13)) OR
		 (FG(27) AND CONC(14)) OR
		 (FH(11) AND CONC(15)) OR
		 (FH(27) AND CONC(16)) OR
		 (FI(11) AND CONC(17)) OR
		 (FI(27) AND CONC(18))) AND SWITCH); 

OUTC(12) <= (((FA(12) AND C(1))  OR 
           (FA(28) AND C(2))  OR 
		 (FB(12) AND C(3))  OR 
		 (FB(28) AND C(4))  OR
		 (FC(12) AND C(5))  OR 
		 (FC(28) AND C(6))  OR 
		 (FD(12) AND C(7))  OR 
		 (FD(28) AND C(8))  OR
           (FE(12) AND C(9))  OR 
		 (FE(28) AND C(10)) OR 
		 (FF(12) AND C(11)) OR 
		 (FF(28) AND C(12)) OR 
           (FG(12) AND C(13)) OR 
		 (FG(28) AND C(14)) OR
		 (FH(12) AND C(15)) OR 
		 (FH(28) AND C(16)) OR
		 (FI(12) AND C(17)) OR
		 (FI(28) AND C(18))) AND NOT SWITCH) OR
		 (((FA(12) AND CONC(1)) OR
		 (FA(28) AND CONC(2)) OR
		 (FB(12) AND CONC(3)) OR
		 (FB(28) AND CONC(4)) OR
		 (FC(12) AND CONC(5)) OR
		 (FC(28) AND CONC(6)) OR
		 (FD(12) AND CONC(7)) OR
		 (FD(28) AND CONC(8)) OR
		 (FE(12) AND CONC(9)) OR
		 (FE(28) AND CONC(10)) OR
		 (FF(12) AND CONC(11)) OR
		 (FF(28) AND CONC(12)) OR
		 (FG(12) AND CONC(13)) OR
		 (FG(28) AND CONC(14)) OR
		 (FH(12) AND CONC(15)) OR
		 (FH(28) AND CONC(16)) OR
		 (FI(12) AND CONC(17)) OR
		 (FI(28) AND CONC(18))) AND SWITCH); 

OUTC(13) <= (((FA(13) AND C(1))  OR 
           (FA(29) AND C(2))  OR 
		 (FB(13) AND C(3))  OR 
		 (FB(29) AND C(4))  OR
		 (FC(13) AND C(5))  OR 
		 (FC(29) AND C(6))  OR 
		 (FD(13) AND C(7))  OR 
		 (FD(29) AND C(8))  OR
           (FE(13) AND C(9))  OR 
		 (FE(29) AND C(10)) OR 
		 (FF(13) AND C(11)) OR 
		 (FF(29) AND C(12)) OR 
           (FG(13) AND C(13)) OR 
		 (FG(29) AND C(14)) OR
		 (FH(13) AND C(15)) OR 
		 (FH(29) AND C(16)) OR
		 (FI(13) AND C(17)) OR
		 (FI(29) AND C(18))) AND NOT SWITCH) OR
		 (((FA(13) AND CONC(1)) OR
		 (FA(29) AND CONC(2)) OR
		 (FB(13) AND CONC(3)) OR
		 (FB(29) AND CONC(4)) OR
		 (FC(13) AND CONC(5)) OR
		 (FC(29) AND CONC(6)) OR
		 (FD(13) AND CONC(7)) OR
		 (FD(29) AND CONC(8)) OR
		 (FE(13) AND CONC(9)) OR
		 (FE(29) AND CONC(10)) OR
		 (FF(13) AND CONC(11)) OR
		 (FF(29) AND CONC(12)) OR
		 (FG(13) AND CONC(13)) OR
		 (FG(29) AND CONC(14)) OR
		 (FH(13) AND CONC(15)) OR
		 (FH(29) AND CONC(16)) OR
		 (FI(13) AND CONC(17)) OR
		 (FI(29) AND CONC(18))) AND SWITCH); 

OUTC(14) <= (((FA(14) AND C(1))  OR 
           (FA(30) AND C(2))  OR 
		 (FB(14) AND C(3))  OR 
		 (FB(30) AND C(4))  OR
		 (FC(14) AND C(5))  OR 
		 (FC(30) AND C(6))  OR 
		 (FD(14) AND C(7))  OR 
		 (FD(30) AND C(8))  OR
           (FE(14) AND C(9))  OR 
		 (FE(30) AND C(10)) OR 
		 (FF(14) AND C(11)) OR 
		 (FF(30) AND C(12)) OR 
           (FG(14) AND C(13)) OR 
		 (FG(30) AND C(14)) OR
		 (FH(14) AND C(15)) OR 
		 (FH(30) AND C(16)) OR
		 (FI(14) AND C(17)) OR
		 (FI(30) AND C(18))) AND NOT SWITCH) OR
		 (((FA(14) AND CONC(1)) OR
		 (FA(30) AND CONC(2)) OR
		 (FB(14) AND CONC(3)) OR
		 (FB(30) AND CONC(4)) OR
		 (FC(14) AND CONC(5)) OR
		 (FC(30) AND CONC(6)) OR
		 (FD(14) AND CONC(7)) OR
		 (FD(30) AND CONC(8)) OR
		 (FE(14) AND CONC(9)) OR
		 (FE(30) AND CONC(10)) OR
		 (FF(14) AND CONC(11)) OR
		 (FF(30) AND CONC(12)) OR
		 (FG(14) AND CONC(13)) OR
		 (FG(30) AND CONC(14)) OR
		 (FH(14) AND CONC(15)) OR
		 (FH(30) AND CONC(16)) OR
		 (FI(14) AND CONC(17)) OR
		 (FI(30) AND CONC(18))) AND SWITCH); 

OUTC(15) <= (((FA(15) AND C(1))  OR 
           (FA(31) AND C(2))  OR 
		 (FB(15) AND C(3))  OR 
		 (FB(31) AND C(4))  OR
		 (FC(15) AND C(5))  OR 
		 (FC(31) AND C(6))  OR 
		 (FD(15) AND C(7))  OR 
		 (FD(31) AND C(8))  OR
           (FE(15) AND C(9))  OR 
		 (FE(31) AND C(10)) OR 
		 (FF(15) AND C(11)) OR 
		 (FF(31) AND C(12)) OR 
           (FG(15) AND C(13)) OR 
		 (FG(31) AND C(14)) OR
		 (FH(15) AND C(15)) OR 
		 (FH(31) AND C(16)) OR
		 (FI(15) AND C(17)) OR
		 (FI(31) AND C(18))) AND NOT SWITCH) OR
		 (((FA(15) AND CONC(1)) OR
		 (FA(31) AND CONC(2)) OR
		 (FB(15) AND CONC(3)) OR
		 (FB(31) AND CONC(4)) OR
		 (FC(15) AND CONC(5)) OR
		 (FC(31) AND CONC(6)) OR
		 (FD(15) AND CONC(7)) OR
		 (FD(31) AND CONC(8)) OR
		 (FE(15) AND CONC(9)) OR
		 (FE(31) AND CONC(10)) OR
		 (FF(15) AND CONC(11)) OR
		 (FF(31) AND CONC(12)) OR
		 (FG(15) AND CONC(13)) OR
		 (FG(31) AND CONC(14)) OR
		 (FH(15) AND CONC(15)) OR
		 (FH(31) AND CONC(16)) OR
		 (FI(15) AND CONC(17)) OR
		 (FI(31) AND CONC(18))) AND SWITCH); 

OUTC(16) <= (((SA(0) AND C(1))  OR 
           (SA(16) AND C(2))  OR 
		 (SB(0)  AND C(3))  OR 
		 (SB(16) AND C(4))  OR
		 (SC(0)  AND C(5))  OR 
		 (SC(16) AND C(6))  OR 
		 (SD(0)  AND C(7))  OR 
		 (SD(16) AND C(8))  OR
           (SE(0)  AND C(9))  OR 
		 (SE(16) AND C(10)) OR 
		 (SF(0)  AND C(11)) OR 
		 (SF(16) AND C(12)) OR 
           (SG(0)  AND C(13)) OR 
		 (SG(16) AND C(14)) OR
		 (SH(0)  AND C(15)) OR 
		 (SH(16) AND C(16)) OR
		 (SI(0)  AND C(17)) OR
		 (SI(16) AND C(18))) AND NOT SWITCH) OR
		 (((SA(0) AND CONC(1)) OR
		 (SA(16) AND CONC(2)) OR
		 (SB(0) AND CONC(3)) OR
		 (SB(16) AND CONC(4)) OR
		 (SC(0) AND CONC(5)) OR
		 (SC(16) AND CONC(6)) OR
		 (SD(0) AND CONC(7)) OR
		 (SD(16) AND CONC(8)) OR
		 (SE(0) AND CONC(9)) OR
		 (SE(16) AND CONC(10)) OR
		 (SF(0) AND CONC(11)) OR
		 (SF(16) AND CONC(12)) OR
		 (SG(0) AND CONC(13)) OR
		 (SG(16) AND CONC(14)) OR
		 (SH(0) AND CONC(15)) OR
		 (SH(16) AND CONC(16)) OR
		 (SI(0) AND CONC(17)) OR
		 (SI(16) AND CONC(18))) AND SWITCH); 

OUTC(17) <= (((SA(1)  AND C(1))  OR 
           (SA(17) AND C(2))  OR 
		 (SB(1)  AND C(3))  OR 
		 (SB(17) AND C(4))  OR
		 (SC(1)  AND C(5))  OR 
		 (SC(17) AND C(6))  OR 
		 (SD(1)  AND C(7))  OR 
		 (SD(17) AND C(8))  OR
           (SE(1)  AND C(9))  OR 
		 (SE(17) AND C(10)) OR 
		 (SF(1)  AND C(11)) OR 
		 (SF(17) AND C(12)) OR 
           (SG(1)  AND C(13)) OR 
		 (SG(17) AND C(14)) OR
		 (SH(1)  AND C(15)) OR 
		 (SH(17) AND C(16)) OR
		 (SI(1)  AND C(17)) OR
		 (SI(17) AND C(18))) AND NOT SWITCH) OR
		 (((SA(1) AND CONC(1)) OR
		 (SA(17) AND CONC(2)) OR
		 (SB(1) AND CONC(3)) OR
		 (SB(17) AND CONC(4)) OR
		 (SC(1) AND CONC(5)) OR
		 (SC(17) AND CONC(6)) OR
		 (SD(1) AND CONC(7)) OR
		 (SD(17) AND CONC(8)) OR
		 (SE(1) AND CONC(9)) OR
		 (SE(17) AND CONC(10)) OR
		 (SF(1) AND CONC(11)) OR
		 (SF(17) AND CONC(12)) OR
		 (SG(1) AND CONC(13)) OR
		 (SG(17) AND CONC(14)) OR
		 (SH(1) AND CONC(15)) OR
		 (SH(17) AND CONC(16)) OR
		 (SI(1) AND CONC(17)) OR
		 (SI(17) AND CONC(18))) AND SWITCH); 

OUTC(18) <= (((SA(2)  AND C(1))  OR 
           (SA(18) AND C(2))  OR 
		 (SB(2)  AND C(3))  OR 
		 (SB(18) AND C(4))  OR
		 (SC(2)  AND C(5))  OR 
		 (SC(18) AND C(6))  OR 
		 (SD(2)  AND C(7))  OR 
		 (SD(18) AND C(8))  OR
           (SE(2)  AND C(9))  OR 
		 (SE(18) AND C(10)) OR 
		 (SF(2)  AND C(11)) OR 
		 (SF(18) AND C(12)) OR 
           (SG(2)  AND C(13)) OR 
		 (SG(18) AND C(14)) OR
		 (SH(2)  AND C(15)) OR 
		 (SH(18) AND C(16)) OR
		 (SI(2)  AND C(17)) OR
		 (SI(18) AND C(18))) AND NOT SWITCH) OR
		 (((SA(2) AND CONC(1)) OR
		 (SA(18) AND CONC(2)) OR
		 (SB(2) AND CONC(3)) OR
		 (SB(18) AND CONC(4)) OR
		 (SC(2) AND CONC(5)) OR
		 (SC(18) AND CONC(6)) OR
		 (SD(2) AND CONC(7)) OR
		 (SD(18) AND CONC(8)) OR
		 (SE(2) AND CONC(9)) OR
		 (SE(18) AND CONC(10)) OR
		 (SF(2) AND CONC(11)) OR
		 (SF(18) AND CONC(12)) OR
		 (SG(2) AND CONC(13)) OR
		 (SG(18) AND CONC(14)) OR
		 (SH(2) AND CONC(15)) OR
		 (SH(18) AND CONC(16)) OR
		 (SI(2) AND CONC(17)) OR
		 (SI(18) AND CONC(18))) AND SWITCH); 

OUTC(19) <= (((SA(3)  AND C(1))  OR 
           (SA(19) AND C(2))  OR 
		 (SB(3)  AND C(3))  OR 
		 (SB(19) AND C(4))  OR
		 (SC(3)  AND C(5))  OR 
		 (SC(19) AND C(6))  OR 
		 (SD(3)  AND C(7))  OR 
		 (SD(19) AND C(8))  OR
           (SE(3)  AND C(9))  OR 
		 (SE(19) AND C(10)) OR 
		 (SF(3)  AND C(11)) OR 
		 (SF(19) AND C(12)) OR 
           (SG(3)  AND C(13)) OR 
		 (SG(19) AND C(14)) OR
		 (SH(3)  AND C(15)) OR 
		 (SH(19) AND C(16)) OR
		 (SI(3)  AND C(17)) OR
		 (SI(19) AND C(18))) AND NOT SWITCH) OR
		 (((SA(3) AND CONC(1)) OR
		 (SA(19) AND CONC(2)) OR
		 (SB(3) AND CONC(3)) OR
		 (SB(19) AND CONC(4)) OR
		 (SC(3) AND CONC(5)) OR
		 (SC(19) AND CONC(6)) OR
		 (SD(3) AND CONC(7)) OR
		 (SD(19) AND CONC(8)) OR
		 (SE(3) AND CONC(9)) OR
		 (SE(19) AND CONC(10)) OR
		 (SF(3) AND CONC(11)) OR
		 (SF(19) AND CONC(12)) OR
		 (SG(3) AND CONC(13)) OR
		 (SG(19) AND CONC(14)) OR
		 (SH(3) AND CONC(15)) OR
		 (SH(19) AND CONC(16)) OR
		 (SI(3) AND CONC(17)) OR
		 (SI(19) AND CONC(18))) AND SWITCH); 


OUTC(20) <= (((SA(4)  AND C(1))  OR 
           (SA(20) AND C(2))  OR 
		 (SB(4)  AND C(3))  OR 
		 (SB(20) AND C(4))  OR
		 (SC(4)  AND C(5))  OR 
		 (SC(20) AND C(6))  OR 
		 (SD(4)  AND C(7))  OR 
		 (SD(20) AND C(8))  OR
           (SE(4)  AND C(9))  OR 
		 (SE(20) AND C(10)) OR 
		 (SF(4)  AND C(11)) OR 
		 (SF(20) AND C(12)) OR 
           (SG(4)  AND C(13)) OR 
		 (SG(20) AND C(14)) OR
		 (SH(4)  AND C(15)) OR 
		 (SH(20) AND C(16)) OR
		 (SI(4)  AND C(17)) OR
		 (SI(20) AND C(18))) AND NOT SWITCH) OR
		 (((SA(4) AND CONC(1)) OR
		 (SA(20) AND CONC(2)) OR
		 (SB(4) AND CONC(3)) OR
		 (SB(20) AND CONC(4)) OR
		 (SC(4) AND CONC(5)) OR
		 (SC(20) AND CONC(6)) OR
		 (SD(4) AND CONC(7)) OR
		 (SD(20) AND CONC(8)) OR
		 (SE(4) AND CONC(9)) OR
		 (SE(20) AND CONC(10)) OR
		 (SF(4) AND CONC(11)) OR
		 (SF(20) AND CONC(12)) OR
		 (SG(4) AND CONC(13)) OR
		 (SG(20) AND CONC(14)) OR
		 (SH(4) AND CONC(15)) OR
		 (SH(20) AND CONC(16)) OR
		 (SI(4) AND CONC(17)) OR
		 (SI(20) AND CONC(18))) AND SWITCH); 

OUTC(21) <= (((SA(5)  AND C(1))  OR 
           (SA(21) AND C(2))  OR 
		 (SB(5)  AND C(3))  OR 
		 (SB(21) AND C(4))  OR
		 (SC(5)  AND C(5))  OR 
		 (SC(21) AND C(6))  OR 
		 (SD(5)  AND C(7))  OR 
		 (SD(21) AND C(8))  OR
           (SE(5)  AND C(9))  OR 
		 (SE(21) AND C(10)) OR 
		 (SF(5)  AND C(11)) OR 
		 (SF(21) AND C(12)) OR 
           (SG(5)  AND C(13)) OR 
		 (SG(21) AND C(14)) OR
		 (SH(5)  AND C(15)) OR 
		 (SH(21) AND C(16)) OR
		 (SI(5)  AND C(17)) OR
		 (SI(21) AND C(18))) AND NOT SWITCH) OR
		 (((SA(5) AND CONC(1)) OR
		 (SA(21) AND CONC(2)) OR
		 (SB(5) AND CONC(3)) OR
		 (SB(21) AND CONC(4)) OR
		 (SC(5) AND CONC(5)) OR
		 (SC(21) AND CONC(6)) OR
		 (SD(5) AND CONC(7)) OR
		 (SD(21) AND CONC(8)) OR
		 (SE(5) AND CONC(9)) OR
		 (SE(21) AND CONC(10)) OR
		 (SF(5) AND CONC(11)) OR
		 (SF(21) AND CONC(12)) OR
		 (SG(5) AND CONC(13)) OR
		 (SG(21) AND CONC(14)) OR
		 (SH(5) AND CONC(15)) OR
		 (SH(21) AND CONC(16)) OR
		 (SI(5) AND CONC(17)) OR
		 (SI(21) AND CONC(18))) AND SWITCH); 

OUTC(22) <= (((SA(6)  AND C(1))  OR 
           (SA(22) AND C(2))  OR 
		 (SB(6)  AND C(3))  OR 
		 (SB(22) AND C(4))  OR
		 (SC(6)  AND C(5))  OR 
		 (SC(22) AND C(6))  OR 
		 (SD(6)  AND C(7))  OR 
		 (SD(22) AND C(8))  OR
           (SE(6)  AND C(9))  OR 
		 (SE(22) AND C(10)) OR 
		 (SF(6)  AND C(11)) OR 
		 (SF(22) AND C(12)) OR 
           (SG(6)  AND C(13)) OR 
		 (SG(22) AND C(14)) OR
		 (SH(6)  AND C(15)) OR 
		 (SH(22) AND C(16)) OR
		 (SI(6)  AND C(17)) OR
		 (SI(22) AND C(18))) AND NOT SWITCH) OR
		 (((SA(6) AND CONC(1)) OR
		 (SA(22) AND CONC(2)) OR
		 (SB(6) AND CONC(3)) OR
		 (SB(22) AND CONC(4)) OR
		 (SC(6) AND CONC(5)) OR
		 (SC(22) AND CONC(6)) OR
		 (SD(6) AND CONC(7)) OR
		 (SD(22) AND CONC(8)) OR
		 (SE(6) AND CONC(9)) OR
		 (SE(22) AND CONC(10)) OR
		 (SF(6) AND CONC(11)) OR
		 (SF(22) AND CONC(12)) OR
		 (SG(6) AND CONC(13)) OR
		 (SG(22) AND CONC(14)) OR
		 (SH(6) AND CONC(15)) OR
		 (SH(22) AND CONC(16)) OR
		 (SI(6) AND CONC(17)) OR
		 (SI(22) AND CONC(18))) AND SWITCH); 

OUTC(23) <= (((SA(7)  AND C(1))  OR 
           (SA(23) AND C(2))  OR 
		 (SB(7)  AND C(3))  OR 
		 (SB(23) AND C(4))  OR
		 (SC(7)  AND C(5))  OR 
		 (SC(23) AND C(6))  OR 
		 (SD(7)  AND C(7))  OR 
		 (SD(23) AND C(8))  OR
           (SE(7)  AND C(9))  OR 
		 (SE(23) AND C(10)) OR 
		 (SF(7)  AND C(11)) OR 
		 (SF(23) AND C(12)) OR 
           (SG(7)  AND C(13)) OR 
		 (SG(23) AND C(14)) OR
		 (SH(7)  AND C(15)) OR 
		 (SH(23) AND C(16)) OR
		 (SI(7)  AND C(17)) OR
		 (SI(23) AND C(18))) AND NOT SWITCH) OR
		 (((SA(7) AND CONC(1)) OR
		 (SA(23) AND CONC(2)) OR
		 (SB(7) AND CONC(3)) OR
		 (SB(23) AND CONC(4)) OR
		 (SC(7) AND CONC(5)) OR
		 (SC(23) AND CONC(6)) OR
		 (SD(7) AND CONC(7)) OR
		 (SD(23) AND CONC(8)) OR
		 (SE(7) AND CONC(9)) OR
		 (SE(23) AND CONC(10)) OR
		 (SF(7) AND CONC(11)) OR
		 (SF(23) AND CONC(12)) OR
		 (SG(7) AND CONC(13)) OR
		 (SG(23) AND CONC(14)) OR
		 (SH(7) AND CONC(15)) OR
		 (SH(23) AND CONC(16)) OR
		 (SI(7) AND CONC(17)) OR
		 (SI(23) AND CONC(18))) AND SWITCH); 

OUTC(24) <= (((SA(8)  AND C(1))  OR 
           (SA(24) AND C(2))  OR 
		 (SB(8)  AND C(3))  OR 
		 (SB(24) AND C(4))  OR
		 (SC(8)  AND C(5))  OR 
		 (SC(24) AND C(6))  OR 
		 (SD(8)  AND C(7))  OR 
		 (SD(24) AND C(8))  OR
           (SE(8)  AND C(9))  OR 
		 (SE(24) AND C(10)) OR 
		 (SF(8)  AND C(11)) OR 
		 (SF(24) AND C(12)) OR 
           (SG(8)  AND C(13)) OR 
		 (SG(24) AND C(14)) OR
		 (SH(8)  AND C(15)) OR 
		 (SH(24) AND C(16)) OR
		 (SI(8)  AND C(17)) OR
		 (SI(24) AND C(18))) AND NOT SWITCH) OR
		 (((SA(8) AND CONC(1)) OR
		 (SA(24) AND CONC(2)) OR
		 (SB(8) AND CONC(3)) OR
		 (SB(24) AND CONC(4)) OR
		 (SC(8) AND CONC(5)) OR
		 (SC(24) AND CONC(6)) OR
		 (SD(8) AND CONC(7)) OR
		 (SD(24) AND CONC(8)) OR
		 (SE(8) AND CONC(9)) OR
		 (SE(24) AND CONC(10)) OR
		 (SF(8) AND CONC(11)) OR
		 (SF(24) AND CONC(12)) OR
		 (SG(8) AND CONC(13)) OR
		 (SG(24) AND CONC(14)) OR
		 (SH(8) AND CONC(15)) OR
		 (SH(24) AND CONC(16)) OR
		 (SI(8) AND CONC(17)) OR
		 (SI(24) AND CONC(18))) AND SWITCH); 

OUTC(25) <= (((SA(9)  AND C(1))  OR 
           (SA(25) AND C(2))  OR 
		 (SB(9)  AND C(3))  OR 
		 (SB(25) AND C(4))  OR
		 (SC(9)  AND C(5))  OR 
		 (SC(25) AND C(6))  OR 
		 (SD(9)  AND C(7))  OR 
		 (SD(25) AND C(8))  OR
           (SE(9)  AND C(9))  OR 
		 (SE(25) AND C(10)) OR 
		 (SF(9)  AND C(11)) OR 
		 (SF(25) AND C(12)) OR 
           (SG(9)  AND C(13)) OR 
		 (SG(25) AND C(14)) OR
		 (SH(9)  AND C(15)) OR 
		 (SH(25) AND C(16)) OR
		 (SI(9)  AND C(17)) OR
		 (SI(25) AND C(18))) AND NOT SWITCH) OR
		 (((SA(9) AND CONC(1)) OR
		 (SA(25) AND CONC(2)) OR
		 (SB(9) AND CONC(3)) OR
		 (SB(25) AND CONC(4)) OR
		 (SC(9) AND CONC(5)) OR
		 (SC(25) AND CONC(6)) OR
		 (SD(9) AND CONC(7)) OR
		 (SD(25) AND CONC(8)) OR
		 (SE(9) AND CONC(9)) OR
		 (SE(25) AND CONC(10)) OR
		 (SF(9) AND CONC(11)) OR
		 (SF(25) AND CONC(12)) OR
		 (SG(9) AND CONC(13)) OR
		 (SG(25) AND CONC(14)) OR
		 (SH(9) AND CONC(15)) OR
		 (SH(25) AND CONC(16)) OR
		 (SI(9) AND CONC(17)) OR
		 (SI(25) AND CONC(18))) AND SWITCH); 

OUTC(26) <= (((SA(10)  AND C(1))  OR 
           (SA(26) AND C(2))  OR 
		 (SB(10) AND C(3))  OR 
		 (SB(26) AND C(4))  OR
		 (SC(10) AND C(5))  OR 
		 (SC(26) AND C(6))  OR 
		 (SD(10) AND C(7))  OR 
		 (SD(26) AND C(8))  OR
           (SE(10) AND C(9))  OR 
		 (SE(26) AND C(10)) OR 
		 (SF(10) AND C(11)) OR 
		 (SF(26) AND C(12)) OR 
           (SG(10) AND C(13)) OR 
		 (SG(26) AND C(14)) OR
		 (SH(10) AND C(15)) OR 
		 (SH(26) AND C(16)) OR
		 (SI(10) AND C(17)) OR
		 (SI(26) AND C(18))) AND NOT SWITCH) OR
		 (((SA(10) AND CONC(1)) OR
		 (SA(26) AND CONC(2)) OR
		 (SB(10) AND CONC(3)) OR
		 (SB(26) AND CONC(4)) OR
		 (SC(10) AND CONC(5)) OR
		 (SC(26) AND CONC(6)) OR
		 (SD(10) AND CONC(7)) OR
		 (SD(26) AND CONC(8)) OR
		 (SE(10) AND CONC(9)) OR
		 (SE(26) AND CONC(10)) OR
		 (SF(10) AND CONC(11)) OR
		 (SF(26) AND CONC(12)) OR
		 (SG(10) AND CONC(13)) OR
		 (SG(26) AND CONC(14)) OR
		 (SH(10) AND CONC(15)) OR
		 (SH(26) AND CONC(16)) OR
		 (SI(10) AND CONC(17)) OR
		 (SI(26) AND CONC(18))) AND SWITCH); 

OUTC(27) <= ((SA(11)  OR 
       SA(27)   OR 
		 SB(11)   OR 
		 SB(27)   OR
		 SC(11)   OR 
		 SC(27)   OR 
		 SD(11)   OR 
		 SD(27)   OR
       SE(11)   OR 
		 SE(27)   OR 
		 SF(11)   OR 
		 SF(27)   OR 
       SG(11)   OR 
		 SG(27)   OR
		 SH(11)   OR 
		 SH(27)   OR
		 SI(11)   OR
		 SI(27))  AND NOT SWITCH) OR
		 (((SA(11) AND CONC(1)) OR
		 (SA(27) AND CONC(2)) OR
		 (SB(11) AND CONC(3)) OR
		 (SB(27) AND CONC(4)) OR
		 (SC(11) AND CONC(5)) OR
		 (SC(27) AND CONC(6)) OR
		 (SD(11) AND CONC(7)) OR
		 (SD(27) AND CONC(8)) OR
		 (SE(11) AND CONC(9)) OR
		 (SE(27) AND CONC(10)) OR
   	 (SF(11) AND CONC(11)) OR
		 (SF(27) AND CONC(12)) OR
		 (SG(11) AND CONC(13)) OR
		 (SG(27) AND CONC(14)) OR
		 (SH(11) AND CONC(15)) OR
		 (SH(27) AND CONC(16)) OR
		 (SI(11) AND CONC(17)) OR
		 (SI(27) AND CONC(18))) AND SWITCH); 

--OUTC(27) <= (((SA(11) AND C(1)) OR 
--       (SA(27) AND C(2))   OR 
--		 (SB(11) AND C(3))   OR 
--		 (SB(27) AND C(4))   OR
--		 (SC(11) AND C(5))   OR 
--		 (SC(27) AND C(6))   OR 
--		 (SD(11) AND C(7))  OR 
--		 (SD(27) AND C(8))  OR
--      (SE(11) AND C(9))  OR 
--		 (SE(27) AND C(10))  OR 
--		 (SF(11) AND C(11))  OR 
--		 (SF(27) AND C(12))  OR 
--      (SG(11) AND C(13))  OR 
--		 (SG(27) AND C(14))  OR
--		 (SH(11) AND C(15))  OR 
--		 (SH(27) AND C(16))  OR
--		 (SI(11) AND C(17))  OR
--		 (SI(27) AND C(18))) AND NOT SWITCH) OR
--		 (((SA(11) AND CONC(1)) OR
--		 (SA(27) AND CONC(2)) OR
--		 (SB(11) AND CONC(3)) OR
--		 (SB(27) AND CONC(4)) OR
--		 (SC(11) AND CONC(5)) OR
--		 (SC(27) AND CONC(6)) OR
--		 (SD(11) AND CONC(7)) OR
--		 (SD(27) AND CONC(8)) OR
--		 (SE(11) AND CONC(9)) OR
--		 (SE(27) AND CONC(10)) OR
--		 (SF(11) AND CONC(11)) OR
--		 (SF(27) AND CONC(12)) OR
--		 (SG(11) AND CONC(13)) OR
--		 (SG(27) AND CONC(14)) OR
--		 (SH(11) AND CONC(15)) OR
--		 (SH(27) AND CONC(16)) OR
--		 (SI(11) AND CONC(17)) OR
--		 (SI(27) AND CONC(18))) AND SWITCH); 

OUTC(28) <= (((SA(12)  AND C(1))  OR 
           (SA(28) AND C(2))  OR 
		 (SB(12) AND C(3))  OR 
		 (SB(28) AND C(4))  OR
		 (SC(12) AND C(5))  OR 
		 (SC(28) AND C(6))  OR 
		 (SD(12) AND C(7))  OR 
		 (SD(28) AND C(8))  OR
           (SE(12) AND C(9))  OR 
		 (SE(28) AND C(10)) OR 
		 (SF(12) AND C(11)) OR 
		 (SF(28) AND C(12)) OR 
           (SG(12) AND C(13)) OR 
		 (SG(28) AND C(14)) OR
		 (SH(12) AND C(15)) OR 
		 (SH(28) AND C(16)) OR
		 (SI(12) AND C(17)) OR
		 (SI(28) AND C(18))) AND NOT SWITCH) OR
		 (((SA(12) AND CONC(1)) OR
		 (SA(28) AND CONC(2)) OR
		 (SB(12) AND CONC(3)) OR
		 (SB(28) AND CONC(4)) OR
		 (SC(12) AND CONC(5)) OR
		 (SC(28) AND CONC(6)) OR
		 (SD(12) AND CONC(7)) OR
		 (SD(28) AND CONC(8)) OR
		 (SE(12) AND CONC(9)) OR
		 (SE(28) AND CONC(10)) OR
		 (SF(12) AND CONC(11)) OR
		 (SF(28) AND CONC(12)) OR
		 (SG(12) AND CONC(13)) OR
		 (SG(28) AND CONC(14)) OR
		 (SH(12) AND CONC(15)) OR
		 (SH(28) AND CONC(16)) OR
		 (SI(12) AND CONC(17)) OR
		 (SI(28) AND CONC(18))) AND SWITCH); 

OUTC(29) <= (((SA(13)  AND C(1))  OR 
           (SA(29) AND C(2))  OR 
		 (SB(13) AND C(3))  OR 
		 (SB(29) AND C(4))  OR
		 (SC(13) AND C(5))  OR 
		 (SC(29) AND C(6))  OR 
		 (SD(13) AND C(7))  OR 
		 (SD(29) AND C(8))  OR
           (SE(13) AND C(9))  OR 
		 (SE(29) AND C(10)) OR 
		 (SF(13) AND C(11)) OR 
		 (SF(29) AND C(12)) OR 
           (SG(13) AND C(13)) OR 
		 (SG(29) AND C(14)) OR
		 (SH(13) AND C(15)) OR 
		 (SH(29) AND C(16)) OR
		 (SI(13) AND C(17)) OR
		 (SI(29) AND C(18))) AND NOT SWITCH) OR
		 (((SA(13) AND CONC(1)) OR
		 (SA(29) AND CONC(2)) OR
		 (SB(13) AND CONC(3)) OR
		 (SB(29) AND CONC(4)) OR
		 (SC(13) AND CONC(5)) OR
		 (SC(29) AND CONC(6)) OR
		 (SD(13) AND CONC(7)) OR
		 (SD(29) AND CONC(8)) OR
		 (SE(13) AND CONC(9)) OR
		 (SE(29) AND CONC(10)) OR
		 (SF(13) AND CONC(11)) OR
		 (SF(29) AND CONC(12)) OR
		 (SG(13) AND CONC(13)) OR
		 (SG(29) AND CONC(14)) OR
		 (SH(13) AND CONC(15)) OR
		 (SH(29) AND CONC(16)) OR
		 (SI(13) AND CONC(17)) OR
		 (SI(29) AND CONC(18))) AND SWITCH); 

OUTC(30) <= (((SA(14)  AND C(1))  OR 
           (SA(30) AND C(2))  OR 
		 (SB(14) AND C(3))  OR 
		 (SB(30) AND C(4))  OR
		 (SC(14) AND C(5))  OR 
		 (SC(30) AND C(6))  OR 
		 (SD(14) AND C(7))  OR 
		 (SD(30) AND C(8))  OR
           (SE(14) AND C(9))  OR 
		 (SE(30) AND C(10)) OR 
		 (SF(14) AND C(11)) OR 
		 (SF(30) AND C(12)) OR 
           (SG(14) AND C(13)) OR 
		 (SG(30) AND C(14)) OR
		 (SH(14) AND C(15)) OR 
		 (SH(30) AND C(16)) OR
		 (SI(14) AND C(17)) OR
		 (SI(30) AND C(18))) AND NOT SWITCH) OR
		 (((SA(14) AND CONC(1)) OR
		 (SA(30) AND CONC(2)) OR
		 (SB(14) AND CONC(3)) OR
		 (SB(30) AND CONC(4)) OR
		 (SC(14) AND CONC(5)) OR
		 (SC(30) AND CONC(6)) OR
		 (SD(14) AND CONC(7)) OR
		 (SD(30) AND CONC(8)) OR
		 (SE(14) AND CONC(9)) OR
		 (SE(30) AND CONC(10)) OR
		 (SF(14) AND CONC(11)) OR
		 (SF(30) AND CONC(12)) OR
		 (SG(14) AND CONC(13)) OR
		 (SG(30) AND CONC(14)) OR
		 (SH(14) AND CONC(15)) OR
		 (SH(30) AND CONC(16)) OR
		 (SI(14) AND CONC(17)) OR
		 (SI(30) AND CONC(18))) AND SWITCH); 

OUTC(31) <= (((SA(15)  AND C(1))  OR 
           (SA(31) AND C(2))  OR 
		 (SB(15) AND C(3))  OR 
		 (SB(31) AND C(4))  OR
		 (SC(15) AND C(5))  OR 
		 (SC(31) AND C(6))  OR 
		 (SD(15) AND C(7))  OR 
		 (SD(31) AND C(8))  OR
           (SE(15) AND C(9))  OR 
		 (SE(31) AND C(10)) OR 
		 (SF(15) AND C(11)) OR 
		 (SF(31) AND C(12)) OR 
           (SG(15) AND C(13)) OR 
		 (SG(31) AND C(14)) OR
		 (SH(15) AND C(15)) OR 
		 (SH(31) AND C(16)) OR
		 (SI(15) AND C(17)) OR
		 (SI(31) AND C(18))) AND NOT SWITCH) OR
		 (((SA(15) AND CONC(1)) OR
		 (SA(31) AND CONC(2)) OR
		 (SB(15) AND CONC(3)) OR
		 (SB(31) AND CONC(4)) OR
		 (SC(15) AND CONC(5)) OR
		 (SC(31) AND CONC(6)) OR
		 (SD(15) AND CONC(7)) OR
		 (SD(31) AND CONC(8)) OR
		 (SE(15) AND CONC(9)) OR
		 (SE(31) AND CONC(10)) OR
		 (SF(15) AND CONC(11)) OR
		 (SF(31) AND CONC(12)) OR
		 (SG(15) AND CONC(13)) OR
		 (SG(31) AND CONC(14)) OR
		 (SH(15) AND CONC(15)) OR
		 (SH(31) AND CONC(16)) OR
		 (SI(15) AND CONC(17)) OR
		 (SI(31) AND CONC(18))) AND SWITCH); 

end ARC;
