library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity sorter is
    Port ( INPUTA : in std_logic_vector(4 downto 1);
           INPUTB : in std_logic_vector(4 downto 1);
           INPUTC : in std_logic_vector(4 downto 1);
           INPUTD : in std_logic_vector(4 downto 1);
           INPUTE : in std_logic_vector(4 downto 1);
           INPUTF : in std_logic_vector(4 downto 1);
           INPUTG : in std_logic_vector(4 downto 1);
           INPUTH : in std_logic_vector(4 downto 1);
           INPUTI : in std_logic_vector(4 downto 1);
           INPUTJ : in std_logic_vector(4 downto 1);
           INPUTK : in std_logic_vector(4 downto 1);
           INPUTL : in std_logic_vector(4 downto 1);
           INPUTM : in std_logic_vector(4 downto 1);
           INPUTN : in std_logic_vector(4 downto 1);
           INPUTP : in std_logic_vector(4 downto 1);
           INPUTQ : in std_logic_vector(4 downto 1);
           INPUTR : in std_logic_vector(4 downto 1);
           INPUTS : in std_logic_vector(4 downto 1);
           CLK1: in std_logic;
           OUTPUTA : out std_logic_vector(18 downto 1);
           OUTPUTB : out std_logic_vector(18 downto 1);
           OUTPUTC : out std_logic_vector(18 downto 1));
--           RESETI   : in std_logic;
--           CLKDBL   : out std_logic);

end sorter;

architecture structural  of sorter is

--component DLL_standard is
 --   port (CLKIN : in  std_logic;
 --         RESET : in  std_logic;
 --         CLKOUT1 : out std_logic;
 --         CLKOUT2 : out std_logic;
 --         CLK2   : out std_logic);
 --         LOCKED: out std_logic);
--end component;

component DFF4 
    Port ( DIN : in std_logic_vector(4 downto 1);
           QOUT : out std_logic_vector(4 downto 1);
           CLK : in std_logic);
end component;

component COMP153 
    Port ( INA : in std_logic_vector(4 downto 1);
           INB : in std_logic_vector(4 downto 1);
           INC : in std_logic_vector(4 downto 1);
           IND : in std_logic_vector(4 downto 1);
           INE : in std_logic_vector(4 downto 1);
           INF : in std_logic_vector(4 downto 1);
           ING : in std_logic_vector(4 downto 1);
           INH : in std_logic_vector(4 downto 1);
           INI : in std_logic_vector(4 downto 1);
           INJ : in std_logic_vector(4 downto 1);
           INK : in std_logic_vector(4 downto 1);
           INL : in std_logic_vector(4 downto 1);
           INM : in std_logic_vector(4 downto 1);
           INN : in std_logic_vector(4 downto 1);
           INP : in std_logic_vector(4 downto 1);
           INQ : in std_logic_vector(4 downto 1);
           INR : in std_logic_vector(4 downto 1);
           INS : in std_logic_vector(4 downto 1);
           ZERO : out std_logic_vector(18 downto 1);
           OUTA : out std_logic_vector(153 downto 1));
end component;

component SELECT1 
    Port ( INPUT  : in std_logic_vector(153 downto 1);
           ZERO   : in std_logic_vector(18 downto 1);      
           OUTPUT : out std_logic_vector(18 downto 1));
end component;

component SELECT2 
    Port ( IINPUT : in std_logic_vector(153 downto 1);
           ZZERO  : in std_logic_vector(18 downto 1);
           INPUTT : in std_logic_vector(18 downto 1);
           OUTPUTT : out std_logic_vector(18 downto 1));
end component;

component SELECT3 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZZZERO  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
           OUTPUTTT : out std_logic_vector(18 downto 1));
end component;

component DFF18 
    Port ( DIN : in std_logic_vector(18 downto 1);
           CLK: in std_logic;
           QOUT : out std_logic_vector(18 downto 1));
end component;

component DFF153 
    Port ( DIN : in std_logic_vector(153 downto 1);
           CLK: in std_logic;
           QOUT : out std_logic_vector(153 downto 1));
end component;

--SIGNAL INPUA :  std_logic_vector(4 downto 1);
--SIGNAL INPUB :  std_logic_vector(4 downto 1);
--SIGNAL INPUC :  std_logic_vector(4 downto 1);
--SIGNAL INPUD :  std_logic_vector(4 downto 1);
--SIGNAL INPUE :  std_logic_vector(4 downto 1);
--SIGNAL INPUF :  std_logic_vector(4 downto 1);
--SIGNAL INPUG :  std_logic_vector(4 downto 1);
--SIGNAL INPUH :  std_logic_vector(4 downto 1);
--SIGNAL INPUI :  std_logic_vector(4 downto 1);
--SIGNAL INPUJ :  std_logic_vector(4 downto 1);
--SIGNAL INPUK :  std_logic_vector(4 downto 1);
--SIGNAL INPUL :  std_logic_vector(4 downto 1);
--SIGNAL INPUM :  std_logic_vector(4 downto 1);
--SIGNAL INPUN :  std_logic_vector(4 downto 1);
--SIGNAL INPUP :  std_logic_vector(4 downto 1);
--SIGNAL INPUQ :  std_logic_vector(4 downto 1);
--SIGNAL INPUR :  std_logic_vector(4 downto 1);
--SIGNAL INPUS :  std_logic_vector(4 downto 1);
SIGNAL TEMA  :  std_logic_vector(153 downto 1);
SIGNAL AOUT  :  std_logic_vector(18 downto 1);
SIGNAL BOUT  :  std_logic_vector(18 downto 1);
SIGNAL COUT  :  std_logic_vector(18 downto 1);
SIGNAL ZEROA :  std_logic_vector(18 downto 1);
SIGNAL TEMAD  :  std_logic_vector(153 downto 1);
SIGNAL AOUTD  :  std_logic_vector(18 downto 1);
SIGNAL ZEROAD :  std_logic_vector(18 downto 1);

--SIGNAL CLKA  : std_logic;
--SIGNAL CLKB  : std_logic;
--SIGNAL logic0 : std_logic;


BEGIN

--logic0 <= '0';

--U1:  DFF4
--PORT MAP (DIN => INPUTA, QOUT => INPUA, CLK => CLK1);
--U2:  DFF4
--PORT MAP (DIN => INPUTB, QOUT => INPUB, CLK => CLK1);
--U3:  DFF4
--PORT MAP (DIN => INPUTC, QOUT => INPUC, CLK => CLK1);
--U4:  DFF4
--PORT MAP (DIN => INPUTD, QOUT => INPUD, CLK => CLK1);
--U5:  DFF4
--PORT MAP (DIN => INPUTE, QOUT => INPUE, CLK => CLK1);
--U6:  DFF4
--PORT MAP (DIN => INPUTF, QOUT => INPUF, CLK => CLK1);
--U7:  DFF4
--PORT MAP (DIN => INPUTG, QOUT => INPUG, CLK => CLK1);
--U8:  DFF4
--PORT MAP (DIN => INPUTH, QOUT => INPUH, CLK => CLK1);
--U9:  DFF4
--PORT MAP (DIN => INPUTI, QOUT => INPUI, CLK => CLK1);
--U10:  DFF4
--PORT MAP (DIN => INPUTJ, QOUT => INPUJ, CLK => CLK1);
--U11:  DFF4
--PORT MAP (DIN => INPUTK, QOUT => INPUK, CLK => CLK1);
--U12:  DFF4
--PORT MAP (DIN => INPUTL, QOUT => INPUL, CLK => CLK1);
--U13:  DFF4
--PORT MAP (DIN => INPUTM, QOUT => INPUM, CLK => CLK1);
--U14:  DFF4
--PORT MAP (DIN => INPUTN, QOUT => INPUN, CLK => CLK1);
--U15:  DFF4
--PORT MAP (DIN => INPUTP, QOUT => INPUP, CLK => CLK1);
--U16:  DFF4
--PORT MAP (DIN => INPUTQ, QOUT => INPUQ, CLK => CLK1);
--U17:  DFF4
--PORT MAP (DIN => INPUTR, QOUT => INPUR, CLK => CLK1);
--U18:  DFF4
--PORT MAP (DIN => INPUTS, QOUT => INPUS, CLK => CLK1);

U19: COMP153
PORT MAP (INA => INPUTA, INB => INPUTB, INC => INPUTC,
          IND => INPUTD, INE => INPUTE, INF => INPUTF,
          ING => INPUTG, INH => INPUTH, INI => INPUTI,
          INJ => INPUTJ, INK => INPUTK, INL => INPUTL,
          INM => INPUTM, INN => INPUTN, INP => INPUTP,
          INQ => INPUTQ, INR => INPUTR, INS => INPUTS,
          ZERO => ZEROA, OUTA => TEMA);

U20: SELECT1
PORT MAP (INPUT => TEMAD, ZERO => ZEROAD, OUTPUT => AOUT);

U21: DFF153
PORT MAP (DIN => TEMA, QOUT => TEMAD, CLK => CLK1);

U22: DFF18
PORT MAP (DIN => ZEROA, QOUT => ZEROAD, CLK => CLK1);

--U23: DFF18
--PORT MAP (DIN => AOUT, QOUT => AOUTD, CLK => CLK1);

U24: SELECT2
PORT MAP (IINPUT => TEMAD, INPUTT => AOUT, OUTPUTT => BOUT, ZZERO => ZEROAD);

U25: SELECT3
PORT MAP (IIINPUT => TEMAD, INPUTTA => AOUT, INPUTTT => BOUT, ZZZERO => ZEROAD, OUTPUTTT => COUT);

U26: DFF18
PORT MAP (DIN => AOUT, QOUT => OUTPUTA, CLK => CLK1);

U27: DFF18
PORT MAP (DIN => BOUT, QOUT => OUTPUTB, CLK => CLK1);

U28: DFF18
PORT MAP (DIN => COUT, QOUT => OUTPUTC, CLK => CLK1);

--U29: DLL_standard
--PORT MAP (CLKIN => CLK1, RESET => RESETI, CLKOUT1 => CLKA,
--          CLKOUT2 => CLKB, CLK2 => CLKDBL, LOCKED => open);

end structural;
