library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity sorter is
    Port ( FFA : in std_logic_vector(31 downto 0);
           FFB : in std_logic_vector(31 downto 0);
           FFC : in std_logic_vector(31 downto 0);
           FFD : in std_logic_vector(31 downto 0);
           FFE : in std_logic_vector(31 downto 0);
           FFF : in std_logic_vector(31 downto 0);
           FFG : in std_logic_vector(31 downto 0);
           FFH : in std_logic_vector(31 downto 0);
           FFI : in std_logic_vector(31 downto 0);

           SFA : in std_logic_vector(31 downto 0);
           SFB : in std_logic_vector(31 downto 0);
           SFC : in std_logic_vector(31 downto 0);
           SFD : in std_logic_vector(31 downto 0);
           SFE : in std_logic_vector(31 downto 0);
           SFF : in std_logic_vector(31 downto 0);
           SFG : in std_logic_vector(31 downto 0);
           SFH : in std_logic_vector(31 downto 0);
           SFI : in std_logic_vector(31 downto 0);
 
           CLK1: in std_logic;

           OA : out std_logic_vector(18 downto 1);
           OB : out std_logic_vector(18 downto 1);
           OC : out std_logic_vector(18 downto 1);

		 CONTRA : in std_logic_vector(18 downto 1);
		 CONTRB : in std_logic_vector(18 downto 1);
		 CONTRC : in std_logic_vector(18 downto 1);

		 MODE : in std_logic;

           FIR : out std_logic_vector(31 downto 0);
           SEC : out std_logic_vector(31 downto 0);
           THI : out std_logic_vector(31 downto 0));

end sorter;

architecture structural  of sorter is

component FLAG
Port (
		 FLA : in std_logic_vector(4 downto 1);
		 FLB : in std_logic_vector(4 downto 1);
		 FLC : in std_logic_vector(4 downto 1);
		 FLD : in std_logic_vector(4 downto 1);
		 FLE : in std_logic_vector(4 downto 1);
		 FLF : in std_logic_vector(4 downto 1);
		 FLG : in std_logic_vector(4 downto 1);
		 FLH : in std_logic_vector(4 downto 1);
		 FLI : in std_logic_vector(4 downto 1);
		 FLJ : in std_logic_vector(4 downto 1);
		 FLK : in std_logic_vector(4 downto 1);
		 FLL : in std_logic_vector(4 downto 1);
		 FLM : in std_logic_vector(4 downto 1);
		 FLN : in std_logic_vector(4 downto 1);
		 FLP : in std_logic_vector(4 downto 1);
		 FLQ : in std_logic_vector(4 downto 1);
		 FLR : in std_logic_vector(4 downto 1);
		 FLS : in std_logic_vector(4 downto 1);

		 FLAGA : in std_logic;
		 FLAGB : in std_logic;
		 FLAGC : in std_logic;
		 FLAGD : in std_logic;
		 FLAGE : in std_logic;
		 FLAGF : in std_logic;
		 FLAGG : in std_logic;
		 FLAGH : in std_logic;
	      FLAGI : in std_logic;
		 FLAGJ : in std_logic;
		 FLAGK : in std_logic;
		 FLAGL : in std_logic;
		 FLAGM : in std_logic;
		 FLAGN : in std_logic;
		 FLAGP : in std_logic;
		 FLAGQ : in std_logic;
		 FLAGR : in std_logic;
	      FLAGS : in std_logic;

 		 OUTA : out std_logic_vector(5 downto 1);
		 OUTB : out std_logic_vector(5 downto 1);
		 OUTC : out std_logic_vector(5 downto 1);
		 OUTD : out std_logic_vector(5 downto 1);
		 OUTE : out std_logic_vector(5 downto 1);
		 OUTF : out std_logic_vector(5 downto 1);
		 OUTG : out std_logic_vector(5 downto 1);
		 OUTH : out std_logic_vector(5 downto 1);
		 OUTI : out std_logic_vector(5 downto 1);
		 OUTJ : out std_logic_vector(5 downto 1);
		 OUTK : out std_logic_vector(5 downto 1);
		 OUTL : out std_logic_vector(5 downto 1);
		 OUTM : out std_logic_vector(5 downto 1);
		 OUTN : out std_logic_vector(5 downto 1);
		 OUTP : out std_logic_vector(5 downto 1);
		 OUTQ : out std_logic_vector(5 downto 1);
		 OUTR : out std_logic_vector(5 downto 1);
		 OUTS : out std_logic_vector(5 downto 1));

end component;

component DFF4 
    Port ( DIN : in std_logic_vector(4 downto 1);
           QOUT : out std_logic_vector(4 downto 1);
           CLK : in std_logic);
end component;

component MERGER
Port ( FA : in std_logic_vector(31 downto 0);
		 FB : in std_logic_vector(31 downto 0);
		 FC : in std_logic_vector(31 downto 0);
		 FD : in std_logic_vector(31 downto 0);
		 FE : in std_logic_vector(31 downto 0);
		 FF : in std_logic_vector(31 downto 0);
		 FG : in std_logic_vector(31 downto 0);
		 FH : in std_logic_vector(31 downto 0);
		 FI : in std_logic_vector(31 downto 0);

		 SA : in std_logic_vector(31 downto 0);
		 SB : in std_logic_vector(31 downto 0);
		 SC : in std_logic_vector(31 downto 0);
		 SD : in std_logic_vector(31 downto 0);
		 SE : in std_logic_vector(31 downto 0);
		 SF : in std_logic_vector(31 downto 0);
		 SG : in std_logic_vector(31 downto 0);
		 SH : in std_logic_vector(31 downto 0);
		 SI : in std_logic_vector(31 downto 0);

        A : in std_logic_vector(18 downto 1);
   	   B : in std_logic_vector(18 downto 1);
        C : in std_logic_vector(18 downto 1);

	   SWITCH : in std_logic;

	   CONA : in std_logic_vector(18 downto 1);
	   CONB : in std_logic_vector(18 downto 1);
	   CONC : in std_logic_vector(18 downto 1);

        OUTA : out std_logic_vector(31 downto 0);
        OUTB : out std_logic_vector(31 downto 0);
        OUTC : out std_logic_vector(31 downto 0));

		  end component;

component COMP153 
    Port ( INA : in std_logic_vector(5 downto 1);
           INB : in std_logic_vector(5 downto 1);
           INC : in std_logic_vector(5 downto 1);
           IND : in std_logic_vector(5 downto 1);
           INE : in std_logic_vector(5 downto 1);
           INF : in std_logic_vector(5 downto 1);
           ING : in std_logic_vector(5 downto 1);
           INH : in std_logic_vector(5 downto 1);
           INI : in std_logic_vector(5 downto 1);
           INJ : in std_logic_vector(5 downto 1);
           INK : in std_logic_vector(5 downto 1);
           INL : in std_logic_vector(5 downto 1);
           INM : in std_logic_vector(5 downto 1);
           INN : in std_logic_vector(5 downto 1);
           INP : in std_logic_vector(5 downto 1);
           INQ : in std_logic_vector(5 downto 1);
           INR : in std_logic_vector(5 downto 1);
           INS : in std_logic_vector(5 downto 1);
           ZERO : out std_logic_vector(18 downto 1);
           OUTA : out std_logic_vector(153 downto 1));
end component;

component SELECT1 
    Port ( INPUT  : in std_logic_vector(153 downto 1);
           ZERO   : in std_logic_vector(18 downto 1);      
           OUTPUT : out std_logic_vector(18 downto 1));
end component;

component SELECT2 
    Port ( IINPUT : in std_logic_vector(153 downto 1);
           ZZERO  : in std_logic_vector(18 downto 1);
           INPUTT : in std_logic_vector(18 downto 1);
           OUTPUTT : out std_logic_vector(18 downto 1));
end component;

component SELECT3 
    Port ( IIINPUT : in std_logic_vector(153 downto 1);
           ZZZERO  : in std_logic_vector(18 downto 1);
           INPUTTA : in std_logic_vector(18 downto 1);
           INPUTTT : in std_logic_vector(18 downto 1);
           OUTPUTTT : out std_logic_vector(18 downto 1));
end component;

component DFF18 
    Port ( DIN : in std_logic_vector(18 downto 1);
           CLK: in std_logic;
           QOUT : out std_logic_vector(18 downto 1));
end component;

component DFF32 
    Port ( DIN : in std_logic_vector(31 downto 0);
           CLK: in std_logic;
           QOUT : out std_logic_vector(31 downto 0));
end component;

component DFF153 
    Port ( DIN : in std_logic_vector(153 downto 1);
           CLK: in std_logic;
           QOUT : out std_logic_vector(153 downto 1));
end component;

SIGNAL FFAD :  std_logic_vector(31 downto 0);
SIGNAL FFBD :  std_logic_vector(31 downto 0);
SIGNAL FFCD :  std_logic_vector(31 downto 0);
SIGNAL FFDD :  std_logic_vector(31 downto 0);
SIGNAL FFED :  std_logic_vector(31 downto 0);
SIGNAL FFFD :  std_logic_vector(31 downto 0);
SIGNAL FFGD :  std_logic_vector(31 downto 0);
SIGNAL FFHD :  std_logic_vector(31 downto 0);
SIGNAL FFID :  std_logic_vector(31 downto 0);

SIGNAL SORA :  std_logic_vector(5 downto 1);
SIGNAL SORB :  std_logic_vector(5 downto 1);
SIGNAL SORC :  std_logic_vector(5 downto 1);
SIGNAL SORD :  std_logic_vector(5 downto 1);
SIGNAL SORE :  std_logic_vector(5 downto 1);
SIGNAL SORF :  std_logic_vector(5 downto 1);
SIGNAL SORG :  std_logic_vector(5 downto 1);
SIGNAL SORH :  std_logic_vector(5 downto 1);
SIGNAL SORI :  std_logic_vector(5 downto 1);
SIGNAL SORJ :  std_logic_vector(5 downto 1);
SIGNAL SORK :  std_logic_vector(5 downto 1);
SIGNAL SORL :  std_logic_vector(5 downto 1);
SIGNAL SORM :  std_logic_vector(5 downto 1);
SIGNAL SORN :  std_logic_vector(5 downto 1);
SIGNAL SORP :  std_logic_vector(5 downto 1);
SIGNAL SORQ :  std_logic_vector(5 downto 1);
SIGNAL SORR :  std_logic_vector(5 downto 1);
SIGNAL SORS :  std_logic_vector(5 downto 1);

SIGNAL TA :  std_logic_vector(31 downto 0);
SIGNAL TB :  std_logic_vector(31 downto 0);
SIGNAL TC :  std_logic_vector(31 downto 0);

SIGNAL TEMA  :  std_logic_vector(153 downto 1);
SIGNAL AOUT  :  std_logic_vector(18 downto 1);
SIGNAL BOUT  :  std_logic_vector(18 downto 1);
SIGNAL COUT  :  std_logic_vector(18 downto 1);
SIGNAL ZEROA :  std_logic_vector(18 downto 1);
SIGNAL TEMAD  :  std_logic_vector(153 downto 1);
--SIGNAL AOUTD  :  std_logic_vector(18 downto 1);
SIGNAL ZEROAD :  std_logic_vector(18 downto 1);

BEGIN

U1: FLAG
PORT MAP (FLA(4) => FFA(14), FLA(3) => FFA(13), FLA(2) => FFA(12), FLA(1) => FFA(11), FLAGA => FFA(15), OUTA => SORA,
          FLB(4) => FFA(30), FLB(3) => FFA(29), FLB(2) => FFA(28), FLB(1) => FFA(27), FLAGB => FFA(31), OUTB => SORB,
          FLC(4) => FFB(14), FLC(3) => FFB(13), FLC(2) => FFB(12), FLC(1) => FFB(11), FLAGC => FFB(15), OUTC => SORC,
          FLD(4) => FFB(30), FLD(3) => FFB(29), FLD(2) => FFB(28), FLD(1) => FFB(27), FLAGD => FFB(31), OUTD => SORD,
          FLE(4) => FFC(14), FLE(3) => FFC(13), FLE(2) => FFC(12), FLE(1) => FFC(11), FLAGE => FFC(15), OUTE => SORE,
          FLF(4) => FFC(30), FLF(3) => FFC(29), FLF(2) => FFC(28), FLF(1) => FFC(27), FLAGF => FFC(31), OUTF => SORF,
          FLG(4) => FFD(14), FLG(3) => FFD(13), FLG(2) => FFD(12), FLG(1) => FFD(11), FLAGG => FFD(15), OUTG => SORG,
          FLH(4) => FFD(30), FLH(3) => FFD(29), FLH(2) => FFD(28), FLH(1) => FFD(27), FLAGH => FFD(31), OUTH => SORH,
          FLI(4) => FFE(14), FLI(3) => FFE(13), FLI(2) => FFE(12), FLI(1) => FFE(11), FLAGI => FFE(15), OUTI => SORI,
          FLJ(4) => FFE(30), FLJ(3) => FFE(29), FLJ(2) => FFE(28), FLJ(1) => FFE(27), FLAGJ => FFE(31), OUTJ => SORJ,
          FLK(4) => FFF(14), FLK(3) => FFF(13), FLK(2) => FFF(12), FLK(1) => FFF(11), FLAGK => FFF(15), OUTK => SORK,
          FLL(4) => FFF(30), FLL(3) => FFF(29), FLL(2) => FFF(28), FLL(1) => FFF(27), FLAGL => FFF(31), OUTL => SORL,
          FLM(4) => FFG(14), FLM(3) => FFG(13), FLM(2) => FFG(12), FLM(1) => FFG(11), FLAGM => FFG(15), OUTM => SORM,
          FLN(4) => FFG(30), FLN(3) => FFG(29), FLN(2) => FFG(28), FLN(1) => FFG(27), FLAGN => FFG(31), OUTN => SORN,
          FLP(4) => FFH(14), FLP(3) => FFH(13), FLP(2) => FFH(12), FLP(1) => FFH(11), FLAGP => FFH(15), OUTP => SORP,
          FLQ(4) => FFH(30), FLQ(3) => FFH(29), FLQ(2) => FFH(28), FLQ(1) => FFH(27), FLAGQ => FFH(31), OUTQ => SORQ,
          FLR(4) => FFI(14), FLR(3) => FFI(13), FLR(2) => FFI(12), FLR(1) => FFI(11), FLAGR => FFI(15), OUTR => SORR,
          FLS(4) => FFI(30), FLS(3) => FFI(29), FLS(2) => FFI(28), FLS(1) => FFI(27), FLAGS => FFI(31), OUTS => SORS);

--U2: DFF18
--PORT MAP (DIN => AOUT, QOUT => AOUTD, CLK => CLK1);

U10: DFF32
PORT MAP (DIN => FFA, QOUT => FFAD, CLK => CLK1);

U11: DFF32
PORT MAP (DIN => FFB, QOUT => FFBD, CLK => CLK1);

U12: DFF32
PORT MAP (DIN => FFC, QOUT => FFCD, CLK => CLK1);

U13: DFF32
PORT MAP (DIN => FFD, QOUT => FFDD, CLK => CLK1);

U14: DFF32
PORT MAP (DIN => FFE, QOUT => FFED, CLK => CLK1);

U15: DFF32
PORT MAP (DIN => FFF, QOUT => FFFD, CLK => CLK1);

U16: DFF32
PORT MAP (DIN => FFG, QOUT => FFGD, CLK => CLK1);

U17: DFF32
PORT MAP (DIN => FFH, QOUT => FFHD, CLK => CLK1);

U18: DFF32
PORT MAP (DIN => FFI, QOUT => FFID, CLK => CLK1);

U19: COMP153
PORT MAP (INA => SORA, INB => SORB, INC => SORC,
          IND => SORD, INE => SORE, INF => SORF,
          ING => SORG, INH => SORH, INI => SORI,
          INJ => SORJ, INK => SORK, INL => SORL,
          INM => SORM, INN => SORN, INP => SORP,
          INQ => SORQ, INR => SORR, INS => SORS,
          ZERO => ZEROA, OUTA => TEMA);

U20: SELECT1
PORT MAP (INPUT => TEMAD, ZERO => ZEROAD, OUTPUT => AOUT);

U21: DFF153
PORT MAP (DIN => TEMA, QOUT => TEMAD, CLK => CLK1);

U22: DFF18
PORT MAP (DIN => ZEROA, QOUT => ZEROAD, CLK => CLK1);

U24: SELECT2
PORT MAP (IINPUT => TEMAD, INPUTT => AOUT, ZZERO => ZEROAD, OUTPUTT => BOUT);

U25: SELECT3
PORT MAP (IIINPUT => TEMAD, INPUTTA => AOUT, INPUTTT => BOUT, 
          ZZZERO => ZEROAD, OUTPUTTT => COUT);

U26: DFF18
PORT MAP (DIN => AOUT, QOUT => OA, CLK => CLK1);

U27: DFF18
PORT MAP (DIN => BOUT, QOUT => OB, CLK => CLK1);

U28: DFF18
PORT MAP (DIN => COUT, QOUT => OC, CLK => CLK1);

U30: MERGER
PORT MAP (FA => FFAD, FB => FFBD, FC => FFCD, FD => FFDD, 
          FE => FFED, FF => FFFD, FG => FFGD, FH => FFHD, FI => FFID,
          SA => SFA, SB => SFB, SC => SFC, SD => SFD, 
		SE => SFE, SF => SFF, SG => SFG, SH => SFH, SI => SFI,
          A => AOUT, B => BOUT, C => COUT, 
		SWITCH => MODE, CONA => CONTRA, CONB => CONTRB, CONC => CONTRC,
		OUTA => TA, OUTB => TB, OUTC => TC);

U40: DFF32
PORT MAP (DIN => TA, QOUT => FIR, CLK => CLK1);

U41: DFF32
PORT MAP (DIN => TB, QOUT => SEC, CLK => CLK1);

U42: DFF32
PORT MAP (DIN => TC, QOUT => THI, CLK => CLK1);

end structural;
